# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from floriday_supplier_client.api_client import ApiClient


class CatalogPricesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_weekly_supply_line(self, body, **kwargs):  # noqa: E501
        """supply:write - Creates a new weekly supply line for trade item.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_weekly_supply_line(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklySupplyLine body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_weekly_supply_line_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.add_weekly_supply_line_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def add_weekly_supply_line_with_http_info(self, body, **kwargs):  # noqa: E501
        """supply:write - Creates a new weekly supply line for trade item.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_weekly_supply_line_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklySupplyLine body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_weekly_supply_line" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_weekly_supply_line`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-lines', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_weekly_supply_lines(self, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Deletes a weekly supply line.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_weekly_supply_lines(supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_weekly_supply_lines_with_http_info(supply_line_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_weekly_supply_lines_with_http_info(supply_line_id, **kwargs)  # noqa: E501
            return data

    def delete_weekly_supply_lines_with_http_info(self, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Deletes a weekly supply line.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_weekly_supply_lines_with_http_info(supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['supply_line_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_weekly_supply_lines" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'supply_line_id' is set
        if ('supply_line_id' not in params or
                params['supply_line_id'] is None):
            raise ValueError("Missing the required parameter `supply_line_id` when calling `delete_weekly_supply_lines`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'supply_line_id' in params:
            path_params['supplyLineId'] = params['supply_line_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-lines/{supplyLineId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_continuous_stock(self, body, trade_item_id, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Set availabilities for a trade item  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_continuous_stock(body, trade_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ContinuousStock body: (required)
        :param str trade_item_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_continuous_stock_with_http_info(body, trade_item_id, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_continuous_stock_with_http_info(body, trade_item_id, **kwargs)  # noqa: E501
            return data

    def edit_continuous_stock_with_http_info(self, body, trade_item_id, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Set availabilities for a trade item  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_continuous_stock_with_http_info(body, trade_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param ContinuousStock body: (required)
        :param str trade_item_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'trade_item_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_continuous_stock" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_continuous_stock`")  # noqa: E501
        # verify the required parameter 'trade_item_id' is set
        if ('trade_item_id' not in params or
                params['trade_item_id'] is None):
            raise ValueError("Missing the required parameter `trade_item_id` when calling `edit_continuous_stock`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'trade_item_id' in params:
            path_params['tradeItemId'] = params['trade_item_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/{tradeItemId}/continuous-stock', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_weekly_base_supply(self, body, trade_item_id, year, week, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Generates new weekly supply lines based on pre-entered price groups.  # noqa: E501

        After entering the base price, Floriday will create multiple supply lines based on a variety of settings within Floriday.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_weekly_base_supply(body, trade_item_id, year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklyBaseSupplyCreate body: (required)
        :param str trade_item_id: (required)
        :param int year: (required)
        :param int week: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_weekly_base_supply_with_http_info(body, trade_item_id, year, week, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_weekly_base_supply_with_http_info(body, trade_item_id, year, week, **kwargs)  # noqa: E501
            return data

    def edit_weekly_base_supply_with_http_info(self, body, trade_item_id, year, week, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Generates new weekly supply lines based on pre-entered price groups.  # noqa: E501

        After entering the base price, Floriday will create multiple supply lines based on a variety of settings within Floriday.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_weekly_base_supply_with_http_info(body, trade_item_id, year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklyBaseSupplyCreate body: (required)
        :param str trade_item_id: (required)
        :param int year: (required)
        :param int week: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'trade_item_id', 'year', 'week']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_weekly_base_supply" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_weekly_base_supply`")  # noqa: E501
        # verify the required parameter 'trade_item_id' is set
        if ('trade_item_id' not in params or
                params['trade_item_id'] is None):
            raise ValueError("Missing the required parameter `trade_item_id` when calling `edit_weekly_base_supply`")  # noqa: E501
        # verify the required parameter 'year' is set
        if ('year' not in params or
                params['year'] is None):
            raise ValueError("Missing the required parameter `year` when calling `edit_weekly_base_supply`")  # noqa: E501
        # verify the required parameter 'week' is set
        if ('week' not in params or
                params['week'] is None):
            raise ValueError("Missing the required parameter `week` when calling `edit_weekly_base_supply`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'trade_item_id' in params:
            path_params['tradeItemId'] = params['trade_item_id']  # noqa: E501
        if 'year' in params:
            path_params['year'] = params['year']  # noqa: E501
        if 'week' in params:
            path_params['week'] = params['week']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/{tradeItemId}/base-supply/{year}/{week}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_weekly_base_supply_lines(self, body, year, week, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Generates new weekly supply lines for multiple trade items based on calculated and manual price groups.  # noqa: E501

        After entering the base price, Floriday will create multiple supply lines based on a variety of settings within Floriday.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_weekly_base_supply_lines(body, year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[EditWeeklyBaseSupplyLines] body: (required)
        :param int year: (required)
        :param int week: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_weekly_base_supply_lines_with_http_info(body, year, week, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_weekly_base_supply_lines_with_http_info(body, year, week, **kwargs)  # noqa: E501
            return data

    def edit_weekly_base_supply_lines_with_http_info(self, body, year, week, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Generates new weekly supply lines for multiple trade items based on calculated and manual price groups.  # noqa: E501

        After entering the base price, Floriday will create multiple supply lines based on a variety of settings within Floriday.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_weekly_base_supply_lines_with_http_info(body, year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[EditWeeklyBaseSupplyLines] body: (required)
        :param int year: (required)
        :param int week: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'year', 'week']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_weekly_base_supply_lines" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_weekly_base_supply_lines`")  # noqa: E501
        # verify the required parameter 'year' is set
        if ('year' not in params or
                params['year'] is None):
            raise ValueError("Missing the required parameter `year` when calling `edit_weekly_base_supply_lines`")  # noqa: E501
        # verify the required parameter 'week' is set
        if ('week' not in params or
                params['week'] is None):
            raise ValueError("Missing the required parameter `week` when calling `edit_weekly_base_supply_lines`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'year' in params:
            path_params['year'] = params['year']  # noqa: E501
        if 'week' in params:
            path_params['week'] = params['week']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/base-supply/{year}/{week}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_weekly_supply_line(self, body, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Updates a weekly supply line for trade item.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_weekly_supply_line(body, supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklySupplyLineUpdate body: (required)
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_weekly_supply_line_with_http_info(body, supply_line_id, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_weekly_supply_line_with_http_info(body, supply_line_id, **kwargs)  # noqa: E501
            return data

    def edit_weekly_supply_line_with_http_info(self, body, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Updates a weekly supply line for trade item.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_weekly_supply_line_with_http_info(body, supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklySupplyLineUpdate body: (required)
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'supply_line_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_weekly_supply_line" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_weekly_supply_line`")  # noqa: E501
        # verify the required parameter 'supply_line_id' is set
        if ('supply_line_id' not in params or
                params['supply_line_id'] is None):
            raise ValueError("Missing the required parameter `supply_line_id` when calling `edit_weekly_supply_line`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'supply_line_id' in params:
            path_params['supplyLineId'] = params['supply_line_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-lines/{supplyLineId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_continuous_stock(self, trade_item_id, **kwargs):  # noqa: E501
        """supply:read - Returns the availability of a trade item.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_continuous_stock(trade_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_item_id: (required)
        :return: ContinuousStock
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_continuous_stock_with_http_info(trade_item_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_continuous_stock_with_http_info(trade_item_id, **kwargs)  # noqa: E501
            return data

    def get_continuous_stock_with_http_info(self, trade_item_id, **kwargs):  # noqa: E501
        """supply:read - Returns the availability of a trade item.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_continuous_stock_with_http_info(trade_item_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_item_id: (required)
        :return: ContinuousStock
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['trade_item_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_continuous_stock" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'trade_item_id' is set
        if ('trade_item_id' not in params or
                params['trade_item_id'] is None):
            raise ValueError("Missing the required parameter `trade_item_id` when calling `get_continuous_stock`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'trade_item_id' in params:
            path_params['tradeItemId'] = params['trade_item_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/{tradeItemId}/continuous-stock', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ContinuousStock',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_trade_item_availabilities(self, **kwargs):  # noqa: E501
        """supply:read - rate limit: 2 per second - burst limit: 200 - Returns the current availability of all trade items.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_trade_item_availabilities(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[TradeItemAvailability]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_trade_item_availabilities_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_trade_item_availabilities_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_trade_item_availabilities_with_http_info(self, **kwargs):  # noqa: E501
        """supply:read - rate limit: 2 per second - burst limit: 200 - Returns the current availability of all trade items.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_trade_item_availabilities_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[TradeItemAvailability]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_trade_item_availabilities" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/availabilities', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[TradeItemAvailability]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_trade_item_availabilities_by_sequence_number(self, sequence_number, **kwargs):  # noqa: E501
        """supply:read - Returns a list of max 1000 trade item availabilities starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_trade_item_availabilities_by_sequence_number(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit:
        :return: SyncResultOfTradeItemAvailability
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_trade_item_availabilities_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
        else:
            (data) = self.get_trade_item_availabilities_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
            return data

    def get_trade_item_availabilities_by_sequence_number_with_http_info(self, sequence_number, **kwargs):  # noqa: E501
        """supply:read - Returns a list of max 1000 trade item availabilities starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_trade_item_availabilities_by_sequence_number_with_http_info(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit:
        :return: SyncResultOfTradeItemAvailability
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sequence_number', 'limit']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_trade_item_availabilities_by_sequence_number" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sequence_number' is set
        if ('sequence_number' not in params or
                params['sequence_number'] is None):
            raise ValueError("Missing the required parameter `sequence_number` when calling `get_trade_item_availabilities_by_sequence_number`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sequence_number' in params:
            path_params['sequenceNumber'] = params['sequence_number']  # noqa: E501

        query_params = []
        if 'limit' in params:
            query_params.append(('limit', params['limit']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/availabilities/sync/{sequenceNumber}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SyncResultOfTradeItemAvailability',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_trade_item_availabilities_max_sequence(self, **kwargs):  # noqa: E501
        """supply:read - Returns the maximum sequence number found in trade item availabilities.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_trade_item_availabilities_max_sequence(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_trade_item_availabilities_max_sequence_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_trade_item_availabilities_max_sequence_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_trade_item_availabilities_max_sequence_with_http_info(self, **kwargs):  # noqa: E501
        """supply:read - Returns the maximum sequence number found in trade item availabilities.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_trade_item_availabilities_max_sequence_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_trade_item_availabilities_max_sequence" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/availabilities/current-max-sequence', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='int',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_weekly_base_supplies(self, year, week, **kwargs):  # noqa: E501
        """supply:read - rate limit: 1 per second - burst limit: 20 - Returns the base supply per year/week for trade items.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_weekly_base_supplies(year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int year: (required)
        :param int week: (required)
        :return: list[WeeklyBaseSupply]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_weekly_base_supplies_with_http_info(year, week, **kwargs)  # noqa: E501
        else:
            (data) = self.get_weekly_base_supplies_with_http_info(year, week, **kwargs)  # noqa: E501
            return data

    def get_weekly_base_supplies_with_http_info(self, year, week, **kwargs):  # noqa: E501
        """supply:read - rate limit: 1 per second - burst limit: 20 - Returns the base supply per year/week for trade items.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_weekly_base_supplies_with_http_info(year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int year: (required)
        :param int week: (required)
        :return: list[WeeklyBaseSupply]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['year', 'week']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_weekly_base_supplies" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'year' is set
        if ('year' not in params or
                params['year'] is None):
            raise ValueError("Missing the required parameter `year` when calling `get_weekly_base_supplies`")  # noqa: E501
        # verify the required parameter 'week' is set
        if ('week' not in params or
                params['week'] is None):
            raise ValueError("Missing the required parameter `week` when calling `get_weekly_base_supplies`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'year' in params:
            query_params.append(('year', params['year']))  # noqa: E501
        if 'week' in params:
            query_params.append(('week', params['week']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/base-supply', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[WeeklyBaseSupply]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def set_trade_item_warehouse(self, trade_item_id, warehouse_id, **kwargs):  # noqa: E501
        """supply:write - Add a warehouse for a trade item ( only continuous stock )  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_trade_item_warehouse(trade_item_id, warehouse_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_item_id: (required)
        :param str warehouse_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.set_trade_item_warehouse_with_http_info(trade_item_id, warehouse_id, **kwargs)  # noqa: E501
        else:
            (data) = self.set_trade_item_warehouse_with_http_info(trade_item_id, warehouse_id, **kwargs)  # noqa: E501
            return data

    def set_trade_item_warehouse_with_http_info(self, trade_item_id, warehouse_id, **kwargs):  # noqa: E501
        """supply:write - Add a warehouse for a trade item ( only continuous stock )  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_trade_item_warehouse_with_http_info(trade_item_id, warehouse_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_item_id: (required)
        :param str warehouse_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['trade_item_id', 'warehouse_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method set_trade_item_warehouse" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'trade_item_id' is set
        if ('trade_item_id' not in params or
                params['trade_item_id'] is None):
            raise ValueError("Missing the required parameter `trade_item_id` when calling `set_trade_item_warehouse`")  # noqa: E501
        # verify the required parameter 'warehouse_id' is set
        if ('warehouse_id' not in params or
                params['warehouse_id'] is None):
            raise ValueError("Missing the required parameter `warehouse_id` when calling `set_trade_item_warehouse`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'trade_item_id' in params:
            path_params['tradeItemId'] = params['trade_item_id']  # noqa: E501

        query_params = []
        if 'warehouse_id' in params:
            query_params.append(('warehouseId', params['warehouse_id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/{tradeItemId}/warehouse', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def set_weekly_base_supply_number_of_pieces(self, trade_item_id, year, week, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Patch the number of pieces of an existing base supply.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_weekly_base_supply_number_of_pieces(trade_item_id, year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_item_id: (required)
        :param int year: (required)
        :param int week: (required)
        :param int number_of_pieces:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.set_weekly_base_supply_number_of_pieces_with_http_info(trade_item_id, year, week, **kwargs)  # noqa: E501
        else:
            (data) = self.set_weekly_base_supply_number_of_pieces_with_http_info(trade_item_id, year, week, **kwargs)  # noqa: E501
            return data

    def set_weekly_base_supply_number_of_pieces_with_http_info(self, trade_item_id, year, week, **kwargs):  # noqa: E501
        """supply:write - rate limit: 10 per second - burst limit: 1000 - Patch the number of pieces of an existing base supply.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_weekly_base_supply_number_of_pieces_with_http_info(trade_item_id, year, week, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_item_id: (required)
        :param int year: (required)
        :param int week: (required)
        :param int number_of_pieces:
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['trade_item_id', 'year', 'week', 'number_of_pieces']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method set_weekly_base_supply_number_of_pieces" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'trade_item_id' is set
        if ('trade_item_id' not in params or
                params['trade_item_id'] is None):
            raise ValueError("Missing the required parameter `trade_item_id` when calling `set_weekly_base_supply_number_of_pieces`")  # noqa: E501
        # verify the required parameter 'year' is set
        if ('year' not in params or
                params['year'] is None):
            raise ValueError("Missing the required parameter `year` when calling `set_weekly_base_supply_number_of_pieces`")  # noqa: E501
        # verify the required parameter 'week' is set
        if ('week' not in params or
                params['week'] is None):
            raise ValueError("Missing the required parameter `week` when calling `set_weekly_base_supply_number_of_pieces`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'trade_item_id' in params:
            path_params['tradeItemId'] = params['trade_item_id']  # noqa: E501
        if 'year' in params:
            path_params['year'] = params['year']  # noqa: E501
        if 'week' in params:
            path_params['week'] = params['week']  # noqa: E501

        query_params = []
        if 'number_of_pieces' in params:
            query_params.append(('numberOfPieces', params['number_of_pieces']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/trade-items/{tradeItemId}/base-supply/{year}/{week}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
