# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from floriday_supplier_client.api_client import ApiClient


class DeliveryOrdersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_clock_delivery_order(self, body, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Create a delivery order for auction warehouse.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_clock_delivery_order(body, delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeliveryOrderAuction body: (required)
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_clock_delivery_order_with_http_info(body, delivery_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.add_clock_delivery_order_with_http_info(body, delivery_order_id, **kwargs)  # noqa: E501
            return data

    def add_clock_delivery_order_with_http_info(self, body, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Create a delivery order for auction warehouse.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_clock_delivery_order_with_http_info(body, delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeliveryOrderAuction body: (required)
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'delivery_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_clock_delivery_order" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_clock_delivery_order`")  # noqa: E501
        # verify the required parameter 'delivery_order_id' is set
        if ('delivery_order_id' not in params or
                params['delivery_order_id'] is None):
            raise ValueError("Missing the required parameter `delivery_order_id` when calling `add_clock_delivery_order`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'delivery_order_id' in params:
            path_params['deliveryOrderId'] = params['delivery_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/{deliveryOrderId}/auction', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_delivery_order_goods_movement(self, body, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Create a delivery order for external warehouse.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_delivery_order_goods_movement(body, delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeliveryOrderGoodsMovement body: (required)
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_delivery_order_goods_movement_with_http_info(body, delivery_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.add_delivery_order_goods_movement_with_http_info(body, delivery_order_id, **kwargs)  # noqa: E501
            return data

    def add_delivery_order_goods_movement_with_http_info(self, body, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Create a delivery order for external warehouse.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_delivery_order_goods_movement_with_http_info(body, delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param DeliveryOrderGoodsMovement body: (required)
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'delivery_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_delivery_order_goods_movement" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_delivery_order_goods_movement`")  # noqa: E501
        # verify the required parameter 'delivery_order_id' is set
        if ('delivery_order_id' not in params or
                params['delivery_order_id'] is None):
            raise ValueError("Missing the required parameter `delivery_order_id` when calling `add_delivery_order_goods_movement`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'delivery_order_id' in params:
            path_params['deliveryOrderId'] = params['delivery_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/{deliveryOrderId}/goods-movement', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_clock_delivery_order(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Delete a delivery order for auction.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_clock_delivery_order(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_clock_delivery_order_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_clock_delivery_order_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
            return data

    def delete_clock_delivery_order_with_http_info(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Delete a delivery order for auction.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_clock_delivery_order_with_http_info(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['delivery_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_clock_delivery_order" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'delivery_order_id' is set
        if ('delivery_order_id' not in params or
                params['delivery_order_id'] is None):
            raise ValueError("Missing the required parameter `delivery_order_id` when calling `delete_clock_delivery_order`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'delivery_order_id' in params:
            path_params['deliveryOrderId'] = params['delivery_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/{deliveryOrderId}/auction', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_delivery_order_goods_movement(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Delete a delivery order for goods movement.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_delivery_order_goods_movement(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_delivery_order_goods_movement_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_delivery_order_goods_movement_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
            return data

    def delete_delivery_order_goods_movement_with_http_info(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Delete a delivery order for goods movement.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_delivery_order_goods_movement_with_http_info(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['delivery_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_delivery_order_goods_movement" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'delivery_order_id' is set
        if ('delivery_order_id' not in params or
                params['delivery_order_id'] is None):
            raise ValueError("Missing the required parameter `delivery_order_id` when calling `delete_delivery_order_goods_movement`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'delivery_order_id' in params:
            path_params['deliveryOrderId'] = params['delivery_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/{deliveryOrderId}/goods-movement', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_delivery_order_by_id(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns a delivery order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_delivery_order_by_id(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: DeliveryOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_delivery_order_by_id_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_delivery_order_by_id_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
            return data

    def get_delivery_order_by_id_with_http_info(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns a delivery order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_delivery_order_by_id_with_http_info(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: DeliveryOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['delivery_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_delivery_order_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'delivery_order_id' is set
        if ('delivery_order_id' not in params or
                params['delivery_order_id'] is None):
            raise ValueError("Missing the required parameter `delivery_order_id` when calling `get_delivery_order_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'delivery_order_id' in params:
            path_params['deliveryOrderId'] = params['delivery_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/{deliveryOrderId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DeliveryOrder',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_delivery_orders_by_sequence_number(self, sequence_number, **kwargs):  # noqa: E501
        """fulfillment:read - rate limit: 3.4 per second - burst limit: 1000 - Returns a list of max 1000 delivery orders starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_delivery_orders_by_sequence_number(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit_result:
        :return: SyncResultOfDeliveryOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_delivery_orders_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
        else:
            (data) = self.get_delivery_orders_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
            return data

    def get_delivery_orders_by_sequence_number_with_http_info(self, sequence_number, **kwargs):  # noqa: E501
        """fulfillment:read - rate limit: 3.4 per second - burst limit: 1000 - Returns a list of max 1000 delivery orders starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_delivery_orders_by_sequence_number_with_http_info(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit_result:
        :return: SyncResultOfDeliveryOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sequence_number', 'limit_result']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_delivery_orders_by_sequence_number" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sequence_number' is set
        if ('sequence_number' not in params or
                params['sequence_number'] is None):
            raise ValueError("Missing the required parameter `sequence_number` when calling `get_delivery_orders_by_sequence_number`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sequence_number' in params:
            path_params['sequenceNumber'] = params['sequence_number']  # noqa: E501

        query_params = []
        if 'limit_result' in params:
            query_params.append(('limitResult', params['limit_result']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/sync/{sequenceNumber}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SyncResultOfDeliveryOrder',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_delivery_orders_max_sequence(self, **kwargs):  # noqa: E501
        """supply:read - rate limit: 3.4 per second - burst limit: 1000 - Returns the maximum sequence number found in delivery orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_delivery_orders_max_sequence(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_delivery_orders_max_sequence_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_delivery_orders_max_sequence_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_delivery_orders_max_sequence_with_http_info(self, **kwargs):  # noqa: E501
        """supply:read - rate limit: 3.4 per second - burst limit: 1000 - Returns the maximum sequence number found in delivery orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_delivery_orders_max_sequence_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_delivery_orders_max_sequence" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/current-max-sequence', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='int',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_tray_labels_as_pdf_by_id(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns tray stickers as pdf for a delivery order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tray_labels_as_pdf_by_id(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_tray_labels_as_pdf_by_id_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_tray_labels_as_pdf_by_id_with_http_info(delivery_order_id, **kwargs)  # noqa: E501
            return data

    def get_tray_labels_as_pdf_by_id_with_http_info(self, delivery_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns tray stickers as pdf for a delivery order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tray_labels_as_pdf_by_id_with_http_info(delivery_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str delivery_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['delivery_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_tray_labels_as_pdf_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'delivery_order_id' is set
        if ('delivery_order_id' not in params or
                params['delivery_order_id'] is None):
            raise ValueError("Missing the required parameter `delivery_order_id` when calling `get_tray_labels_as_pdf_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'delivery_order_id' in params:
            path_params['deliveryOrderId'] = params['delivery_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/delivery-orders/{deliveryOrderId}/stickers', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
