# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from floriday_supplier_client.api_client import ApiClient


class FulfillmentOrdersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_fulfillment_order(self, body, **kwargs):  # noqa: E501
        """fulfillment:write - Creates a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_fulfillment_order(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param FulfillmentOrderCreate body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_fulfillment_order_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.add_fulfillment_order_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def add_fulfillment_order_with_http_info(self, body, **kwargs):  # noqa: E501
        """fulfillment:write - Creates a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_fulfillment_order_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param FulfillmentOrderCreate body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_fulfillment_order" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_fulfillment_order`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_fulfillment_order_correction(self, body, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Corrects a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_fulfillment_order_correction(body, fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AddFulfillmentOrderCorrection body: (required)
        :param str fulfillment_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_fulfillment_order_correction_with_http_info(body, fulfillment_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.add_fulfillment_order_correction_with_http_info(body, fulfillment_order_id, **kwargs)  # noqa: E501
            return data

    def add_fulfillment_order_correction_with_http_info(self, body, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Corrects a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_fulfillment_order_correction_with_http_info(body, fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param AddFulfillmentOrderCorrection body: (required)
        :param str fulfillment_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'fulfillment_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_fulfillment_order_correction" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_fulfillment_order_correction`")  # noqa: E501
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `add_fulfillment_order_correction`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}/corrections', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_fulfillment_order(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Delete a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_fulfillment_order(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_fulfillment_order_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_fulfillment_order_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
            return data

    def delete_fulfillment_order_with_http_info(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Delete a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_fulfillment_order_with_http_info(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['fulfillment_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_fulfillment_order" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `delete_fulfillment_order`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def edit_fulfillment_order(self, body, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Updates a fulfillment order.  # noqa: E501

        Update to the new number of load carriers ( lower than original value ). Load carrier(s) with highest sequence-number(s) will be removed first.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_fulfillment_order(body, fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param FulfillmentOrderUpdate body: (required)
        :param str fulfillment_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.edit_fulfillment_order_with_http_info(body, fulfillment_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.edit_fulfillment_order_with_http_info(body, fulfillment_order_id, **kwargs)  # noqa: E501
            return data

    def edit_fulfillment_order_with_http_info(self, body, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:write - Updates a fulfillment order.  # noqa: E501

        Update to the new number of load carriers ( lower than original value ). Load carrier(s) with highest sequence-number(s) will be removed first.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.edit_fulfillment_order_with_http_info(body, fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param FulfillmentOrderUpdate body: (required)
        :param str fulfillment_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'fulfillment_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method edit_fulfillment_order" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `edit_fulfillment_order`")  # noqa: E501
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `edit_fulfillment_order`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_fulfillment_order_by_id(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_order_by_id(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: FulfillmentOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_fulfillment_order_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_fulfillment_order_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
            return data

    def get_fulfillment_order_by_id_with_http_info(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_order_by_id_with_http_info(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: FulfillmentOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['fulfillment_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_fulfillment_order_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `get_fulfillment_order_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FulfillmentOrder',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_fulfillment_order_corrections_by_id(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns fulfillment order corrections.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_order_corrections_by_id(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: list[FulfillmentOrderCorrection]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_fulfillment_order_corrections_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_fulfillment_order_corrections_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
            return data

    def get_fulfillment_order_corrections_by_id_with_http_info(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns fulfillment order corrections.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_order_corrections_by_id_with_http_info(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: list[FulfillmentOrderCorrection]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['fulfillment_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_fulfillment_order_corrections_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `get_fulfillment_order_corrections_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}/corrections', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[FulfillmentOrderCorrection]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_fulfillment_order_status_by_id(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns the status of a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_order_status_by_id(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: FulfillmentOrderStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_fulfillment_order_status_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_fulfillment_order_status_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
            return data

    def get_fulfillment_order_status_by_id_with_http_info(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns the status of a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_order_status_by_id_with_http_info(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: FulfillmentOrderStatus
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['fulfillment_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_fulfillment_order_status_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `get_fulfillment_order_status_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}/status', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='FulfillmentOrderStatus',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_fulfillment_orders_by_sequence_number(self, sequence_number, **kwargs):  # noqa: E501
        """fulfillment:read - rate limit: 3.4 per second - burst limit: 1000 - Returns a list of max 1000 fulfillment orders starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_orders_by_sequence_number(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit_result:
        :return: SyncResultOfFulfillmentOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_fulfillment_orders_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
        else:
            (data) = self.get_fulfillment_orders_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
            return data

    def get_fulfillment_orders_by_sequence_number_with_http_info(self, sequence_number, **kwargs):  # noqa: E501
        """fulfillment:read - rate limit: 3.4 per second - burst limit: 1000 - Returns a list of max 1000 fulfillment orders starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_orders_by_sequence_number_with_http_info(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit_result:
        :return: SyncResultOfFulfillmentOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sequence_number', 'limit_result']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_fulfillment_orders_by_sequence_number" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sequence_number' is set
        if ('sequence_number' not in params or
                params['sequence_number'] is None):
            raise ValueError("Missing the required parameter `sequence_number` when calling `get_fulfillment_orders_by_sequence_number`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sequence_number' in params:
            path_params['sequenceNumber'] = params['sequence_number']  # noqa: E501

        query_params = []
        if 'limit_result' in params:
            query_params.append(('limitResult', params['limit_result']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/sync/{sequenceNumber}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SyncResultOfFulfillmentOrder',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_fulfillment_orders_max_sequence(self, **kwargs):  # noqa: E501
        """supply:read - rate limit: 3.4 per second - burst limit: 1000 - Returns the maximum sequence number found in fulfillment orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_orders_max_sequence(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_fulfillment_orders_max_sequence_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_fulfillment_orders_max_sequence_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_fulfillment_orders_max_sequence_with_http_info(self, **kwargs):  # noqa: E501
        """supply:read - rate limit: 3.4 per second - burst limit: 1000 - Returns the maximum sequence number found in fulfillment orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_fulfillment_orders_max_sequence_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_fulfillment_orders_max_sequence" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/current-max-sequence', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='int',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_logistic_labels_by_id(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - rate limit: 1.0 per second - burst limit: 60 - Returns logistic labels (SSCC or delivery notes) as pdf for a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logistic_labels_by_id(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_logistic_labels_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_logistic_labels_by_id_with_http_info(fulfillment_order_id, **kwargs)  # noqa: E501
            return data

    def get_logistic_labels_by_id_with_http_info(self, fulfillment_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - rate limit: 1.0 per second - burst limit: 60 - Returns logistic labels (SSCC or delivery notes) as pdf for a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_logistic_labels_by_id_with_http_info(fulfillment_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['fulfillment_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_logistic_labels_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `get_logistic_labels_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}/logistic-labels', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_tray_labels_as_pdf_by_fulfillment_order_id(self, fulfillment_order_id, show_customer_on_sticker, **kwargs):  # noqa: E501
        """fulfillment:read - Returns tray stickers as pdf for a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tray_labels_as_pdf_by_fulfillment_order_id(fulfillment_order_id, show_customer_on_sticker, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :param bool show_customer_on_sticker: (required)
        :param bool single_sticker_per_batch:
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_tray_labels_as_pdf_by_fulfillment_order_id_with_http_info(fulfillment_order_id, show_customer_on_sticker, **kwargs)  # noqa: E501
        else:
            (data) = self.get_tray_labels_as_pdf_by_fulfillment_order_id_with_http_info(fulfillment_order_id, show_customer_on_sticker, **kwargs)  # noqa: E501
            return data

    def get_tray_labels_as_pdf_by_fulfillment_order_id_with_http_info(self, fulfillment_order_id, show_customer_on_sticker, **kwargs):  # noqa: E501
        """fulfillment:read - Returns tray stickers as pdf for a fulfillment order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tray_labels_as_pdf_by_fulfillment_order_id_with_http_info(fulfillment_order_id, show_customer_on_sticker, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str fulfillment_order_id: (required)
        :param bool show_customer_on_sticker: (required)
        :param bool single_sticker_per_batch:
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['fulfillment_order_id', 'show_customer_on_sticker', 'single_sticker_per_batch']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_tray_labels_as_pdf_by_fulfillment_order_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'fulfillment_order_id' is set
        if ('fulfillment_order_id' not in params or
                params['fulfillment_order_id'] is None):
            raise ValueError("Missing the required parameter `fulfillment_order_id` when calling `get_tray_labels_as_pdf_by_fulfillment_order_id`")  # noqa: E501
        # verify the required parameter 'show_customer_on_sticker' is set
        if ('show_customer_on_sticker' not in params or
                params['show_customer_on_sticker'] is None):
            raise ValueError("Missing the required parameter `show_customer_on_sticker` when calling `get_tray_labels_as_pdf_by_fulfillment_order_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'fulfillment_order_id' in params:
            path_params['fulfillmentOrderId'] = params['fulfillment_order_id']  # noqa: E501

        query_params = []
        if 'show_customer_on_sticker' in params:
            query_params.append(('showCustomerOnSticker', params['show_customer_on_sticker']))  # noqa: E501
        if 'single_sticker_per_batch' in params:
            query_params.append(('singleStickerPerBatch', params['single_sticker_per_batch']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/fulfillment-orders/{fulfillmentOrderId}/stickers', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
