# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from floriday_supplier_client.api_client import ApiClient


class PlantPassportsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_plant_passport_pdf(self, body, **kwargs):  # noqa: E501
        """fulfillment:read - Returns the plant passport PDF for the BatchIds.  # noqa: E501

        Uses HTTP POST to prevent a limit on the query URL.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_plant_passport_pdf(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] body: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_plant_passport_pdf_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.get_plant_passport_pdf_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def get_plant_passport_pdf_with_http_info(self, body, **kwargs):  # noqa: E501
        """fulfillment:read - Returns the plant passport PDF for the BatchIds.  # noqa: E501

        Uses HTTP POST to prevent a limit on the query URL.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_plant_passport_pdf_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] body: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_plant_passport_pdf" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `get_plant_passport_pdf`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/plant-passports', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_plant_passport_pdf_by_sales_channel_order_id(self, sales_channel_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns plant passport PDF for the sales order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_plant_passport_pdf_by_sales_channel_order_id(sales_channel_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_channel_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_plant_passport_pdf_by_sales_channel_order_id_with_http_info(sales_channel_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_plant_passport_pdf_by_sales_channel_order_id_with_http_info(sales_channel_order_id, **kwargs)  # noqa: E501
            return data

    def get_plant_passport_pdf_by_sales_channel_order_id_with_http_info(self, sales_channel_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns plant passport PDF for the sales order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_plant_passport_pdf_by_sales_channel_order_id_with_http_info(sales_channel_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_channel_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sales_channel_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_plant_passport_pdf_by_sales_channel_order_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sales_channel_order_id' is set
        if ('sales_channel_order_id' not in params or
                params['sales_channel_order_id'] is None):
            raise ValueError("Missing the required parameter `sales_channel_order_id` when calling `get_plant_passport_pdf_by_sales_channel_order_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sales_channel_order_id' in params:
            path_params['salesChannelOrderId'] = params['sales_channel_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/plant-passports/by-sales-channel-order-id/{salesChannelOrderId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_plant_passport_pdf_by_sales_order_id(self, sales_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns plant passport PDF for the sales order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_plant_passport_pdf_by_sales_order_id(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_plant_passport_pdf_by_sales_order_id_with_http_info(sales_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_plant_passport_pdf_by_sales_order_id_with_http_info(sales_order_id, **kwargs)  # noqa: E501
            return data

    def get_plant_passport_pdf_by_sales_order_id_with_http_info(self, sales_order_id, **kwargs):  # noqa: E501
        """fulfillment:read - Returns plant passport PDF for the sales order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_plant_passport_pdf_by_sales_order_id_with_http_info(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sales_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_plant_passport_pdf_by_sales_order_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sales_order_id' is set
        if ('sales_order_id' not in params or
                params['sales_order_id'] is None):
            raise ValueError("Missing the required parameter `sales_order_id` when calling `get_plant_passport_pdf_by_sales_order_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sales_order_id' in params:
            path_params['salesOrderId'] = params['sales_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/plant-passports/by-sales-order-id/{salesOrderId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
