# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from floriday_supplier_client.api_client import ApiClient


class SalesOrdersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_sales_order(self, body, **kwargs):  # noqa: E501
        """sales-order:write - rate limit: 3.4 per second - burst limit: 1000 - Creates a new sales order.  # noqa: E501

        Creates a new sales order with a supply reference  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_sales_order(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SalesOrderRequest body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_sales_order_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.add_sales_order_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def add_sales_order_with_http_info(self, body, **kwargs):  # noqa: E501
        """sales-order:write - rate limit: 3.4 per second - burst limit: 1000 - Creates a new sales order.  # noqa: E501

        Creates a new sales order with a supply reference  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_sales_order_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SalesOrderRequest body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_sales_order" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_sales_order`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_sales_order_external_integration(self, body, **kwargs):  # noqa: E501
        """sales-order:write - rate limit: 3.4 per second - burst limit: 1000 - Creates a new sales order.  # noqa: E501

        Creates a new sales order without a supply line or blanket order reference.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_sales_order_external_integration(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SalesOrderExternalIntegrationRequest body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_sales_order_external_integration_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.add_sales_order_external_integration_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def add_sales_order_external_integration_with_http_info(self, body, **kwargs):  # noqa: E501
        """sales-order:write - rate limit: 3.4 per second - burst limit: 1000 - Creates a new sales order.  # noqa: E501

        Creates a new sales order without a supply line or blanket order reference.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_sales_order_external_integration_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param SalesOrderExternalIntegrationRequest body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_sales_order_external_integration" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_sales_order_external_integration`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders/external-integration', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_sales_order_by_id(self, sales_order_id, **kwargs):  # noqa: E501
        """sales-order:read - Returns a sales order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_order_by_id(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: SalesOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_sales_order_by_id_with_http_info(sales_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_sales_order_by_id_with_http_info(sales_order_id, **kwargs)  # noqa: E501
            return data

    def get_sales_order_by_id_with_http_info(self, sales_order_id, **kwargs):  # noqa: E501
        """sales-order:read - Returns a sales order.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_order_by_id_with_http_info(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: SalesOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sales_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sales_order_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sales_order_id' is set
        if ('sales_order_id' not in params or
                params['sales_order_id'] is None):
            raise ValueError("Missing the required parameter `sales_order_id` when calling `get_sales_order_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sales_order_id' in params:
            path_params['salesOrderId'] = params['sales_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders/{salesOrderId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SalesOrder',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_sales_order_by_id_and_version(self, sales_order_id, sales_order_version, **kwargs):  # noqa: E501
        """sales-order:read - Returns the sales order by ID and version.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_order_by_id_and_version(sales_order_id, sales_order_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :param int sales_order_version: (required)
        :return: SalesOrderVersion
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_sales_order_by_id_and_version_with_http_info(sales_order_id, sales_order_version, **kwargs)  # noqa: E501
        else:
            (data) = self.get_sales_order_by_id_and_version_with_http_info(sales_order_id, sales_order_version, **kwargs)  # noqa: E501
            return data

    def get_sales_order_by_id_and_version_with_http_info(self, sales_order_id, sales_order_version, **kwargs):  # noqa: E501
        """sales-order:read - Returns the sales order by ID and version.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_order_by_id_and_version_with_http_info(sales_order_id, sales_order_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :param int sales_order_version: (required)
        :return: SalesOrderVersion
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sales_order_id', 'sales_order_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sales_order_by_id_and_version" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sales_order_id' is set
        if ('sales_order_id' not in params or
                params['sales_order_id'] is None):
            raise ValueError("Missing the required parameter `sales_order_id` when calling `get_sales_order_by_id_and_version`")  # noqa: E501
        # verify the required parameter 'sales_order_version' is set
        if ('sales_order_version' not in params or
                params['sales_order_version'] is None):
            raise ValueError("Missing the required parameter `sales_order_version` when calling `get_sales_order_by_id_and_version`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sales_order_id' in params:
            path_params['salesOrderId'] = params['sales_order_id']  # noqa: E501

        query_params = []
        if 'sales_order_version' in params:
            query_params.append(('salesOrderVersion', params['sales_order_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders/{salesOrderId}/version', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SalesOrderVersion',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_sales_orders(self, **kwargs):  # noqa: E501
        """sales-order:read - rate limit: 3.4 per second - burst limit: 1000 - Returns sales orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_orders(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param datetime start_date_time:
        :param datetime end_date_time:
        :param str trade_instrument:
        :param int sequence:
        :param int limit_result:
        :return: list[SalesOrder]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_sales_orders_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_sales_orders_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_sales_orders_with_http_info(self, **kwargs):  # noqa: E501
        """sales-order:read - rate limit: 3.4 per second - burst limit: 1000 - Returns sales orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_orders_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param datetime start_date_time:
        :param datetime end_date_time:
        :param str trade_instrument:
        :param int sequence:
        :param int limit_result:
        :return: list[SalesOrder]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['start_date_time', 'end_date_time', 'trade_instrument', 'sequence', 'limit_result']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sales_orders" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'start_date_time' in params:
            query_params.append(('startDateTime', params['start_date_time']))  # noqa: E501
        if 'end_date_time' in params:
            query_params.append(('endDateTime', params['end_date_time']))  # noqa: E501
        if 'trade_instrument' in params:
            query_params.append(('tradeInstrument', params['trade_instrument']))  # noqa: E501
        if 'sequence' in params:
            query_params.append(('sequence', params['sequence']))  # noqa: E501
        if 'limit_result' in params:
            query_params.append(('limitResult', params['limit_result']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[SalesOrder]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_sales_orders_by_sequence_number(self, sequence_number, **kwargs):  # noqa: E501
        """sales-order:read - rate limit: 3.4 per second - burst limit: 1000 - Returns a list of max 1000 sales orders starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_orders_by_sequence_number(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit_result:
        :return: SyncResultOfSalesOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_sales_orders_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
        else:
            (data) = self.get_sales_orders_by_sequence_number_with_http_info(sequence_number, **kwargs)  # noqa: E501
            return data

    def get_sales_orders_by_sequence_number_with_http_info(self, sequence_number, **kwargs):  # noqa: E501
        """sales-order:read - rate limit: 3.4 per second - burst limit: 1000 - Returns a list of max 1000 sales orders starting from a specified sequence number.  # noqa: E501

        **Synchronization endpoint** Fetches the succeeding modified records (including deleted records) based on `Limit` and the given `SequenceNumber`.  **Note** Your data is up to date when your given `SequenceNumber` is equal to the received `MaximumSequenceNumber`.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_orders_by_sequence_number_with_http_info(sequence_number, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int sequence_number: (required)
        :param int limit_result:
        :return: SyncResultOfSalesOrder
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sequence_number', 'limit_result']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sales_orders_by_sequence_number" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sequence_number' is set
        if ('sequence_number' not in params or
                params['sequence_number'] is None):
            raise ValueError("Missing the required parameter `sequence_number` when calling `get_sales_orders_by_sequence_number`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sequence_number' in params:
            path_params['sequenceNumber'] = params['sequence_number']  # noqa: E501

        query_params = []
        if 'limit_result' in params:
            query_params.append(('limitResult', params['limit_result']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders/sync/{sequenceNumber}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='SyncResultOfSalesOrder',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_sales_orders_max_sequence(self, **kwargs):  # noqa: E501
        """sales-order:read - Returns the maximum sequence number found in sales orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_orders_max_sequence(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_sales_orders_max_sequence_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_sales_orders_max_sequence_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_sales_orders_max_sequence_with_http_info(self, **kwargs):  # noqa: E501
        """sales-order:read - Returns the maximum sequence number found in sales orders.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_sales_orders_max_sequence_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: int
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_sales_orders_max_sequence" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders/current-max-sequence', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='int',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def set_sales_order_cancelled(self, sales_order_id, **kwargs):  # noqa: E501
        """sales-order:write - Cancel a sales order that is still in status ACCEPTED.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_sales_order_cancelled(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.set_sales_order_cancelled_with_http_info(sales_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.set_sales_order_cancelled_with_http_info(sales_order_id, **kwargs)  # noqa: E501
            return data

    def set_sales_order_cancelled_with_http_info(self, sales_order_id, **kwargs):  # noqa: E501
        """sales-order:write - Cancel a sales order that is still in status ACCEPTED.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_sales_order_cancelled_with_http_info(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sales_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method set_sales_order_cancelled" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sales_order_id' is set
        if ('sales_order_id' not in params or
                params['sales_order_id'] is None):
            raise ValueError("Missing the required parameter `sales_order_id` when calling `set_sales_order_cancelled`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sales_order_id' in params:
            path_params['salesOrderId'] = params['sales_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders/{salesOrderId}/cancel', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def set_sales_order_committed(self, sales_order_id, **kwargs):  # noqa: E501
        """sales-order:write - Commit a sales order that is still in status ACCEPTED.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_sales_order_committed(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.set_sales_order_committed_with_http_info(sales_order_id, **kwargs)  # noqa: E501
        else:
            (data) = self.set_sales_order_committed_with_http_info(sales_order_id, **kwargs)  # noqa: E501
            return data

    def set_sales_order_committed_with_http_info(self, sales_order_id, **kwargs):  # noqa: E501
        """sales-order:write - Commit a sales order that is still in status ACCEPTED.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.set_sales_order_committed_with_http_info(sales_order_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sales_order_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['sales_order_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method set_sales_order_committed" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'sales_order_id' is set
        if ('sales_order_id' not in params or
                params['sales_order_id'] is None):
            raise ValueError("Missing the required parameter `sales_order_id` when calling `set_sales_order_committed`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'sales_order_id' in params:
            path_params['salesOrderId'] = params['sales_order_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['*/*'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/sales-orders/{salesOrderId}/commit', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
