# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from floriday_supplier_client.api_client import ApiClient


class WeeklySupplyLineCountersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def add_weekly_supply_line_counter(self, body, **kwargs):  # noqa: E501
        """supply:write - Creates a new WeeklySupplyLineCounter.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_weekly_supply_line_counter(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklySupplyLineCounterCreate body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_weekly_supply_line_counter_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.add_weekly_supply_line_counter_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def add_weekly_supply_line_counter_with_http_info(self, body, **kwargs):  # noqa: E501
        """supply:write - Creates a new WeeklySupplyLineCounter.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_weekly_supply_line_counter_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param WeeklySupplyLineCounterCreate body: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_weekly_supply_line_counter" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_weekly_supply_line_counter`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-line-counters', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def add_weekly_supply_line_counter_to_supply_line(self, weekly_supply_line_counter_id, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Links the supply line to the WeeklySupplyLineCounter. The `numberOfPieces` in the supply line will be based on the counter.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_weekly_supply_line_counter_to_supply_line(weekly_supply_line_counter_id, supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.add_weekly_supply_line_counter_to_supply_line_with_http_info(weekly_supply_line_counter_id, supply_line_id, **kwargs)  # noqa: E501
        else:
            (data) = self.add_weekly_supply_line_counter_to_supply_line_with_http_info(weekly_supply_line_counter_id, supply_line_id, **kwargs)  # noqa: E501
            return data

    def add_weekly_supply_line_counter_to_supply_line_with_http_info(self, weekly_supply_line_counter_id, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Links the supply line to the WeeklySupplyLineCounter. The `numberOfPieces` in the supply line will be based on the counter.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.add_weekly_supply_line_counter_to_supply_line_with_http_info(weekly_supply_line_counter_id, supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['weekly_supply_line_counter_id', 'supply_line_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_weekly_supply_line_counter_to_supply_line" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'weekly_supply_line_counter_id' is set
        if ('weekly_supply_line_counter_id' not in params or
                params['weekly_supply_line_counter_id'] is None):
            raise ValueError("Missing the required parameter `weekly_supply_line_counter_id` when calling `add_weekly_supply_line_counter_to_supply_line`")  # noqa: E501
        # verify the required parameter 'supply_line_id' is set
        if ('supply_line_id' not in params or
                params['supply_line_id'] is None):
            raise ValueError("Missing the required parameter `supply_line_id` when calling `add_weekly_supply_line_counter_to_supply_line`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'weekly_supply_line_counter_id' in params:
            path_params['weeklySupplyLineCounterId'] = params['weekly_supply_line_counter_id']  # noqa: E501
        if 'supply_line_id' in params:
            path_params['supplyLineId'] = params['supply_line_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-line-counters/{weeklySupplyLineCounterId}/add-to-supplyline/{supplyLineId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_weekly_supply_line_counter(self, weekly_supply_line_counter_id, **kwargs):  # noqa: E501
        """supply:write - Deletes the WeeklySupplyLineCounter and removes all the supply line links.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_weekly_supply_line_counter(weekly_supply_line_counter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_weekly_supply_line_counter_with_http_info(weekly_supply_line_counter_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_weekly_supply_line_counter_with_http_info(weekly_supply_line_counter_id, **kwargs)  # noqa: E501
            return data

    def delete_weekly_supply_line_counter_with_http_info(self, weekly_supply_line_counter_id, **kwargs):  # noqa: E501
        """supply:write - Deletes the WeeklySupplyLineCounter and removes all the supply line links.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_weekly_supply_line_counter_with_http_info(weekly_supply_line_counter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['weekly_supply_line_counter_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_weekly_supply_line_counter" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'weekly_supply_line_counter_id' is set
        if ('weekly_supply_line_counter_id' not in params or
                params['weekly_supply_line_counter_id'] is None):
            raise ValueError("Missing the required parameter `weekly_supply_line_counter_id` when calling `delete_weekly_supply_line_counter`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'weekly_supply_line_counter_id' in params:
            path_params['weeklySupplyLineCounterId'] = params['weekly_supply_line_counter_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-line-counters/{weeklySupplyLineCounterId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_weekly_supply_line_counter_by_id(self, weekly_supply_line_counter_id, **kwargs):  # noqa: E501
        """supply:read - Returns the WeeklySupplyLineCounters by id.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_weekly_supply_line_counter_by_id(weekly_supply_line_counter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :return: WeeklySupplyLineCounter
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_weekly_supply_line_counter_by_id_with_http_info(weekly_supply_line_counter_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_weekly_supply_line_counter_by_id_with_http_info(weekly_supply_line_counter_id, **kwargs)  # noqa: E501
            return data

    def get_weekly_supply_line_counter_by_id_with_http_info(self, weekly_supply_line_counter_id, **kwargs):  # noqa: E501
        """supply:read - Returns the WeeklySupplyLineCounters by id.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_weekly_supply_line_counter_by_id_with_http_info(weekly_supply_line_counter_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :return: WeeklySupplyLineCounter
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['weekly_supply_line_counter_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_weekly_supply_line_counter_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'weekly_supply_line_counter_id' is set
        if ('weekly_supply_line_counter_id' not in params or
                params['weekly_supply_line_counter_id'] is None):
            raise ValueError("Missing the required parameter `weekly_supply_line_counter_id` when calling `get_weekly_supply_line_counter_by_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'weekly_supply_line_counter_id' in params:
            path_params['weeklySupplyLineCounterId'] = params['weekly_supply_line_counter_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-line-counters/{weeklySupplyLineCounterId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='WeeklySupplyLineCounter',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_weekly_supply_line_counters(self, **kwargs):  # noqa: E501
        """supply:read - Returns all available WeeklySupplyLineCounters created via the Suppliers API.  # noqa: E501

        WeeklySupplyLineCounters are used to create a countdown in the supply lines. The `numberOfPieces` in the supply line will be linked to the counter  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_weekly_supply_line_counters(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[WeeklySupplyLineCounter]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_weekly_supply_line_counters_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_weekly_supply_line_counters_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_weekly_supply_line_counters_with_http_info(self, **kwargs):  # noqa: E501
        """supply:read - Returns all available WeeklySupplyLineCounters created via the Suppliers API.  # noqa: E501

        WeeklySupplyLineCounters are used to create a countdown in the supply lines. The `numberOfPieces` in the supply line will be linked to the counter  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_weekly_supply_line_counters_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: list[WeeklySupplyLineCounter]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_weekly_supply_line_counters" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-line-counters', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[WeeklySupplyLineCounter]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def remove_weekly_supply_line_counter_from_supply_line(self, weekly_supply_line_counter_id, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Removes the supply line from the WeeklySupplyLineCounter.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_weekly_supply_line_counter_from_supply_line(weekly_supply_line_counter_id, supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.remove_weekly_supply_line_counter_from_supply_line_with_http_info(weekly_supply_line_counter_id, supply_line_id, **kwargs)  # noqa: E501
        else:
            (data) = self.remove_weekly_supply_line_counter_from_supply_line_with_http_info(weekly_supply_line_counter_id, supply_line_id, **kwargs)  # noqa: E501
            return data

    def remove_weekly_supply_line_counter_from_supply_line_with_http_info(self, weekly_supply_line_counter_id, supply_line_id, **kwargs):  # noqa: E501
        """supply:write - Removes the supply line from the WeeklySupplyLineCounter.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.remove_weekly_supply_line_counter_from_supply_line_with_http_info(weekly_supply_line_counter_id, supply_line_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str weekly_supply_line_counter_id: (required)
        :param str supply_line_id: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['weekly_supply_line_counter_id', 'supply_line_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method remove_weekly_supply_line_counter_from_supply_line" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'weekly_supply_line_counter_id' is set
        if ('weekly_supply_line_counter_id' not in params or
                params['weekly_supply_line_counter_id'] is None):
            raise ValueError("Missing the required parameter `weekly_supply_line_counter_id` when calling `remove_weekly_supply_line_counter_from_supply_line`")  # noqa: E501
        # verify the required parameter 'supply_line_id' is set
        if ('supply_line_id' not in params or
                params['supply_line_id'] is None):
            raise ValueError("Missing the required parameter `supply_line_id` when calling `remove_weekly_supply_line_counter_from_supply_line`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'weekly_supply_line_counter_id' in params:
            path_params['weeklySupplyLineCounterId'] = params['weekly_supply_line_counter_id']  # noqa: E501
        if 'supply_line_id' in params:
            path_params['supplyLineId'] = params['supply_line_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JWT Token', 'X-Api-Key']  # noqa: E501

        return self.api_client.call_api(
            '/weekly-supply-line-counters/{weeklySupplyLineCounterId}/remove-from-supplyline/{supplyLineId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
