# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AcceptSupplyRequestLine(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'price_per_piece': 'float',
        'number_of_pieces': 'int',
        'order_period': 'TradePeriod',
        'delivery_period': 'TradePeriod',
        'despatch_warehouse_id': 'str',
        'uses_catalog_availability': 'bool'
    }

    attribute_map = {
        'price_per_piece': 'pricePerPiece',
        'number_of_pieces': 'numberOfPieces',
        'order_period': 'orderPeriod',
        'delivery_period': 'deliveryPeriod',
        'despatch_warehouse_id': 'despatchWarehouseId',
        'uses_catalog_availability': 'usesCatalogAvailability'
    }

    def __init__(self, price_per_piece=None, number_of_pieces=None, order_period=None, delivery_period=None, despatch_warehouse_id=None, uses_catalog_availability=None):  # noqa: E501
        """AcceptSupplyRequestLine - a model defined in Swagger"""  # noqa: E501
        self._price_per_piece = None
        self._number_of_pieces = None
        self._order_period = None
        self._delivery_period = None
        self._despatch_warehouse_id = None
        self._uses_catalog_availability = None
        self.discriminator = None
        self.price_per_piece = price_per_piece
        self.number_of_pieces = number_of_pieces
        self.order_period = order_period
        self.delivery_period = delivery_period
        self.despatch_warehouse_id = despatch_warehouse_id
        self.uses_catalog_availability = uses_catalog_availability

    @property
    def price_per_piece(self):
        """Gets the price_per_piece of this AcceptSupplyRequestLine.  # noqa: E501


        :return: The price_per_piece of this AcceptSupplyRequestLine.  # noqa: E501
        :rtype: float
        """
        return self._price_per_piece

    @price_per_piece.setter
    def price_per_piece(self, price_per_piece):
        """Sets the price_per_piece of this AcceptSupplyRequestLine.


        :param price_per_piece: The price_per_piece of this AcceptSupplyRequestLine.  # noqa: E501
        :type: float
        """
        if price_per_piece is None:
            raise ValueError("Invalid value for `price_per_piece`, must not be `None`")  # noqa: E501

        self._price_per_piece = price_per_piece

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this AcceptSupplyRequestLine.  # noqa: E501


        :return: The number_of_pieces of this AcceptSupplyRequestLine.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this AcceptSupplyRequestLine.


        :param number_of_pieces: The number_of_pieces of this AcceptSupplyRequestLine.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def order_period(self):
        """Gets the order_period of this AcceptSupplyRequestLine.  # noqa: E501


        :return: The order_period of this AcceptSupplyRequestLine.  # noqa: E501
        :rtype: TradePeriod
        """
        return self._order_period

    @order_period.setter
    def order_period(self, order_period):
        """Sets the order_period of this AcceptSupplyRequestLine.


        :param order_period: The order_period of this AcceptSupplyRequestLine.  # noqa: E501
        :type: TradePeriod
        """
        if order_period is None:
            raise ValueError("Invalid value for `order_period`, must not be `None`")  # noqa: E501

        self._order_period = order_period

    @property
    def delivery_period(self):
        """Gets the delivery_period of this AcceptSupplyRequestLine.  # noqa: E501


        :return: The delivery_period of this AcceptSupplyRequestLine.  # noqa: E501
        :rtype: TradePeriod
        """
        return self._delivery_period

    @delivery_period.setter
    def delivery_period(self, delivery_period):
        """Sets the delivery_period of this AcceptSupplyRequestLine.


        :param delivery_period: The delivery_period of this AcceptSupplyRequestLine.  # noqa: E501
        :type: TradePeriod
        """
        if delivery_period is None:
            raise ValueError("Invalid value for `delivery_period`, must not be `None`")  # noqa: E501

        self._delivery_period = delivery_period

    @property
    def despatch_warehouse_id(self):
        """Gets the despatch_warehouse_id of this AcceptSupplyRequestLine.  # noqa: E501


        :return: The despatch_warehouse_id of this AcceptSupplyRequestLine.  # noqa: E501
        :rtype: str
        """
        return self._despatch_warehouse_id

    @despatch_warehouse_id.setter
    def despatch_warehouse_id(self, despatch_warehouse_id):
        """Sets the despatch_warehouse_id of this AcceptSupplyRequestLine.


        :param despatch_warehouse_id: The despatch_warehouse_id of this AcceptSupplyRequestLine.  # noqa: E501
        :type: str
        """
        if despatch_warehouse_id is None:
            raise ValueError("Invalid value for `despatch_warehouse_id`, must not be `None`")  # noqa: E501

        self._despatch_warehouse_id = despatch_warehouse_id

    @property
    def uses_catalog_availability(self):
        """Gets the uses_catalog_availability of this AcceptSupplyRequestLine.  # noqa: E501


        :return: The uses_catalog_availability of this AcceptSupplyRequestLine.  # noqa: E501
        :rtype: bool
        """
        return self._uses_catalog_availability

    @uses_catalog_availability.setter
    def uses_catalog_availability(self, uses_catalog_availability):
        """Sets the uses_catalog_availability of this AcceptSupplyRequestLine.


        :param uses_catalog_availability: The uses_catalog_availability of this AcceptSupplyRequestLine.  # noqa: E501
        :type: bool
        """
        if uses_catalog_availability is None:
            raise ValueError("Invalid value for `uses_catalog_availability`, must not be `None`")  # noqa: E501

        self._uses_catalog_availability = uses_catalog_availability

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AcceptSupplyRequestLine, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AcceptSupplyRequestLine):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
