# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AddBatch(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'batch_date': 'datetime',
        'batch_id': 'str',
        'trade_item_id': 'str',
        'number_of_pieces': 'int',
        'packing_configuration': 'AddBatchPackingConfiguration',
        'warehouse_id': 'str',
        'image_url': 'str',
        'batch_reference': 'str',
        'custom_reference': 'str',
        'transit_status': 'TransitStatus'
    }

    attribute_map = {
        'batch_date': 'batchDate',
        'batch_id': 'batchId',
        'trade_item_id': 'tradeItemId',
        'number_of_pieces': 'numberOfPieces',
        'packing_configuration': 'packingConfiguration',
        'warehouse_id': 'warehouseId',
        'image_url': 'imageUrl',
        'batch_reference': 'batchReference',
        'custom_reference': 'customReference',
        'transit_status': 'transitStatus'
    }

    def __init__(self, batch_date=None, batch_id=None, trade_item_id=None, number_of_pieces=None, packing_configuration=None, warehouse_id=None, image_url=None, batch_reference=None, custom_reference=None, transit_status=None):  # noqa: E501
        """AddBatch - a model defined in Swagger"""  # noqa: E501
        self._batch_date = None
        self._batch_id = None
        self._trade_item_id = None
        self._number_of_pieces = None
        self._packing_configuration = None
        self._warehouse_id = None
        self._image_url = None
        self._batch_reference = None
        self._custom_reference = None
        self._transit_status = None
        self.discriminator = None
        self.batch_date = batch_date
        self.batch_id = batch_id
        self.trade_item_id = trade_item_id
        self.number_of_pieces = number_of_pieces
        self.packing_configuration = packing_configuration
        self.warehouse_id = warehouse_id
        if image_url is not None:
            self.image_url = image_url
        if batch_reference is not None:
            self.batch_reference = batch_reference
        if custom_reference is not None:
            self.custom_reference = custom_reference
        if transit_status is not None:
            self.transit_status = transit_status

    @property
    def batch_date(self):
        """Gets the batch_date of this AddBatch.  # noqa: E501


        :return: The batch_date of this AddBatch.  # noqa: E501
        :rtype: datetime
        """
        return self._batch_date

    @batch_date.setter
    def batch_date(self, batch_date):
        """Sets the batch_date of this AddBatch.


        :param batch_date: The batch_date of this AddBatch.  # noqa: E501
        :type: datetime
        """
        if batch_date is None:
            raise ValueError("Invalid value for `batch_date`, must not be `None`")  # noqa: E501

        self._batch_date = batch_date

    @property
    def batch_id(self):
        """Gets the batch_id of this AddBatch.  # noqa: E501


        :return: The batch_id of this AddBatch.  # noqa: E501
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """Sets the batch_id of this AddBatch.


        :param batch_id: The batch_id of this AddBatch.  # noqa: E501
        :type: str
        """
        if batch_id is None:
            raise ValueError("Invalid value for `batch_id`, must not be `None`")  # noqa: E501

        self._batch_id = batch_id

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this AddBatch.  # noqa: E501


        :return: The trade_item_id of this AddBatch.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this AddBatch.


        :param trade_item_id: The trade_item_id of this AddBatch.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this AddBatch.  # noqa: E501


        :return: The number_of_pieces of this AddBatch.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this AddBatch.


        :param number_of_pieces: The number_of_pieces of this AddBatch.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def packing_configuration(self):
        """Gets the packing_configuration of this AddBatch.  # noqa: E501


        :return: The packing_configuration of this AddBatch.  # noqa: E501
        :rtype: AddBatchPackingConfiguration
        """
        return self._packing_configuration

    @packing_configuration.setter
    def packing_configuration(self, packing_configuration):
        """Sets the packing_configuration of this AddBatch.


        :param packing_configuration: The packing_configuration of this AddBatch.  # noqa: E501
        :type: AddBatchPackingConfiguration
        """
        if packing_configuration is None:
            raise ValueError("Invalid value for `packing_configuration`, must not be `None`")  # noqa: E501

        self._packing_configuration = packing_configuration

    @property
    def warehouse_id(self):
        """Gets the warehouse_id of this AddBatch.  # noqa: E501


        :return: The warehouse_id of this AddBatch.  # noqa: E501
        :rtype: str
        """
        return self._warehouse_id

    @warehouse_id.setter
    def warehouse_id(self, warehouse_id):
        """Sets the warehouse_id of this AddBatch.


        :param warehouse_id: The warehouse_id of this AddBatch.  # noqa: E501
        :type: str
        """
        if warehouse_id is None:
            raise ValueError("Invalid value for `warehouse_id`, must not be `None`")  # noqa: E501

        self._warehouse_id = warehouse_id

    @property
    def image_url(self):
        """Gets the image_url of this AddBatch.  # noqa: E501

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :return: The image_url of this AddBatch.  # noqa: E501
        :rtype: str
        """
        return self._image_url

    @image_url.setter
    def image_url(self, image_url):
        """Sets the image_url of this AddBatch.

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :param image_url: The image_url of this AddBatch.  # noqa: E501
        :type: str
        """

        self._image_url = image_url

    @property
    def batch_reference(self):
        """Gets the batch_reference of this AddBatch.  # noqa: E501


        :return: The batch_reference of this AddBatch.  # noqa: E501
        :rtype: str
        """
        return self._batch_reference

    @batch_reference.setter
    def batch_reference(self, batch_reference):
        """Sets the batch_reference of this AddBatch.


        :param batch_reference: The batch_reference of this AddBatch.  # noqa: E501
        :type: str
        """

        self._batch_reference = batch_reference

    @property
    def custom_reference(self):
        """Gets the custom_reference of this AddBatch.  # noqa: E501


        :return: The custom_reference of this AddBatch.  # noqa: E501
        :rtype: str
        """
        return self._custom_reference

    @custom_reference.setter
    def custom_reference(self, custom_reference):
        """Sets the custom_reference of this AddBatch.


        :param custom_reference: The custom_reference of this AddBatch.  # noqa: E501
        :type: str
        """

        self._custom_reference = custom_reference

    @property
    def transit_status(self):
        """Gets the transit_status of this AddBatch.  # noqa: E501


        :return: The transit_status of this AddBatch.  # noqa: E501
        :rtype: TransitStatus
        """
        return self._transit_status

    @transit_status.setter
    def transit_status(self, transit_status):
        """Sets the transit_status of this AddBatch.


        :param transit_status: The transit_status of this AddBatch.  # noqa: E501
        :type: TransitStatus
        """

        self._transit_status = transit_status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddBatch, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddBatch):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
