# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AddContractVersion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contract_id': 'str',
        'reason_for_version_update': 'str',
        'title': 'str',
        'description': 'str',
        'start_date_time': 'datetime',
        'end_date_time': 'datetime',
        'sub_supplier_organization_ids': 'list[str]',
        'allow_trade_item_variants': 'bool',
        'allow_automatic_blanket_order_approval': 'bool',
        'delivery': 'EditContractDelivery',
        'currency': 'Currency',
        'payment_provider': 'PaymentProvider',
        'contract_lines': 'list[EditContractLine]'
    }

    attribute_map = {
        'contract_id': 'contractId',
        'reason_for_version_update': 'reasonForVersionUpdate',
        'title': 'title',
        'description': 'description',
        'start_date_time': 'startDateTime',
        'end_date_time': 'endDateTime',
        'sub_supplier_organization_ids': 'subSupplierOrganizationIds',
        'allow_trade_item_variants': 'allowTradeItemVariants',
        'allow_automatic_blanket_order_approval': 'allowAutomaticBlanketOrderApproval',
        'delivery': 'delivery',
        'currency': 'currency',
        'payment_provider': 'paymentProvider',
        'contract_lines': 'contractLines'
    }

    def __init__(self, contract_id=None, reason_for_version_update=None, title=None, description=None, start_date_time=None, end_date_time=None, sub_supplier_organization_ids=None, allow_trade_item_variants=None, allow_automatic_blanket_order_approval=None, delivery=None, currency=None, payment_provider=None, contract_lines=None):  # noqa: E501
        """AddContractVersion - a model defined in Swagger"""  # noqa: E501
        self._contract_id = None
        self._reason_for_version_update = None
        self._title = None
        self._description = None
        self._start_date_time = None
        self._end_date_time = None
        self._sub_supplier_organization_ids = None
        self._allow_trade_item_variants = None
        self._allow_automatic_blanket_order_approval = None
        self._delivery = None
        self._currency = None
        self._payment_provider = None
        self._contract_lines = None
        self.discriminator = None
        self.contract_id = contract_id
        self.reason_for_version_update = reason_for_version_update
        self.title = title
        if description is not None:
            self.description = description
        self.start_date_time = start_date_time
        self.end_date_time = end_date_time
        if sub_supplier_organization_ids is not None:
            self.sub_supplier_organization_ids = sub_supplier_organization_ids
        self.allow_trade_item_variants = allow_trade_item_variants
        self.allow_automatic_blanket_order_approval = allow_automatic_blanket_order_approval
        self.delivery = delivery
        self.currency = currency
        self.payment_provider = payment_provider
        self.contract_lines = contract_lines

    @property
    def contract_id(self):
        """Gets the contract_id of this AddContractVersion.  # noqa: E501


        :return: The contract_id of this AddContractVersion.  # noqa: E501
        :rtype: str
        """
        return self._contract_id

    @contract_id.setter
    def contract_id(self, contract_id):
        """Sets the contract_id of this AddContractVersion.


        :param contract_id: The contract_id of this AddContractVersion.  # noqa: E501
        :type: str
        """
        if contract_id is None:
            raise ValueError("Invalid value for `contract_id`, must not be `None`")  # noqa: E501

        self._contract_id = contract_id

    @property
    def reason_for_version_update(self):
        """Gets the reason_for_version_update of this AddContractVersion.  # noqa: E501


        :return: The reason_for_version_update of this AddContractVersion.  # noqa: E501
        :rtype: str
        """
        return self._reason_for_version_update

    @reason_for_version_update.setter
    def reason_for_version_update(self, reason_for_version_update):
        """Sets the reason_for_version_update of this AddContractVersion.


        :param reason_for_version_update: The reason_for_version_update of this AddContractVersion.  # noqa: E501
        :type: str
        """
        if reason_for_version_update is None:
            raise ValueError("Invalid value for `reason_for_version_update`, must not be `None`")  # noqa: E501

        self._reason_for_version_update = reason_for_version_update

    @property
    def title(self):
        """Gets the title of this AddContractVersion.  # noqa: E501


        :return: The title of this AddContractVersion.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this AddContractVersion.


        :param title: The title of this AddContractVersion.  # noqa: E501
        :type: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def description(self):
        """Gets the description of this AddContractVersion.  # noqa: E501


        :return: The description of this AddContractVersion.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AddContractVersion.


        :param description: The description of this AddContractVersion.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def start_date_time(self):
        """Gets the start_date_time of this AddContractVersion.  # noqa: E501


        :return: The start_date_time of this AddContractVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._start_date_time

    @start_date_time.setter
    def start_date_time(self, start_date_time):
        """Sets the start_date_time of this AddContractVersion.


        :param start_date_time: The start_date_time of this AddContractVersion.  # noqa: E501
        :type: datetime
        """
        if start_date_time is None:
            raise ValueError("Invalid value for `start_date_time`, must not be `None`")  # noqa: E501

        self._start_date_time = start_date_time

    @property
    def end_date_time(self):
        """Gets the end_date_time of this AddContractVersion.  # noqa: E501


        :return: The end_date_time of this AddContractVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._end_date_time

    @end_date_time.setter
    def end_date_time(self, end_date_time):
        """Sets the end_date_time of this AddContractVersion.


        :param end_date_time: The end_date_time of this AddContractVersion.  # noqa: E501
        :type: datetime
        """
        if end_date_time is None:
            raise ValueError("Invalid value for `end_date_time`, must not be `None`")  # noqa: E501

        self._end_date_time = end_date_time

    @property
    def sub_supplier_organization_ids(self):
        """Gets the sub_supplier_organization_ids of this AddContractVersion.  # noqa: E501


        :return: The sub_supplier_organization_ids of this AddContractVersion.  # noqa: E501
        :rtype: list[str]
        """
        return self._sub_supplier_organization_ids

    @sub_supplier_organization_ids.setter
    def sub_supplier_organization_ids(self, sub_supplier_organization_ids):
        """Sets the sub_supplier_organization_ids of this AddContractVersion.


        :param sub_supplier_organization_ids: The sub_supplier_organization_ids of this AddContractVersion.  # noqa: E501
        :type: list[str]
        """

        self._sub_supplier_organization_ids = sub_supplier_organization_ids

    @property
    def allow_trade_item_variants(self):
        """Gets the allow_trade_item_variants of this AddContractVersion.  # noqa: E501

        Allow the use of variants from the chosen trade item when creating a blanket order.  # noqa: E501

        :return: The allow_trade_item_variants of this AddContractVersion.  # noqa: E501
        :rtype: bool
        """
        return self._allow_trade_item_variants

    @allow_trade_item_variants.setter
    def allow_trade_item_variants(self, allow_trade_item_variants):
        """Sets the allow_trade_item_variants of this AddContractVersion.

        Allow the use of variants from the chosen trade item when creating a blanket order.  # noqa: E501

        :param allow_trade_item_variants: The allow_trade_item_variants of this AddContractVersion.  # noqa: E501
        :type: bool
        """
        if allow_trade_item_variants is None:
            raise ValueError("Invalid value for `allow_trade_item_variants`, must not be `None`")  # noqa: E501

        self._allow_trade_item_variants = allow_trade_item_variants

    @property
    def allow_automatic_blanket_order_approval(self):
        """Gets the allow_automatic_blanket_order_approval of this AddContractVersion.  # noqa: E501


        :return: The allow_automatic_blanket_order_approval of this AddContractVersion.  # noqa: E501
        :rtype: bool
        """
        return self._allow_automatic_blanket_order_approval

    @allow_automatic_blanket_order_approval.setter
    def allow_automatic_blanket_order_approval(self, allow_automatic_blanket_order_approval):
        """Sets the allow_automatic_blanket_order_approval of this AddContractVersion.


        :param allow_automatic_blanket_order_approval: The allow_automatic_blanket_order_approval of this AddContractVersion.  # noqa: E501
        :type: bool
        """
        if allow_automatic_blanket_order_approval is None:
            raise ValueError("Invalid value for `allow_automatic_blanket_order_approval`, must not be `None`")  # noqa: E501

        self._allow_automatic_blanket_order_approval = allow_automatic_blanket_order_approval

    @property
    def delivery(self):
        """Gets the delivery of this AddContractVersion.  # noqa: E501


        :return: The delivery of this AddContractVersion.  # noqa: E501
        :rtype: EditContractDelivery
        """
        return self._delivery

    @delivery.setter
    def delivery(self, delivery):
        """Sets the delivery of this AddContractVersion.


        :param delivery: The delivery of this AddContractVersion.  # noqa: E501
        :type: EditContractDelivery
        """
        if delivery is None:
            raise ValueError("Invalid value for `delivery`, must not be `None`")  # noqa: E501

        self._delivery = delivery

    @property
    def currency(self):
        """Gets the currency of this AddContractVersion.  # noqa: E501


        :return: The currency of this AddContractVersion.  # noqa: E501
        :rtype: Currency
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this AddContractVersion.


        :param currency: The currency of this AddContractVersion.  # noqa: E501
        :type: Currency
        """
        if currency is None:
            raise ValueError("Invalid value for `currency`, must not be `None`")  # noqa: E501

        self._currency = currency

    @property
    def payment_provider(self):
        """Gets the payment_provider of this AddContractVersion.  # noqa: E501


        :return: The payment_provider of this AddContractVersion.  # noqa: E501
        :rtype: PaymentProvider
        """
        return self._payment_provider

    @payment_provider.setter
    def payment_provider(self, payment_provider):
        """Sets the payment_provider of this AddContractVersion.


        :param payment_provider: The payment_provider of this AddContractVersion.  # noqa: E501
        :type: PaymentProvider
        """
        if payment_provider is None:
            raise ValueError("Invalid value for `payment_provider`, must not be `None`")  # noqa: E501

        self._payment_provider = payment_provider

    @property
    def contract_lines(self):
        """Gets the contract_lines of this AddContractVersion.  # noqa: E501


        :return: The contract_lines of this AddContractVersion.  # noqa: E501
        :rtype: list[EditContractLine]
        """
        return self._contract_lines

    @contract_lines.setter
    def contract_lines(self, contract_lines):
        """Sets the contract_lines of this AddContractVersion.


        :param contract_lines: The contract_lines of this AddContractVersion.  # noqa: E501
        :type: list[EditContractLine]
        """
        if contract_lines is None:
            raise ValueError("Invalid value for `contract_lines`, must not be `None`")  # noqa: E501

        self._contract_lines = contract_lines

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddContractVersion, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddContractVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
