# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AddLoadCarrierConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'load_carrier_items': 'list[AddLoadCarrierItem]',
        'load_carrier_type': 'LoadCarrierType',
        'number_of_additional_layers': 'int',
        'sort_index': 'int',
        'load_carrier_reference': 'str'
    }

    attribute_map = {
        'load_carrier_items': 'loadCarrierItems',
        'load_carrier_type': 'loadCarrierType',
        'number_of_additional_layers': 'numberOfAdditionalLayers',
        'sort_index': 'sortIndex',
        'load_carrier_reference': 'loadCarrierReference'
    }

    def __init__(self, load_carrier_items=None, load_carrier_type=None, number_of_additional_layers=None, sort_index=None, load_carrier_reference=None):  # noqa: E501
        """AddLoadCarrierConfiguration - a model defined in Swagger"""  # noqa: E501
        self._load_carrier_items = None
        self._load_carrier_type = None
        self._number_of_additional_layers = None
        self._sort_index = None
        self._load_carrier_reference = None
        self.discriminator = None
        self.load_carrier_items = load_carrier_items
        self.load_carrier_type = load_carrier_type
        self.number_of_additional_layers = number_of_additional_layers
        self.sort_index = sort_index
        if load_carrier_reference is not None:
            self.load_carrier_reference = load_carrier_reference

    @property
    def load_carrier_items(self):
        """Gets the load_carrier_items of this AddLoadCarrierConfiguration.  # noqa: E501


        :return: The load_carrier_items of this AddLoadCarrierConfiguration.  # noqa: E501
        :rtype: list[AddLoadCarrierItem]
        """
        return self._load_carrier_items

    @load_carrier_items.setter
    def load_carrier_items(self, load_carrier_items):
        """Sets the load_carrier_items of this AddLoadCarrierConfiguration.


        :param load_carrier_items: The load_carrier_items of this AddLoadCarrierConfiguration.  # noqa: E501
        :type: list[AddLoadCarrierItem]
        """
        if load_carrier_items is None:
            raise ValueError("Invalid value for `load_carrier_items`, must not be `None`")  # noqa: E501

        self._load_carrier_items = load_carrier_items

    @property
    def load_carrier_type(self):
        """Gets the load_carrier_type of this AddLoadCarrierConfiguration.  # noqa: E501


        :return: The load_carrier_type of this AddLoadCarrierConfiguration.  # noqa: E501
        :rtype: LoadCarrierType
        """
        return self._load_carrier_type

    @load_carrier_type.setter
    def load_carrier_type(self, load_carrier_type):
        """Sets the load_carrier_type of this AddLoadCarrierConfiguration.


        :param load_carrier_type: The load_carrier_type of this AddLoadCarrierConfiguration.  # noqa: E501
        :type: LoadCarrierType
        """
        if load_carrier_type is None:
            raise ValueError("Invalid value for `load_carrier_type`, must not be `None`")  # noqa: E501

        self._load_carrier_type = load_carrier_type

    @property
    def number_of_additional_layers(self):
        """Gets the number_of_additional_layers of this AddLoadCarrierConfiguration.  # noqa: E501


        :return: The number_of_additional_layers of this AddLoadCarrierConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._number_of_additional_layers

    @number_of_additional_layers.setter
    def number_of_additional_layers(self, number_of_additional_layers):
        """Sets the number_of_additional_layers of this AddLoadCarrierConfiguration.


        :param number_of_additional_layers: The number_of_additional_layers of this AddLoadCarrierConfiguration.  # noqa: E501
        :type: int
        """
        if number_of_additional_layers is None:
            raise ValueError("Invalid value for `number_of_additional_layers`, must not be `None`")  # noqa: E501

        self._number_of_additional_layers = number_of_additional_layers

    @property
    def sort_index(self):
        """Gets the sort_index of this AddLoadCarrierConfiguration.  # noqa: E501

        Used to determine the position of the load carrier within the shipment. Duplicate numbers will yield indeterministic sequencing.  # noqa: E501

        :return: The sort_index of this AddLoadCarrierConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._sort_index

    @sort_index.setter
    def sort_index(self, sort_index):
        """Sets the sort_index of this AddLoadCarrierConfiguration.

        Used to determine the position of the load carrier within the shipment. Duplicate numbers will yield indeterministic sequencing.  # noqa: E501

        :param sort_index: The sort_index of this AddLoadCarrierConfiguration.  # noqa: E501
        :type: int
        """
        if sort_index is None:
            raise ValueError("Invalid value for `sort_index`, must not be `None`")  # noqa: E501

        self._sort_index = sort_index

    @property
    def load_carrier_reference(self):
        """Gets the load_carrier_reference of this AddLoadCarrierConfiguration.  # noqa: E501

        When present, uniquely references a load carrier within a collection of load carrier configurations; Appears on a PAB.  # noqa: E501

        :return: The load_carrier_reference of this AddLoadCarrierConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._load_carrier_reference

    @load_carrier_reference.setter
    def load_carrier_reference(self, load_carrier_reference):
        """Sets the load_carrier_reference of this AddLoadCarrierConfiguration.

        When present, uniquely references a load carrier within a collection of load carrier configurations; Appears on a PAB.  # noqa: E501

        :param load_carrier_reference: The load_carrier_reference of this AddLoadCarrierConfiguration.  # noqa: E501
        :type: str
        """

        self._load_carrier_reference = load_carrier_reference

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddLoadCarrierConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddLoadCarrierConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
