# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class AddLoadCarrierCorrection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'document_reference': 'str',
        'load_carrier_type': 'LoadCarrierType',
        'number_of_additional_layers': 'int',
        'load_carrier_item_corrections': 'list[AddLoadCarrierItemCorrection]'
    }

    attribute_map = {
        'document_reference': 'documentReference',
        'load_carrier_type': 'loadCarrierType',
        'number_of_additional_layers': 'numberOfAdditionalLayers',
        'load_carrier_item_corrections': 'loadCarrierItemCorrections'
    }

    def __init__(self, document_reference=None, load_carrier_type=None, number_of_additional_layers=None, load_carrier_item_corrections=None):  # noqa: E501
        """AddLoadCarrierCorrection - a model defined in Swagger"""  # noqa: E501
        self._document_reference = None
        self._load_carrier_type = None
        self._number_of_additional_layers = None
        self._load_carrier_item_corrections = None
        self.discriminator = None
        self.document_reference = document_reference
        self.load_carrier_type = load_carrier_type
        self.number_of_additional_layers = number_of_additional_layers
        if load_carrier_item_corrections is not None:
            self.load_carrier_item_corrections = load_carrier_item_corrections

    @property
    def document_reference(self):
        """Gets the document_reference of this AddLoadCarrierCorrection.  # noqa: E501


        :return: The document_reference of this AddLoadCarrierCorrection.  # noqa: E501
        :rtype: str
        """
        return self._document_reference

    @document_reference.setter
    def document_reference(self, document_reference):
        """Sets the document_reference of this AddLoadCarrierCorrection.


        :param document_reference: The document_reference of this AddLoadCarrierCorrection.  # noqa: E501
        :type: str
        """
        if document_reference is None:
            raise ValueError("Invalid value for `document_reference`, must not be `None`")  # noqa: E501

        self._document_reference = document_reference

    @property
    def load_carrier_type(self):
        """Gets the load_carrier_type of this AddLoadCarrierCorrection.  # noqa: E501


        :return: The load_carrier_type of this AddLoadCarrierCorrection.  # noqa: E501
        :rtype: LoadCarrierType
        """
        return self._load_carrier_type

    @load_carrier_type.setter
    def load_carrier_type(self, load_carrier_type):
        """Sets the load_carrier_type of this AddLoadCarrierCorrection.


        :param load_carrier_type: The load_carrier_type of this AddLoadCarrierCorrection.  # noqa: E501
        :type: LoadCarrierType
        """
        if load_carrier_type is None:
            raise ValueError("Invalid value for `load_carrier_type`, must not be `None`")  # noqa: E501

        self._load_carrier_type = load_carrier_type

    @property
    def number_of_additional_layers(self):
        """Gets the number_of_additional_layers of this AddLoadCarrierCorrection.  # noqa: E501


        :return: The number_of_additional_layers of this AddLoadCarrierCorrection.  # noqa: E501
        :rtype: int
        """
        return self._number_of_additional_layers

    @number_of_additional_layers.setter
    def number_of_additional_layers(self, number_of_additional_layers):
        """Sets the number_of_additional_layers of this AddLoadCarrierCorrection.


        :param number_of_additional_layers: The number_of_additional_layers of this AddLoadCarrierCorrection.  # noqa: E501
        :type: int
        """
        if number_of_additional_layers is None:
            raise ValueError("Invalid value for `number_of_additional_layers`, must not be `None`")  # noqa: E501

        self._number_of_additional_layers = number_of_additional_layers

    @property
    def load_carrier_item_corrections(self):
        """Gets the load_carrier_item_corrections of this AddLoadCarrierCorrection.  # noqa: E501


        :return: The load_carrier_item_corrections of this AddLoadCarrierCorrection.  # noqa: E501
        :rtype: list[AddLoadCarrierItemCorrection]
        """
        return self._load_carrier_item_corrections

    @load_carrier_item_corrections.setter
    def load_carrier_item_corrections(self, load_carrier_item_corrections):
        """Sets the load_carrier_item_corrections of this AddLoadCarrierCorrection.


        :param load_carrier_item_corrections: The load_carrier_item_corrections of this AddLoadCarrierCorrection.  # noqa: E501
        :type: list[AddLoadCarrierItemCorrection]
        """

        self._load_carrier_item_corrections = load_carrier_item_corrections

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AddLoadCarrierCorrection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddLoadCarrierCorrection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
