# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ClockSupplyLine(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'supply_line_id': 'str',
        'trade_item_id': 'str',
        'batch_id': 'str',
        'minimum_price_per_piece': 'Price',
        'minimum_order_quantity': 'Quantity',
        'number_of_pieces': 'int',
        'auction_date': 'date',
        'auction_location': 'AuctionLocation',
        'auction_group_code': 'int',
        'quality_group_code': 'str',
        'service_code': 'int',
        'delivery_note_code': 'str',
        'packing_configuration': 'ClockSupplyLinePackingConfiguration',
        'packing_agent_organization_id': 'str',
        'sequence_number': 'int',
        'creation_date_time': 'datetime',
        'last_modified_date_time': 'datetime',
        'clock_presales_supply_reference': 'str',
        'delivery_note_reference': 'str',
        'auction_status': 'AuctionStatusName',
        'is_deleted': 'bool'
    }

    attribute_map = {
        'supply_line_id': 'supplyLineId',
        'trade_item_id': 'tradeItemId',
        'batch_id': 'batchId',
        'minimum_price_per_piece': 'minimumPricePerPiece',
        'minimum_order_quantity': 'minimumOrderQuantity',
        'number_of_pieces': 'numberOfPieces',
        'auction_date': 'auctionDate',
        'auction_location': 'auctionLocation',
        'auction_group_code': 'auctionGroupCode',
        'quality_group_code': 'qualityGroupCode',
        'service_code': 'serviceCode',
        'delivery_note_code': 'deliveryNoteCode',
        'packing_configuration': 'packingConfiguration',
        'packing_agent_organization_id': 'packingAgentOrganizationId',
        'sequence_number': 'sequenceNumber',
        'creation_date_time': 'creationDateTime',
        'last_modified_date_time': 'lastModifiedDateTime',
        'clock_presales_supply_reference': 'clockPresalesSupplyReference',
        'delivery_note_reference': 'deliveryNoteReference',
        'auction_status': 'auctionStatus',
        'is_deleted': 'isDeleted'
    }

    def __init__(self, supply_line_id=None, trade_item_id=None, batch_id=None, minimum_price_per_piece=None, minimum_order_quantity=None, number_of_pieces=None, auction_date=None, auction_location=None, auction_group_code=None, quality_group_code=None, service_code=None, delivery_note_code=None, packing_configuration=None, packing_agent_organization_id=None, sequence_number=None, creation_date_time=None, last_modified_date_time=None, clock_presales_supply_reference=None, delivery_note_reference=None, auction_status=None, is_deleted=None):  # noqa: E501
        """ClockSupplyLine - a model defined in Swagger"""  # noqa: E501
        self._supply_line_id = None
        self._trade_item_id = None
        self._batch_id = None
        self._minimum_price_per_piece = None
        self._minimum_order_quantity = None
        self._number_of_pieces = None
        self._auction_date = None
        self._auction_location = None
        self._auction_group_code = None
        self._quality_group_code = None
        self._service_code = None
        self._delivery_note_code = None
        self._packing_configuration = None
        self._packing_agent_organization_id = None
        self._sequence_number = None
        self._creation_date_time = None
        self._last_modified_date_time = None
        self._clock_presales_supply_reference = None
        self._delivery_note_reference = None
        self._auction_status = None
        self._is_deleted = None
        self.discriminator = None
        self.supply_line_id = supply_line_id
        self.trade_item_id = trade_item_id
        self.batch_id = batch_id
        if minimum_price_per_piece is not None:
            self.minimum_price_per_piece = minimum_price_per_piece
        if minimum_order_quantity is not None:
            self.minimum_order_quantity = minimum_order_quantity
        self.number_of_pieces = number_of_pieces
        self.auction_date = auction_date
        self.auction_location = auction_location
        self.auction_group_code = auction_group_code
        self.quality_group_code = quality_group_code
        if service_code is not None:
            self.service_code = service_code
        if delivery_note_code is not None:
            self.delivery_note_code = delivery_note_code
        self.packing_configuration = packing_configuration
        if packing_agent_organization_id is not None:
            self.packing_agent_organization_id = packing_agent_organization_id
        self.sequence_number = sequence_number
        if creation_date_time is not None:
            self.creation_date_time = creation_date_time
        if last_modified_date_time is not None:
            self.last_modified_date_time = last_modified_date_time
        if clock_presales_supply_reference is not None:
            self.clock_presales_supply_reference = clock_presales_supply_reference
        if delivery_note_reference is not None:
            self.delivery_note_reference = delivery_note_reference
        if auction_status is not None:
            self.auction_status = auction_status
        self.is_deleted = is_deleted

    @property
    def supply_line_id(self):
        """Gets the supply_line_id of this ClockSupplyLine.  # noqa: E501


        :return: The supply_line_id of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._supply_line_id

    @supply_line_id.setter
    def supply_line_id(self, supply_line_id):
        """Sets the supply_line_id of this ClockSupplyLine.


        :param supply_line_id: The supply_line_id of this ClockSupplyLine.  # noqa: E501
        :type: str
        """
        if supply_line_id is None:
            raise ValueError("Invalid value for `supply_line_id`, must not be `None`")  # noqa: E501

        self._supply_line_id = supply_line_id

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this ClockSupplyLine.  # noqa: E501


        :return: The trade_item_id of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this ClockSupplyLine.


        :param trade_item_id: The trade_item_id of this ClockSupplyLine.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def batch_id(self):
        """Gets the batch_id of this ClockSupplyLine.  # noqa: E501


        :return: The batch_id of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """Sets the batch_id of this ClockSupplyLine.


        :param batch_id: The batch_id of this ClockSupplyLine.  # noqa: E501
        :type: str
        """
        if batch_id is None:
            raise ValueError("Invalid value for `batch_id`, must not be `None`")  # noqa: E501

        self._batch_id = batch_id

    @property
    def minimum_price_per_piece(self):
        """Gets the minimum_price_per_piece of this ClockSupplyLine.  # noqa: E501


        :return: The minimum_price_per_piece of this ClockSupplyLine.  # noqa: E501
        :rtype: Price
        """
        return self._minimum_price_per_piece

    @minimum_price_per_piece.setter
    def minimum_price_per_piece(self, minimum_price_per_piece):
        """Sets the minimum_price_per_piece of this ClockSupplyLine.


        :param minimum_price_per_piece: The minimum_price_per_piece of this ClockSupplyLine.  # noqa: E501
        :type: Price
        """

        self._minimum_price_per_piece = minimum_price_per_piece

    @property
    def minimum_order_quantity(self):
        """Gets the minimum_order_quantity of this ClockSupplyLine.  # noqa: E501


        :return: The minimum_order_quantity of this ClockSupplyLine.  # noqa: E501
        :rtype: Quantity
        """
        return self._minimum_order_quantity

    @minimum_order_quantity.setter
    def minimum_order_quantity(self, minimum_order_quantity):
        """Sets the minimum_order_quantity of this ClockSupplyLine.


        :param minimum_order_quantity: The minimum_order_quantity of this ClockSupplyLine.  # noqa: E501
        :type: Quantity
        """

        self._minimum_order_quantity = minimum_order_quantity

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this ClockSupplyLine.  # noqa: E501


        :return: The number_of_pieces of this ClockSupplyLine.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this ClockSupplyLine.


        :param number_of_pieces: The number_of_pieces of this ClockSupplyLine.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def auction_date(self):
        """Gets the auction_date of this ClockSupplyLine.  # noqa: E501


        :return: The auction_date of this ClockSupplyLine.  # noqa: E501
        :rtype: date
        """
        return self._auction_date

    @auction_date.setter
    def auction_date(self, auction_date):
        """Sets the auction_date of this ClockSupplyLine.


        :param auction_date: The auction_date of this ClockSupplyLine.  # noqa: E501
        :type: date
        """
        if auction_date is None:
            raise ValueError("Invalid value for `auction_date`, must not be `None`")  # noqa: E501

        self._auction_date = auction_date

    @property
    def auction_location(self):
        """Gets the auction_location of this ClockSupplyLine.  # noqa: E501


        :return: The auction_location of this ClockSupplyLine.  # noqa: E501
        :rtype: AuctionLocation
        """
        return self._auction_location

    @auction_location.setter
    def auction_location(self, auction_location):
        """Sets the auction_location of this ClockSupplyLine.


        :param auction_location: The auction_location of this ClockSupplyLine.  # noqa: E501
        :type: AuctionLocation
        """
        if auction_location is None:
            raise ValueError("Invalid value for `auction_location`, must not be `None`")  # noqa: E501

        self._auction_location = auction_location

    @property
    def auction_group_code(self):
        """Gets the auction_group_code of this ClockSupplyLine.  # noqa: E501


        :return: The auction_group_code of this ClockSupplyLine.  # noqa: E501
        :rtype: int
        """
        return self._auction_group_code

    @auction_group_code.setter
    def auction_group_code(self, auction_group_code):
        """Sets the auction_group_code of this ClockSupplyLine.


        :param auction_group_code: The auction_group_code of this ClockSupplyLine.  # noqa: E501
        :type: int
        """
        if auction_group_code is None:
            raise ValueError("Invalid value for `auction_group_code`, must not be `None`")  # noqa: E501

        self._auction_group_code = auction_group_code

    @property
    def quality_group_code(self):
        """Gets the quality_group_code of this ClockSupplyLine.  # noqa: E501


        :return: The quality_group_code of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._quality_group_code

    @quality_group_code.setter
    def quality_group_code(self, quality_group_code):
        """Sets the quality_group_code of this ClockSupplyLine.


        :param quality_group_code: The quality_group_code of this ClockSupplyLine.  # noqa: E501
        :type: str
        """
        if quality_group_code is None:
            raise ValueError("Invalid value for `quality_group_code`, must not be `None`")  # noqa: E501

        self._quality_group_code = quality_group_code

    @property
    def service_code(self):
        """Gets the service_code of this ClockSupplyLine.  # noqa: E501


        :return: The service_code of this ClockSupplyLine.  # noqa: E501
        :rtype: int
        """
        return self._service_code

    @service_code.setter
    def service_code(self, service_code):
        """Sets the service_code of this ClockSupplyLine.


        :param service_code: The service_code of this ClockSupplyLine.  # noqa: E501
        :type: int
        """

        self._service_code = service_code

    @property
    def delivery_note_code(self):
        """Gets the delivery_note_code of this ClockSupplyLine.  # noqa: E501


        :return: The delivery_note_code of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._delivery_note_code

    @delivery_note_code.setter
    def delivery_note_code(self, delivery_note_code):
        """Sets the delivery_note_code of this ClockSupplyLine.


        :param delivery_note_code: The delivery_note_code of this ClockSupplyLine.  # noqa: E501
        :type: str
        """

        self._delivery_note_code = delivery_note_code

    @property
    def packing_configuration(self):
        """Gets the packing_configuration of this ClockSupplyLine.  # noqa: E501


        :return: The packing_configuration of this ClockSupplyLine.  # noqa: E501
        :rtype: ClockSupplyLinePackingConfiguration
        """
        return self._packing_configuration

    @packing_configuration.setter
    def packing_configuration(self, packing_configuration):
        """Sets the packing_configuration of this ClockSupplyLine.


        :param packing_configuration: The packing_configuration of this ClockSupplyLine.  # noqa: E501
        :type: ClockSupplyLinePackingConfiguration
        """
        if packing_configuration is None:
            raise ValueError("Invalid value for `packing_configuration`, must not be `None`")  # noqa: E501

        self._packing_configuration = packing_configuration

    @property
    def packing_agent_organization_id(self):
        """Gets the packing_agent_organization_id of this ClockSupplyLine.  # noqa: E501


        :return: The packing_agent_organization_id of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._packing_agent_organization_id

    @packing_agent_organization_id.setter
    def packing_agent_organization_id(self, packing_agent_organization_id):
        """Sets the packing_agent_organization_id of this ClockSupplyLine.


        :param packing_agent_organization_id: The packing_agent_organization_id of this ClockSupplyLine.  # noqa: E501
        :type: str
        """

        self._packing_agent_organization_id = packing_agent_organization_id

    @property
    def sequence_number(self):
        """Gets the sequence_number of this ClockSupplyLine.  # noqa: E501


        :return: The sequence_number of this ClockSupplyLine.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this ClockSupplyLine.


        :param sequence_number: The sequence_number of this ClockSupplyLine.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    @property
    def creation_date_time(self):
        """Gets the creation_date_time of this ClockSupplyLine.  # noqa: E501


        :return: The creation_date_time of this ClockSupplyLine.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date_time

    @creation_date_time.setter
    def creation_date_time(self, creation_date_time):
        """Sets the creation_date_time of this ClockSupplyLine.


        :param creation_date_time: The creation_date_time of this ClockSupplyLine.  # noqa: E501
        :type: datetime
        """

        self._creation_date_time = creation_date_time

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this ClockSupplyLine.  # noqa: E501


        :return: The last_modified_date_time of this ClockSupplyLine.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this ClockSupplyLine.


        :param last_modified_date_time: The last_modified_date_time of this ClockSupplyLine.  # noqa: E501
        :type: datetime
        """

        self._last_modified_date_time = last_modified_date_time

    @property
    def clock_presales_supply_reference(self):
        """Gets the clock_presales_supply_reference of this ClockSupplyLine.  # noqa: E501


        :return: The clock_presales_supply_reference of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._clock_presales_supply_reference

    @clock_presales_supply_reference.setter
    def clock_presales_supply_reference(self, clock_presales_supply_reference):
        """Sets the clock_presales_supply_reference of this ClockSupplyLine.


        :param clock_presales_supply_reference: The clock_presales_supply_reference of this ClockSupplyLine.  # noqa: E501
        :type: str
        """

        self._clock_presales_supply_reference = clock_presales_supply_reference

    @property
    def delivery_note_reference(self):
        """Gets the delivery_note_reference of this ClockSupplyLine.  # noqa: E501

        DeliveryNoteCode + letter of the original clock delivery  # noqa: E501

        :return: The delivery_note_reference of this ClockSupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._delivery_note_reference

    @delivery_note_reference.setter
    def delivery_note_reference(self, delivery_note_reference):
        """Sets the delivery_note_reference of this ClockSupplyLine.

        DeliveryNoteCode + letter of the original clock delivery  # noqa: E501

        :param delivery_note_reference: The delivery_note_reference of this ClockSupplyLine.  # noqa: E501
        :type: str
        """

        self._delivery_note_reference = delivery_note_reference

    @property
    def auction_status(self):
        """Gets the auction_status of this ClockSupplyLine.  # noqa: E501


        :return: The auction_status of this ClockSupplyLine.  # noqa: E501
        :rtype: AuctionStatusName
        """
        return self._auction_status

    @auction_status.setter
    def auction_status(self, auction_status):
        """Sets the auction_status of this ClockSupplyLine.


        :param auction_status: The auction_status of this ClockSupplyLine.  # noqa: E501
        :type: AuctionStatusName
        """

        self._auction_status = auction_status

    @property
    def is_deleted(self):
        """Gets the is_deleted of this ClockSupplyLine.  # noqa: E501


        :return: The is_deleted of this ClockSupplyLine.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this ClockSupplyLine.


        :param is_deleted: The is_deleted of this ClockSupplyLine.  # noqa: E501
        :type: bool
        """
        if is_deleted is None:
            raise ValueError("Invalid value for `is_deleted`, must not be `None`")  # noqa: E501

        self._is_deleted = is_deleted

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClockSupplyLine, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClockSupplyLine):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
