# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Collection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'collection_id': 'str',
        'name': 'str',
        'description': 'str',
        'image_url': 'str',
        'trade_items': 'list[str]',
        'sort_order': 'int',
        'is_active': 'bool',
        'sequence_number': 'int'
    }

    attribute_map = {
        'collection_id': 'collectionId',
        'name': 'name',
        'description': 'description',
        'image_url': 'imageUrl',
        'trade_items': 'tradeItems',
        'sort_order': 'sortOrder',
        'is_active': 'isActive',
        'sequence_number': 'sequenceNumber'
    }

    def __init__(self, collection_id=None, name=None, description=None, image_url=None, trade_items=None, sort_order=None, is_active=None, sequence_number=None):  # noqa: E501
        """Collection - a model defined in Swagger"""  # noqa: E501
        self._collection_id = None
        self._name = None
        self._description = None
        self._image_url = None
        self._trade_items = None
        self._sort_order = None
        self._is_active = None
        self._sequence_number = None
        self.discriminator = None
        self.collection_id = collection_id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if image_url is not None:
            self.image_url = image_url
        if trade_items is not None:
            self.trade_items = trade_items
        if sort_order is not None:
            self.sort_order = sort_order
        if is_active is not None:
            self.is_active = is_active
        self.sequence_number = sequence_number

    @property
    def collection_id(self):
        """Gets the collection_id of this Collection.  # noqa: E501


        :return: The collection_id of this Collection.  # noqa: E501
        :rtype: str
        """
        return self._collection_id

    @collection_id.setter
    def collection_id(self, collection_id):
        """Sets the collection_id of this Collection.


        :param collection_id: The collection_id of this Collection.  # noqa: E501
        :type: str
        """
        if collection_id is None:
            raise ValueError("Invalid value for `collection_id`, must not be `None`")  # noqa: E501

        self._collection_id = collection_id

    @property
    def name(self):
        """Gets the name of this Collection.  # noqa: E501


        :return: The name of this Collection.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Collection.


        :param name: The name of this Collection.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this Collection.  # noqa: E501


        :return: The description of this Collection.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Collection.


        :param description: The description of this Collection.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def image_url(self):
        """Gets the image_url of this Collection.  # noqa: E501


        :return: The image_url of this Collection.  # noqa: E501
        :rtype: str
        """
        return self._image_url

    @image_url.setter
    def image_url(self, image_url):
        """Sets the image_url of this Collection.


        :param image_url: The image_url of this Collection.  # noqa: E501
        :type: str
        """

        self._image_url = image_url

    @property
    def trade_items(self):
        """Gets the trade_items of this Collection.  # noqa: E501


        :return: The trade_items of this Collection.  # noqa: E501
        :rtype: list[str]
        """
        return self._trade_items

    @trade_items.setter
    def trade_items(self, trade_items):
        """Sets the trade_items of this Collection.


        :param trade_items: The trade_items of this Collection.  # noqa: E501
        :type: list[str]
        """

        self._trade_items = trade_items

    @property
    def sort_order(self):
        """Gets the sort_order of this Collection.  # noqa: E501


        :return: The sort_order of this Collection.  # noqa: E501
        :rtype: int
        """
        return self._sort_order

    @sort_order.setter
    def sort_order(self, sort_order):
        """Sets the sort_order of this Collection.


        :param sort_order: The sort_order of this Collection.  # noqa: E501
        :type: int
        """

        self._sort_order = sort_order

    @property
    def is_active(self):
        """Gets the is_active of this Collection.  # noqa: E501


        :return: The is_active of this Collection.  # noqa: E501
        :rtype: bool
        """
        return self._is_active

    @is_active.setter
    def is_active(self, is_active):
        """Sets the is_active of this Collection.


        :param is_active: The is_active of this Collection.  # noqa: E501
        :type: bool
        """

        self._is_active = is_active

    @property
    def sequence_number(self):
        """Gets the sequence_number of this Collection.  # noqa: E501


        :return: The sequence_number of this Collection.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this Collection.


        :param sequence_number: The sequence_number of this Collection.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Collection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Collection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
