# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CombineAndTransformBatchesRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'batches_to_combine': 'list[BatchToCombine]',
        'new_batch_id': 'str',
        'trade_item_id': 'str',
        'number_of_pieces': 'int',
        'packing_configuration': 'TransformBatchRequestPackingConfiguration',
        'custom_reference': 'str',
        'image_url': 'str'
    }

    attribute_map = {
        'batches_to_combine': 'batchesToCombine',
        'new_batch_id': 'newBatchId',
        'trade_item_id': 'tradeItemId',
        'number_of_pieces': 'numberOfPieces',
        'packing_configuration': 'packingConfiguration',
        'custom_reference': 'customReference',
        'image_url': 'imageUrl'
    }

    def __init__(self, batches_to_combine=None, new_batch_id=None, trade_item_id=None, number_of_pieces=None, packing_configuration=None, custom_reference=None, image_url=None):  # noqa: E501
        """CombineAndTransformBatchesRequest - a model defined in Swagger"""  # noqa: E501
        self._batches_to_combine = None
        self._new_batch_id = None
        self._trade_item_id = None
        self._number_of_pieces = None
        self._packing_configuration = None
        self._custom_reference = None
        self._image_url = None
        self.discriminator = None
        self.batches_to_combine = batches_to_combine
        self.new_batch_id = new_batch_id
        self.trade_item_id = trade_item_id
        self.number_of_pieces = number_of_pieces
        self.packing_configuration = packing_configuration
        if custom_reference is not None:
            self.custom_reference = custom_reference
        if image_url is not None:
            self.image_url = image_url

    @property
    def batches_to_combine(self):
        """Gets the batches_to_combine of this CombineAndTransformBatchesRequest.  # noqa: E501


        :return: The batches_to_combine of this CombineAndTransformBatchesRequest.  # noqa: E501
        :rtype: list[BatchToCombine]
        """
        return self._batches_to_combine

    @batches_to_combine.setter
    def batches_to_combine(self, batches_to_combine):
        """Sets the batches_to_combine of this CombineAndTransformBatchesRequest.


        :param batches_to_combine: The batches_to_combine of this CombineAndTransformBatchesRequest.  # noqa: E501
        :type: list[BatchToCombine]
        """
        if batches_to_combine is None:
            raise ValueError("Invalid value for `batches_to_combine`, must not be `None`")  # noqa: E501

        self._batches_to_combine = batches_to_combine

    @property
    def new_batch_id(self):
        """Gets the new_batch_id of this CombineAndTransformBatchesRequest.  # noqa: E501


        :return: The new_batch_id of this CombineAndTransformBatchesRequest.  # noqa: E501
        :rtype: str
        """
        return self._new_batch_id

    @new_batch_id.setter
    def new_batch_id(self, new_batch_id):
        """Sets the new_batch_id of this CombineAndTransformBatchesRequest.


        :param new_batch_id: The new_batch_id of this CombineAndTransformBatchesRequest.  # noqa: E501
        :type: str
        """
        if new_batch_id is None:
            raise ValueError("Invalid value for `new_batch_id`, must not be `None`")  # noqa: E501

        self._new_batch_id = new_batch_id

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this CombineAndTransformBatchesRequest.  # noqa: E501


        :return: The trade_item_id of this CombineAndTransformBatchesRequest.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this CombineAndTransformBatchesRequest.


        :param trade_item_id: The trade_item_id of this CombineAndTransformBatchesRequest.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this CombineAndTransformBatchesRequest.  # noqa: E501


        :return: The number_of_pieces of this CombineAndTransformBatchesRequest.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this CombineAndTransformBatchesRequest.


        :param number_of_pieces: The number_of_pieces of this CombineAndTransformBatchesRequest.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def packing_configuration(self):
        """Gets the packing_configuration of this CombineAndTransformBatchesRequest.  # noqa: E501


        :return: The packing_configuration of this CombineAndTransformBatchesRequest.  # noqa: E501
        :rtype: TransformBatchRequestPackingConfiguration
        """
        return self._packing_configuration

    @packing_configuration.setter
    def packing_configuration(self, packing_configuration):
        """Sets the packing_configuration of this CombineAndTransformBatchesRequest.


        :param packing_configuration: The packing_configuration of this CombineAndTransformBatchesRequest.  # noqa: E501
        :type: TransformBatchRequestPackingConfiguration
        """
        if packing_configuration is None:
            raise ValueError("Invalid value for `packing_configuration`, must not be `None`")  # noqa: E501

        self._packing_configuration = packing_configuration

    @property
    def custom_reference(self):
        """Gets the custom_reference of this CombineAndTransformBatchesRequest.  # noqa: E501


        :return: The custom_reference of this CombineAndTransformBatchesRequest.  # noqa: E501
        :rtype: str
        """
        return self._custom_reference

    @custom_reference.setter
    def custom_reference(self, custom_reference):
        """Sets the custom_reference of this CombineAndTransformBatchesRequest.


        :param custom_reference: The custom_reference of this CombineAndTransformBatchesRequest.  # noqa: E501
        :type: str
        """

        self._custom_reference = custom_reference

    @property
    def image_url(self):
        """Gets the image_url of this CombineAndTransformBatchesRequest.  # noqa: E501

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :return: The image_url of this CombineAndTransformBatchesRequest.  # noqa: E501
        :rtype: str
        """
        return self._image_url

    @image_url.setter
    def image_url(self, image_url):
        """Sets the image_url of this CombineAndTransformBatchesRequest.

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :param image_url: The image_url of this CombineAndTransformBatchesRequest.  # noqa: E501
        :type: str
        """

        self._image_url = image_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CombineAndTransformBatchesRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CombineAndTransformBatchesRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
