# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ContinuousStock(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'available': 'bool',
        'excluded_customer_organization_ids': 'list[str]',
        'warehouse_id': 'str'
    }

    attribute_map = {
        'available': 'available',
        'excluded_customer_organization_ids': 'excludedCustomerOrganizationIds',
        'warehouse_id': 'warehouseId'
    }

    def __init__(self, available=None, excluded_customer_organization_ids=None, warehouse_id=None):  # noqa: E501
        """ContinuousStock - a model defined in Swagger"""  # noqa: E501
        self._available = None
        self._excluded_customer_organization_ids = None
        self._warehouse_id = None
        self.discriminator = None
        self.available = available
        if excluded_customer_organization_ids is not None:
            self.excluded_customer_organization_ids = excluded_customer_organization_ids
        if warehouse_id is not None:
            self.warehouse_id = warehouse_id

    @property
    def available(self):
        """Gets the available of this ContinuousStock.  # noqa: E501


        :return: The available of this ContinuousStock.  # noqa: E501
        :rtype: bool
        """
        return self._available

    @available.setter
    def available(self, available):
        """Sets the available of this ContinuousStock.


        :param available: The available of this ContinuousStock.  # noqa: E501
        :type: bool
        """
        if available is None:
            raise ValueError("Invalid value for `available`, must not be `None`")  # noqa: E501

        self._available = available

    @property
    def excluded_customer_organization_ids(self):
        """Gets the excluded_customer_organization_ids of this ContinuousStock.  # noqa: E501


        :return: The excluded_customer_organization_ids of this ContinuousStock.  # noqa: E501
        :rtype: list[str]
        """
        return self._excluded_customer_organization_ids

    @excluded_customer_organization_ids.setter
    def excluded_customer_organization_ids(self, excluded_customer_organization_ids):
        """Sets the excluded_customer_organization_ids of this ContinuousStock.


        :param excluded_customer_organization_ids: The excluded_customer_organization_ids of this ContinuousStock.  # noqa: E501
        :type: list[str]
        """

        self._excluded_customer_organization_ids = excluded_customer_organization_ids

    @property
    def warehouse_id(self):
        """Gets the warehouse_id of this ContinuousStock.  # noqa: E501


        :return: The warehouse_id of this ContinuousStock.  # noqa: E501
        :rtype: str
        """
        return self._warehouse_id

    @warehouse_id.setter
    def warehouse_id(self, warehouse_id):
        """Sets the warehouse_id of this ContinuousStock.


        :param warehouse_id: The warehouse_id of this ContinuousStock.  # noqa: E501
        :type: str
        """

        self._warehouse_id = warehouse_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContinuousStock, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContinuousStock):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
