# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Contract(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contract_id': 'str',
        'reference': 'str',
        'title': 'str',
        'description': 'str',
        'start_date_time': 'datetime',
        'end_date_time': 'datetime',
        'customer_organization_id': 'str',
        'supplier_organization_id': 'str',
        'sub_supplier_organization_ids': 'list[str]',
        'contract_period_kind': 'ContractPeriodKind',
        'is_initiated_by_supplier': 'bool',
        'allow_trade_item_variants': 'bool',
        'allow_automatic_blanket_order_approval': 'bool',
        'version': 'ContractVersion',
        'status': 'ContractStatus',
        'delivery': 'ContractDelivery',
        'currency': 'Currency',
        'payment_provider': 'PaymentProvider',
        'creation_date_time': 'datetime',
        'last_modified_date_time': 'datetime',
        'contract_lines': 'list[ContractLine]',
        'attachment_details': 'list[AttachmentDetail]',
        'sequence_number': 'int'
    }

    attribute_map = {
        'contract_id': 'contractId',
        'reference': 'reference',
        'title': 'title',
        'description': 'description',
        'start_date_time': 'startDateTime',
        'end_date_time': 'endDateTime',
        'customer_organization_id': 'customerOrganizationId',
        'supplier_organization_id': 'supplierOrganizationId',
        'sub_supplier_organization_ids': 'subSupplierOrganizationIds',
        'contract_period_kind': 'contractPeriodKind',
        'is_initiated_by_supplier': 'isInitiatedBySupplier',
        'allow_trade_item_variants': 'allowTradeItemVariants',
        'allow_automatic_blanket_order_approval': 'allowAutomaticBlanketOrderApproval',
        'version': 'version',
        'status': 'status',
        'delivery': 'delivery',
        'currency': 'currency',
        'payment_provider': 'paymentProvider',
        'creation_date_time': 'creationDateTime',
        'last_modified_date_time': 'lastModifiedDateTime',
        'contract_lines': 'contractLines',
        'attachment_details': 'attachmentDetails',
        'sequence_number': 'sequenceNumber'
    }

    def __init__(self, contract_id=None, reference=None, title=None, description=None, start_date_time=None, end_date_time=None, customer_organization_id=None, supplier_organization_id=None, sub_supplier_organization_ids=None, contract_period_kind=None, is_initiated_by_supplier=None, allow_trade_item_variants=None, allow_automatic_blanket_order_approval=None, version=None, status=None, delivery=None, currency=None, payment_provider=None, creation_date_time=None, last_modified_date_time=None, contract_lines=None, attachment_details=None, sequence_number=None):  # noqa: E501
        """Contract - a model defined in Swagger"""  # noqa: E501
        self._contract_id = None
        self._reference = None
        self._title = None
        self._description = None
        self._start_date_time = None
        self._end_date_time = None
        self._customer_organization_id = None
        self._supplier_organization_id = None
        self._sub_supplier_organization_ids = None
        self._contract_period_kind = None
        self._is_initiated_by_supplier = None
        self._allow_trade_item_variants = None
        self._allow_automatic_blanket_order_approval = None
        self._version = None
        self._status = None
        self._delivery = None
        self._currency = None
        self._payment_provider = None
        self._creation_date_time = None
        self._last_modified_date_time = None
        self._contract_lines = None
        self._attachment_details = None
        self._sequence_number = None
        self.discriminator = None
        self.contract_id = contract_id
        self.reference = reference
        self.title = title
        if description is not None:
            self.description = description
        self.start_date_time = start_date_time
        self.end_date_time = end_date_time
        self.customer_organization_id = customer_organization_id
        self.supplier_organization_id = supplier_organization_id
        if sub_supplier_organization_ids is not None:
            self.sub_supplier_organization_ids = sub_supplier_organization_ids
        self.contract_period_kind = contract_period_kind
        self.is_initiated_by_supplier = is_initiated_by_supplier
        self.allow_trade_item_variants = allow_trade_item_variants
        self.allow_automatic_blanket_order_approval = allow_automatic_blanket_order_approval
        self.version = version
        self.status = status
        self.delivery = delivery
        self.currency = currency
        self.payment_provider = payment_provider
        self.creation_date_time = creation_date_time
        self.last_modified_date_time = last_modified_date_time
        self.contract_lines = contract_lines
        if attachment_details is not None:
            self.attachment_details = attachment_details
        self.sequence_number = sequence_number

    @property
    def contract_id(self):
        """Gets the contract_id of this Contract.  # noqa: E501


        :return: The contract_id of this Contract.  # noqa: E501
        :rtype: str
        """
        return self._contract_id

    @contract_id.setter
    def contract_id(self, contract_id):
        """Sets the contract_id of this Contract.


        :param contract_id: The contract_id of this Contract.  # noqa: E501
        :type: str
        """
        if contract_id is None:
            raise ValueError("Invalid value for `contract_id`, must not be `None`")  # noqa: E501

        self._contract_id = contract_id

    @property
    def reference(self):
        """Gets the reference of this Contract.  # noqa: E501

        The reference of a contract remains the same between the different versions.  # noqa: E501

        :return: The reference of this Contract.  # noqa: E501
        :rtype: str
        """
        return self._reference

    @reference.setter
    def reference(self, reference):
        """Sets the reference of this Contract.

        The reference of a contract remains the same between the different versions.  # noqa: E501

        :param reference: The reference of this Contract.  # noqa: E501
        :type: str
        """
        if reference is None:
            raise ValueError("Invalid value for `reference`, must not be `None`")  # noqa: E501

        self._reference = reference

    @property
    def title(self):
        """Gets the title of this Contract.  # noqa: E501


        :return: The title of this Contract.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this Contract.


        :param title: The title of this Contract.  # noqa: E501
        :type: str
        """
        if title is None:
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def description(self):
        """Gets the description of this Contract.  # noqa: E501


        :return: The description of this Contract.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Contract.


        :param description: The description of this Contract.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def start_date_time(self):
        """Gets the start_date_time of this Contract.  # noqa: E501


        :return: The start_date_time of this Contract.  # noqa: E501
        :rtype: datetime
        """
        return self._start_date_time

    @start_date_time.setter
    def start_date_time(self, start_date_time):
        """Sets the start_date_time of this Contract.


        :param start_date_time: The start_date_time of this Contract.  # noqa: E501
        :type: datetime
        """
        if start_date_time is None:
            raise ValueError("Invalid value for `start_date_time`, must not be `None`")  # noqa: E501

        self._start_date_time = start_date_time

    @property
    def end_date_time(self):
        """Gets the end_date_time of this Contract.  # noqa: E501


        :return: The end_date_time of this Contract.  # noqa: E501
        :rtype: datetime
        """
        return self._end_date_time

    @end_date_time.setter
    def end_date_time(self, end_date_time):
        """Sets the end_date_time of this Contract.


        :param end_date_time: The end_date_time of this Contract.  # noqa: E501
        :type: datetime
        """
        if end_date_time is None:
            raise ValueError("Invalid value for `end_date_time`, must not be `None`")  # noqa: E501

        self._end_date_time = end_date_time

    @property
    def customer_organization_id(self):
        """Gets the customer_organization_id of this Contract.  # noqa: E501


        :return: The customer_organization_id of this Contract.  # noqa: E501
        :rtype: str
        """
        return self._customer_organization_id

    @customer_organization_id.setter
    def customer_organization_id(self, customer_organization_id):
        """Sets the customer_organization_id of this Contract.


        :param customer_organization_id: The customer_organization_id of this Contract.  # noqa: E501
        :type: str
        """
        if customer_organization_id is None:
            raise ValueError("Invalid value for `customer_organization_id`, must not be `None`")  # noqa: E501

        self._customer_organization_id = customer_organization_id

    @property
    def supplier_organization_id(self):
        """Gets the supplier_organization_id of this Contract.  # noqa: E501


        :return: The supplier_organization_id of this Contract.  # noqa: E501
        :rtype: str
        """
        return self._supplier_organization_id

    @supplier_organization_id.setter
    def supplier_organization_id(self, supplier_organization_id):
        """Sets the supplier_organization_id of this Contract.


        :param supplier_organization_id: The supplier_organization_id of this Contract.  # noqa: E501
        :type: str
        """
        if supplier_organization_id is None:
            raise ValueError("Invalid value for `supplier_organization_id`, must not be `None`")  # noqa: E501

        self._supplier_organization_id = supplier_organization_id

    @property
    def sub_supplier_organization_ids(self):
        """Gets the sub_supplier_organization_ids of this Contract.  # noqa: E501


        :return: The sub_supplier_organization_ids of this Contract.  # noqa: E501
        :rtype: list[str]
        """
        return self._sub_supplier_organization_ids

    @sub_supplier_organization_ids.setter
    def sub_supplier_organization_ids(self, sub_supplier_organization_ids):
        """Sets the sub_supplier_organization_ids of this Contract.


        :param sub_supplier_organization_ids: The sub_supplier_organization_ids of this Contract.  # noqa: E501
        :type: list[str]
        """

        self._sub_supplier_organization_ids = sub_supplier_organization_ids

    @property
    def contract_period_kind(self):
        """Gets the contract_period_kind of this Contract.  # noqa: E501


        :return: The contract_period_kind of this Contract.  # noqa: E501
        :rtype: ContractPeriodKind
        """
        return self._contract_period_kind

    @contract_period_kind.setter
    def contract_period_kind(self, contract_period_kind):
        """Sets the contract_period_kind of this Contract.


        :param contract_period_kind: The contract_period_kind of this Contract.  # noqa: E501
        :type: ContractPeriodKind
        """
        if contract_period_kind is None:
            raise ValueError("Invalid value for `contract_period_kind`, must not be `None`")  # noqa: E501

        self._contract_period_kind = contract_period_kind

    @property
    def is_initiated_by_supplier(self):
        """Gets the is_initiated_by_supplier of this Contract.  # noqa: E501


        :return: The is_initiated_by_supplier of this Contract.  # noqa: E501
        :rtype: bool
        """
        return self._is_initiated_by_supplier

    @is_initiated_by_supplier.setter
    def is_initiated_by_supplier(self, is_initiated_by_supplier):
        """Sets the is_initiated_by_supplier of this Contract.


        :param is_initiated_by_supplier: The is_initiated_by_supplier of this Contract.  # noqa: E501
        :type: bool
        """
        if is_initiated_by_supplier is None:
            raise ValueError("Invalid value for `is_initiated_by_supplier`, must not be `None`")  # noqa: E501

        self._is_initiated_by_supplier = is_initiated_by_supplier

    @property
    def allow_trade_item_variants(self):
        """Gets the allow_trade_item_variants of this Contract.  # noqa: E501

        Allow the use of variants from the chosen trade item when creating a blanket order.  # noqa: E501

        :return: The allow_trade_item_variants of this Contract.  # noqa: E501
        :rtype: bool
        """
        return self._allow_trade_item_variants

    @allow_trade_item_variants.setter
    def allow_trade_item_variants(self, allow_trade_item_variants):
        """Sets the allow_trade_item_variants of this Contract.

        Allow the use of variants from the chosen trade item when creating a blanket order.  # noqa: E501

        :param allow_trade_item_variants: The allow_trade_item_variants of this Contract.  # noqa: E501
        :type: bool
        """
        if allow_trade_item_variants is None:
            raise ValueError("Invalid value for `allow_trade_item_variants`, must not be `None`")  # noqa: E501

        self._allow_trade_item_variants = allow_trade_item_variants

    @property
    def allow_automatic_blanket_order_approval(self):
        """Gets the allow_automatic_blanket_order_approval of this Contract.  # noqa: E501


        :return: The allow_automatic_blanket_order_approval of this Contract.  # noqa: E501
        :rtype: bool
        """
        return self._allow_automatic_blanket_order_approval

    @allow_automatic_blanket_order_approval.setter
    def allow_automatic_blanket_order_approval(self, allow_automatic_blanket_order_approval):
        """Sets the allow_automatic_blanket_order_approval of this Contract.


        :param allow_automatic_blanket_order_approval: The allow_automatic_blanket_order_approval of this Contract.  # noqa: E501
        :type: bool
        """
        if allow_automatic_blanket_order_approval is None:
            raise ValueError("Invalid value for `allow_automatic_blanket_order_approval`, must not be `None`")  # noqa: E501

        self._allow_automatic_blanket_order_approval = allow_automatic_blanket_order_approval

    @property
    def version(self):
        """Gets the version of this Contract.  # noqa: E501


        :return: The version of this Contract.  # noqa: E501
        :rtype: ContractVersion
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this Contract.


        :param version: The version of this Contract.  # noqa: E501
        :type: ContractVersion
        """
        if version is None:
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def status(self):
        """Gets the status of this Contract.  # noqa: E501


        :return: The status of this Contract.  # noqa: E501
        :rtype: ContractStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Contract.


        :param status: The status of this Contract.  # noqa: E501
        :type: ContractStatus
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def delivery(self):
        """Gets the delivery of this Contract.  # noqa: E501


        :return: The delivery of this Contract.  # noqa: E501
        :rtype: ContractDelivery
        """
        return self._delivery

    @delivery.setter
    def delivery(self, delivery):
        """Sets the delivery of this Contract.


        :param delivery: The delivery of this Contract.  # noqa: E501
        :type: ContractDelivery
        """
        if delivery is None:
            raise ValueError("Invalid value for `delivery`, must not be `None`")  # noqa: E501

        self._delivery = delivery

    @property
    def currency(self):
        """Gets the currency of this Contract.  # noqa: E501


        :return: The currency of this Contract.  # noqa: E501
        :rtype: Currency
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this Contract.


        :param currency: The currency of this Contract.  # noqa: E501
        :type: Currency
        """
        if currency is None:
            raise ValueError("Invalid value for `currency`, must not be `None`")  # noqa: E501

        self._currency = currency

    @property
    def payment_provider(self):
        """Gets the payment_provider of this Contract.  # noqa: E501


        :return: The payment_provider of this Contract.  # noqa: E501
        :rtype: PaymentProvider
        """
        return self._payment_provider

    @payment_provider.setter
    def payment_provider(self, payment_provider):
        """Sets the payment_provider of this Contract.


        :param payment_provider: The payment_provider of this Contract.  # noqa: E501
        :type: PaymentProvider
        """
        if payment_provider is None:
            raise ValueError("Invalid value for `payment_provider`, must not be `None`")  # noqa: E501

        self._payment_provider = payment_provider

    @property
    def creation_date_time(self):
        """Gets the creation_date_time of this Contract.  # noqa: E501


        :return: The creation_date_time of this Contract.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date_time

    @creation_date_time.setter
    def creation_date_time(self, creation_date_time):
        """Sets the creation_date_time of this Contract.


        :param creation_date_time: The creation_date_time of this Contract.  # noqa: E501
        :type: datetime
        """
        if creation_date_time is None:
            raise ValueError("Invalid value for `creation_date_time`, must not be `None`")  # noqa: E501

        self._creation_date_time = creation_date_time

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this Contract.  # noqa: E501


        :return: The last_modified_date_time of this Contract.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this Contract.


        :param last_modified_date_time: The last_modified_date_time of this Contract.  # noqa: E501
        :type: datetime
        """
        if last_modified_date_time is None:
            raise ValueError("Invalid value for `last_modified_date_time`, must not be `None`")  # noqa: E501

        self._last_modified_date_time = last_modified_date_time

    @property
    def contract_lines(self):
        """Gets the contract_lines of this Contract.  # noqa: E501


        :return: The contract_lines of this Contract.  # noqa: E501
        :rtype: list[ContractLine]
        """
        return self._contract_lines

    @contract_lines.setter
    def contract_lines(self, contract_lines):
        """Sets the contract_lines of this Contract.


        :param contract_lines: The contract_lines of this Contract.  # noqa: E501
        :type: list[ContractLine]
        """
        if contract_lines is None:
            raise ValueError("Invalid value for `contract_lines`, must not be `None`")  # noqa: E501

        self._contract_lines = contract_lines

    @property
    def attachment_details(self):
        """Gets the attachment_details of this Contract.  # noqa: E501


        :return: The attachment_details of this Contract.  # noqa: E501
        :rtype: list[AttachmentDetail]
        """
        return self._attachment_details

    @attachment_details.setter
    def attachment_details(self, attachment_details):
        """Sets the attachment_details of this Contract.


        :param attachment_details: The attachment_details of this Contract.  # noqa: E501
        :type: list[AttachmentDetail]
        """

        self._attachment_details = attachment_details

    @property
    def sequence_number(self):
        """Gets the sequence_number of this Contract.  # noqa: E501


        :return: The sequence_number of this Contract.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this Contract.


        :param sequence_number: The sequence_number of this Contract.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Contract, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Contract):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
