# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ContractDelivery(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_condition_id': 'str',
        'default_delivery_location_gln': 'str',
        'despatch_warehouse_id': 'str',
        'default_incoterm': 'Incoterm',
        'next_leg_identifier': 'str'
    }

    attribute_map = {
        'delivery_condition_id': 'deliveryConditionId',
        'default_delivery_location_gln': 'defaultDeliveryLocationGln',
        'despatch_warehouse_id': 'despatchWarehouseId',
        'default_incoterm': 'defaultIncoterm',
        'next_leg_identifier': 'nextLegIdentifier'
    }

    def __init__(self, delivery_condition_id=None, default_delivery_location_gln=None, despatch_warehouse_id=None, default_incoterm=None, next_leg_identifier=None):  # noqa: E501
        """ContractDelivery - a model defined in Swagger"""  # noqa: E501
        self._delivery_condition_id = None
        self._default_delivery_location_gln = None
        self._despatch_warehouse_id = None
        self._default_incoterm = None
        self._next_leg_identifier = None
        self.discriminator = None
        self.delivery_condition_id = delivery_condition_id
        if default_delivery_location_gln is not None:
            self.default_delivery_location_gln = default_delivery_location_gln
        if despatch_warehouse_id is not None:
            self.despatch_warehouse_id = despatch_warehouse_id
        self.default_incoterm = default_incoterm
        if next_leg_identifier is not None:
            self.next_leg_identifier = next_leg_identifier

    @property
    def delivery_condition_id(self):
        """Gets the delivery_condition_id of this ContractDelivery.  # noqa: E501


        :return: The delivery_condition_id of this ContractDelivery.  # noqa: E501
        :rtype: str
        """
        return self._delivery_condition_id

    @delivery_condition_id.setter
    def delivery_condition_id(self, delivery_condition_id):
        """Sets the delivery_condition_id of this ContractDelivery.


        :param delivery_condition_id: The delivery_condition_id of this ContractDelivery.  # noqa: E501
        :type: str
        """
        if delivery_condition_id is None:
            raise ValueError("Invalid value for `delivery_condition_id`, must not be `None`")  # noqa: E501

        self._delivery_condition_id = delivery_condition_id

    @property
    def default_delivery_location_gln(self):
        """Gets the default_delivery_location_gln of this ContractDelivery.  # noqa: E501


        :return: The default_delivery_location_gln of this ContractDelivery.  # noqa: E501
        :rtype: str
        """
        return self._default_delivery_location_gln

    @default_delivery_location_gln.setter
    def default_delivery_location_gln(self, default_delivery_location_gln):
        """Sets the default_delivery_location_gln of this ContractDelivery.


        :param default_delivery_location_gln: The default_delivery_location_gln of this ContractDelivery.  # noqa: E501
        :type: str
        """

        self._default_delivery_location_gln = default_delivery_location_gln

    @property
    def despatch_warehouse_id(self):
        """Gets the despatch_warehouse_id of this ContractDelivery.  # noqa: E501


        :return: The despatch_warehouse_id of this ContractDelivery.  # noqa: E501
        :rtype: str
        """
        return self._despatch_warehouse_id

    @despatch_warehouse_id.setter
    def despatch_warehouse_id(self, despatch_warehouse_id):
        """Sets the despatch_warehouse_id of this ContractDelivery.


        :param despatch_warehouse_id: The despatch_warehouse_id of this ContractDelivery.  # noqa: E501
        :type: str
        """

        self._despatch_warehouse_id = despatch_warehouse_id

    @property
    def default_incoterm(self):
        """Gets the default_incoterm of this ContractDelivery.  # noqa: E501


        :return: The default_incoterm of this ContractDelivery.  # noqa: E501
        :rtype: Incoterm
        """
        return self._default_incoterm

    @default_incoterm.setter
    def default_incoterm(self, default_incoterm):
        """Sets the default_incoterm of this ContractDelivery.


        :param default_incoterm: The default_incoterm of this ContractDelivery.  # noqa: E501
        :type: Incoterm
        """
        if default_incoterm is None:
            raise ValueError("Invalid value for `default_incoterm`, must not be `None`")  # noqa: E501

        self._default_incoterm = default_incoterm

    @property
    def next_leg_identifier(self):
        """Gets the next_leg_identifier of this ContractDelivery.  # noqa: E501


        :return: The next_leg_identifier of this ContractDelivery.  # noqa: E501
        :rtype: str
        """
        return self._next_leg_identifier

    @next_leg_identifier.setter
    def next_leg_identifier(self, next_leg_identifier):
        """Sets the next_leg_identifier of this ContractDelivery.


        :param next_leg_identifier: The next_leg_identifier of this ContractDelivery.  # noqa: E501
        :type: str
        """

        self._next_leg_identifier = next_leg_identifier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContractDelivery, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContractDelivery):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
