# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ContractLine(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contract_line_id': 'str',
        'trade_item': 'ContractLineTradeItem',
        'periods': 'list[ContractLinePeriod]',
        'substitute_trade_items': 'list[ContractLineTradeItem]',
        'additional_services': 'list[ContractLineAdditionalService]',
        'contract_trade_item_group_id': 'str'
    }

    attribute_map = {
        'contract_line_id': 'contractLineId',
        'trade_item': 'tradeItem',
        'periods': 'periods',
        'substitute_trade_items': 'substituteTradeItems',
        'additional_services': 'additionalServices',
        'contract_trade_item_group_id': 'contractTradeItemGroupId'
    }

    def __init__(self, contract_line_id=None, trade_item=None, periods=None, substitute_trade_items=None, additional_services=None, contract_trade_item_group_id=None):  # noqa: E501
        """ContractLine - a model defined in Swagger"""  # noqa: E501
        self._contract_line_id = None
        self._trade_item = None
        self._periods = None
        self._substitute_trade_items = None
        self._additional_services = None
        self._contract_trade_item_group_id = None
        self.discriminator = None
        self.contract_line_id = contract_line_id
        self.trade_item = trade_item
        if periods is not None:
            self.periods = periods
        if substitute_trade_items is not None:
            self.substitute_trade_items = substitute_trade_items
        if additional_services is not None:
            self.additional_services = additional_services
        if contract_trade_item_group_id is not None:
            self.contract_trade_item_group_id = contract_trade_item_group_id

    @property
    def contract_line_id(self):
        """Gets the contract_line_id of this ContractLine.  # noqa: E501


        :return: The contract_line_id of this ContractLine.  # noqa: E501
        :rtype: str
        """
        return self._contract_line_id

    @contract_line_id.setter
    def contract_line_id(self, contract_line_id):
        """Sets the contract_line_id of this ContractLine.


        :param contract_line_id: The contract_line_id of this ContractLine.  # noqa: E501
        :type: str
        """
        if contract_line_id is None:
            raise ValueError("Invalid value for `contract_line_id`, must not be `None`")  # noqa: E501

        self._contract_line_id = contract_line_id

    @property
    def trade_item(self):
        """Gets the trade_item of this ContractLine.  # noqa: E501


        :return: The trade_item of this ContractLine.  # noqa: E501
        :rtype: ContractLineTradeItem
        """
        return self._trade_item

    @trade_item.setter
    def trade_item(self, trade_item):
        """Sets the trade_item of this ContractLine.


        :param trade_item: The trade_item of this ContractLine.  # noqa: E501
        :type: ContractLineTradeItem
        """
        if trade_item is None:
            raise ValueError("Invalid value for `trade_item`, must not be `None`")  # noqa: E501

        self._trade_item = trade_item

    @property
    def periods(self):
        """Gets the periods of this ContractLine.  # noqa: E501


        :return: The periods of this ContractLine.  # noqa: E501
        :rtype: list[ContractLinePeriod]
        """
        return self._periods

    @periods.setter
    def periods(self, periods):
        """Sets the periods of this ContractLine.


        :param periods: The periods of this ContractLine.  # noqa: E501
        :type: list[ContractLinePeriod]
        """

        self._periods = periods

    @property
    def substitute_trade_items(self):
        """Gets the substitute_trade_items of this ContractLine.  # noqa: E501

        Only used for older contracts that don't work with ContractTradeItemGroup.  # noqa: E501

        :return: The substitute_trade_items of this ContractLine.  # noqa: E501
        :rtype: list[ContractLineTradeItem]
        """
        return self._substitute_trade_items

    @substitute_trade_items.setter
    def substitute_trade_items(self, substitute_trade_items):
        """Sets the substitute_trade_items of this ContractLine.

        Only used for older contracts that don't work with ContractTradeItemGroup.  # noqa: E501

        :param substitute_trade_items: The substitute_trade_items of this ContractLine.  # noqa: E501
        :type: list[ContractLineTradeItem]
        """

        self._substitute_trade_items = substitute_trade_items

    @property
    def additional_services(self):
        """Gets the additional_services of this ContractLine.  # noqa: E501


        :return: The additional_services of this ContractLine.  # noqa: E501
        :rtype: list[ContractLineAdditionalService]
        """
        return self._additional_services

    @additional_services.setter
    def additional_services(self, additional_services):
        """Sets the additional_services of this ContractLine.


        :param additional_services: The additional_services of this ContractLine.  # noqa: E501
        :type: list[ContractLineAdditionalService]
        """

        self._additional_services = additional_services

    @property
    def contract_trade_item_group_id(self):
        """Gets the contract_trade_item_group_id of this ContractLine.  # noqa: E501


        :return: The contract_trade_item_group_id of this ContractLine.  # noqa: E501
        :rtype: str
        """
        return self._contract_trade_item_group_id

    @contract_trade_item_group_id.setter
    def contract_trade_item_group_id(self, contract_trade_item_group_id):
        """Sets the contract_trade_item_group_id of this ContractLine.


        :param contract_trade_item_group_id: The contract_trade_item_group_id of this ContractLine.  # noqa: E501
        :type: str
        """

        self._contract_trade_item_group_id = contract_trade_item_group_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContractLine, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContractLine):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
