# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ContractStatus(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'approval_status': 'ApprovalStatus',
        'approved_on_date_time': 'datetime',
        'decline_description': 'str',
        'is_delete_requested_by_supplier': 'bool',
        'is_deleted': 'bool'
    }

    attribute_map = {
        'approval_status': 'approvalStatus',
        'approved_on_date_time': 'approvedOnDateTime',
        'decline_description': 'declineDescription',
        'is_delete_requested_by_supplier': 'isDeleteRequestedBySupplier',
        'is_deleted': 'isDeleted'
    }

    def __init__(self, approval_status=None, approved_on_date_time=None, decline_description=None, is_delete_requested_by_supplier=None, is_deleted=None):  # noqa: E501
        """ContractStatus - a model defined in Swagger"""  # noqa: E501
        self._approval_status = None
        self._approved_on_date_time = None
        self._decline_description = None
        self._is_delete_requested_by_supplier = None
        self._is_deleted = None
        self.discriminator = None
        self.approval_status = approval_status
        if approved_on_date_time is not None:
            self.approved_on_date_time = approved_on_date_time
        if decline_description is not None:
            self.decline_description = decline_description
        self.is_delete_requested_by_supplier = is_delete_requested_by_supplier
        self.is_deleted = is_deleted

    @property
    def approval_status(self):
        """Gets the approval_status of this ContractStatus.  # noqa: E501


        :return: The approval_status of this ContractStatus.  # noqa: E501
        :rtype: ApprovalStatus
        """
        return self._approval_status

    @approval_status.setter
    def approval_status(self, approval_status):
        """Sets the approval_status of this ContractStatus.


        :param approval_status: The approval_status of this ContractStatus.  # noqa: E501
        :type: ApprovalStatus
        """
        if approval_status is None:
            raise ValueError("Invalid value for `approval_status`, must not be `None`")  # noqa: E501

        self._approval_status = approval_status

    @property
    def approved_on_date_time(self):
        """Gets the approved_on_date_time of this ContractStatus.  # noqa: E501


        :return: The approved_on_date_time of this ContractStatus.  # noqa: E501
        :rtype: datetime
        """
        return self._approved_on_date_time

    @approved_on_date_time.setter
    def approved_on_date_time(self, approved_on_date_time):
        """Sets the approved_on_date_time of this ContractStatus.


        :param approved_on_date_time: The approved_on_date_time of this ContractStatus.  # noqa: E501
        :type: datetime
        """

        self._approved_on_date_time = approved_on_date_time

    @property
    def decline_description(self):
        """Gets the decline_description of this ContractStatus.  # noqa: E501


        :return: The decline_description of this ContractStatus.  # noqa: E501
        :rtype: str
        """
        return self._decline_description

    @decline_description.setter
    def decline_description(self, decline_description):
        """Sets the decline_description of this ContractStatus.


        :param decline_description: The decline_description of this ContractStatus.  # noqa: E501
        :type: str
        """

        self._decline_description = decline_description

    @property
    def is_delete_requested_by_supplier(self):
        """Gets the is_delete_requested_by_supplier of this ContractStatus.  # noqa: E501


        :return: The is_delete_requested_by_supplier of this ContractStatus.  # noqa: E501
        :rtype: bool
        """
        return self._is_delete_requested_by_supplier

    @is_delete_requested_by_supplier.setter
    def is_delete_requested_by_supplier(self, is_delete_requested_by_supplier):
        """Sets the is_delete_requested_by_supplier of this ContractStatus.


        :param is_delete_requested_by_supplier: The is_delete_requested_by_supplier of this ContractStatus.  # noqa: E501
        :type: bool
        """
        if is_delete_requested_by_supplier is None:
            raise ValueError("Invalid value for `is_delete_requested_by_supplier`, must not be `None`")  # noqa: E501

        self._is_delete_requested_by_supplier = is_delete_requested_by_supplier

    @property
    def is_deleted(self):
        """Gets the is_deleted of this ContractStatus.  # noqa: E501


        :return: The is_deleted of this ContractStatus.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this ContractStatus.


        :param is_deleted: The is_deleted of this ContractStatus.  # noqa: E501
        :type: bool
        """
        if is_deleted is None:
            raise ValueError("Invalid value for `is_deleted`, must not be `None`")  # noqa: E501

        self._is_deleted = is_deleted

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContractStatus, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContractStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
