# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ContractTradeItemGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contract_trade_item_group_id': 'str',
        'supplier_organization_id': 'str',
        'name': 'str',
        'trade_items': 'list[ContractTradeItemGroupTradeItem]',
        'creation_date_time': 'datetime',
        'last_modified_date_time': 'datetime',
        'is_deleted': 'bool',
        'sequence_number': 'int'
    }

    attribute_map = {
        'contract_trade_item_group_id': 'contractTradeItemGroupId',
        'supplier_organization_id': 'supplierOrganizationId',
        'name': 'name',
        'trade_items': 'tradeItems',
        'creation_date_time': 'creationDateTime',
        'last_modified_date_time': 'lastModifiedDateTime',
        'is_deleted': 'isDeleted',
        'sequence_number': 'sequenceNumber'
    }

    def __init__(self, contract_trade_item_group_id=None, supplier_organization_id=None, name=None, trade_items=None, creation_date_time=None, last_modified_date_time=None, is_deleted=None, sequence_number=None):  # noqa: E501
        """ContractTradeItemGroup - a model defined in Swagger"""  # noqa: E501
        self._contract_trade_item_group_id = None
        self._supplier_organization_id = None
        self._name = None
        self._trade_items = None
        self._creation_date_time = None
        self._last_modified_date_time = None
        self._is_deleted = None
        self._sequence_number = None
        self.discriminator = None
        self.contract_trade_item_group_id = contract_trade_item_group_id
        self.supplier_organization_id = supplier_organization_id
        self.name = name
        self.trade_items = trade_items
        self.creation_date_time = creation_date_time
        if last_modified_date_time is not None:
            self.last_modified_date_time = last_modified_date_time
        self.is_deleted = is_deleted
        self.sequence_number = sequence_number

    @property
    def contract_trade_item_group_id(self):
        """Gets the contract_trade_item_group_id of this ContractTradeItemGroup.  # noqa: E501


        :return: The contract_trade_item_group_id of this ContractTradeItemGroup.  # noqa: E501
        :rtype: str
        """
        return self._contract_trade_item_group_id

    @contract_trade_item_group_id.setter
    def contract_trade_item_group_id(self, contract_trade_item_group_id):
        """Sets the contract_trade_item_group_id of this ContractTradeItemGroup.


        :param contract_trade_item_group_id: The contract_trade_item_group_id of this ContractTradeItemGroup.  # noqa: E501
        :type: str
        """
        if contract_trade_item_group_id is None:
            raise ValueError("Invalid value for `contract_trade_item_group_id`, must not be `None`")  # noqa: E501

        self._contract_trade_item_group_id = contract_trade_item_group_id

    @property
    def supplier_organization_id(self):
        """Gets the supplier_organization_id of this ContractTradeItemGroup.  # noqa: E501


        :return: The supplier_organization_id of this ContractTradeItemGroup.  # noqa: E501
        :rtype: str
        """
        return self._supplier_organization_id

    @supplier_organization_id.setter
    def supplier_organization_id(self, supplier_organization_id):
        """Sets the supplier_organization_id of this ContractTradeItemGroup.


        :param supplier_organization_id: The supplier_organization_id of this ContractTradeItemGroup.  # noqa: E501
        :type: str
        """
        if supplier_organization_id is None:
            raise ValueError("Invalid value for `supplier_organization_id`, must not be `None`")  # noqa: E501

        self._supplier_organization_id = supplier_organization_id

    @property
    def name(self):
        """Gets the name of this ContractTradeItemGroup.  # noqa: E501


        :return: The name of this ContractTradeItemGroup.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ContractTradeItemGroup.


        :param name: The name of this ContractTradeItemGroup.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def trade_items(self):
        """Gets the trade_items of this ContractTradeItemGroup.  # noqa: E501


        :return: The trade_items of this ContractTradeItemGroup.  # noqa: E501
        :rtype: list[ContractTradeItemGroupTradeItem]
        """
        return self._trade_items

    @trade_items.setter
    def trade_items(self, trade_items):
        """Sets the trade_items of this ContractTradeItemGroup.


        :param trade_items: The trade_items of this ContractTradeItemGroup.  # noqa: E501
        :type: list[ContractTradeItemGroupTradeItem]
        """
        if trade_items is None:
            raise ValueError("Invalid value for `trade_items`, must not be `None`")  # noqa: E501

        self._trade_items = trade_items

    @property
    def creation_date_time(self):
        """Gets the creation_date_time of this ContractTradeItemGroup.  # noqa: E501


        :return: The creation_date_time of this ContractTradeItemGroup.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date_time

    @creation_date_time.setter
    def creation_date_time(self, creation_date_time):
        """Sets the creation_date_time of this ContractTradeItemGroup.


        :param creation_date_time: The creation_date_time of this ContractTradeItemGroup.  # noqa: E501
        :type: datetime
        """
        if creation_date_time is None:
            raise ValueError("Invalid value for `creation_date_time`, must not be `None`")  # noqa: E501

        self._creation_date_time = creation_date_time

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this ContractTradeItemGroup.  # noqa: E501


        :return: The last_modified_date_time of this ContractTradeItemGroup.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this ContractTradeItemGroup.


        :param last_modified_date_time: The last_modified_date_time of this ContractTradeItemGroup.  # noqa: E501
        :type: datetime
        """

        self._last_modified_date_time = last_modified_date_time

    @property
    def is_deleted(self):
        """Gets the is_deleted of this ContractTradeItemGroup.  # noqa: E501


        :return: The is_deleted of this ContractTradeItemGroup.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this ContractTradeItemGroup.


        :param is_deleted: The is_deleted of this ContractTradeItemGroup.  # noqa: E501
        :type: bool
        """
        if is_deleted is None:
            raise ValueError("Invalid value for `is_deleted`, must not be `None`")  # noqa: E501

        self._is_deleted = is_deleted

    @property
    def sequence_number(self):
        """Gets the sequence_number of this ContractTradeItemGroup.  # noqa: E501


        :return: The sequence_number of this ContractTradeItemGroup.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this ContractTradeItemGroup.


        :param sequence_number: The sequence_number of this ContractTradeItemGroup.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContractTradeItemGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContractTradeItemGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
