# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ContractVersion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'version_number': 'int',
        'is_latest_approved_version': 'bool',
        'reason_for_version_update': 'str'
    }

    attribute_map = {
        'version_number': 'versionNumber',
        'is_latest_approved_version': 'isLatestApprovedVersion',
        'reason_for_version_update': 'reasonForVersionUpdate'
    }

    def __init__(self, version_number=None, is_latest_approved_version=None, reason_for_version_update=None):  # noqa: E501
        """ContractVersion - a model defined in Swagger"""  # noqa: E501
        self._version_number = None
        self._is_latest_approved_version = None
        self._reason_for_version_update = None
        self.discriminator = None
        self.version_number = version_number
        self.is_latest_approved_version = is_latest_approved_version
        self.reason_for_version_update = reason_for_version_update

    @property
    def version_number(self):
        """Gets the version_number of this ContractVersion.  # noqa: E501


        :return: The version_number of this ContractVersion.  # noqa: E501
        :rtype: int
        """
        return self._version_number

    @version_number.setter
    def version_number(self, version_number):
        """Sets the version_number of this ContractVersion.


        :param version_number: The version_number of this ContractVersion.  # noqa: E501
        :type: int
        """
        if version_number is None:
            raise ValueError("Invalid value for `version_number`, must not be `None`")  # noqa: E501

        self._version_number = version_number

    @property
    def is_latest_approved_version(self):
        """Gets the is_latest_approved_version of this ContractVersion.  # noqa: E501


        :return: The is_latest_approved_version of this ContractVersion.  # noqa: E501
        :rtype: bool
        """
        return self._is_latest_approved_version

    @is_latest_approved_version.setter
    def is_latest_approved_version(self, is_latest_approved_version):
        """Sets the is_latest_approved_version of this ContractVersion.


        :param is_latest_approved_version: The is_latest_approved_version of this ContractVersion.  # noqa: E501
        :type: bool
        """
        if is_latest_approved_version is None:
            raise ValueError("Invalid value for `is_latest_approved_version`, must not be `None`")  # noqa: E501

        self._is_latest_approved_version = is_latest_approved_version

    @property
    def reason_for_version_update(self):
        """Gets the reason_for_version_update of this ContractVersion.  # noqa: E501


        :return: The reason_for_version_update of this ContractVersion.  # noqa: E501
        :rtype: str
        """
        return self._reason_for_version_update

    @reason_for_version_update.setter
    def reason_for_version_update(self, reason_for_version_update):
        """Sets the reason_for_version_update of this ContractVersion.


        :param reason_for_version_update: The reason_for_version_update of this ContractVersion.  # noqa: E501
        :type: str
        """
        if reason_for_version_update is None:
            raise ValueError("Invalid value for `reason_for_version_update`, must not be `None`")  # noqa: E501

        self._reason_for_version_update = reason_for_version_update

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContractVersion, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContractVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
