# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeliveryOrder(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'delivery_order_id': 'str',
        'creation_date_time': 'datetime',
        'fulfillment_requests': 'list[FulfillmentRequest]',
        'delivery_date_time': 'datetime',
        'destination': 'Destination',
        'despatch_warehouse_id': 'str',
        'fulfilled': 'bool',
        'sequence_number': 'int',
        'is_deleted': 'bool',
        'last_modified_date_time': 'datetime',
        'carrier_organization_id': 'str',
        'started_order_picking_at': 'datetime'
    }

    attribute_map = {
        'delivery_order_id': 'deliveryOrderId',
        'creation_date_time': 'creationDateTime',
        'fulfillment_requests': 'fulfillmentRequests',
        'delivery_date_time': 'deliveryDateTime',
        'destination': 'destination',
        'despatch_warehouse_id': 'despatchWarehouseId',
        'fulfilled': 'fulfilled',
        'sequence_number': 'sequenceNumber',
        'is_deleted': 'isDeleted',
        'last_modified_date_time': 'lastModifiedDateTime',
        'carrier_organization_id': 'carrierOrganizationId',
        'started_order_picking_at': 'startedOrderPickingAt'
    }

    def __init__(self, delivery_order_id=None, creation_date_time=None, fulfillment_requests=None, delivery_date_time=None, destination=None, despatch_warehouse_id=None, fulfilled=None, sequence_number=None, is_deleted=None, last_modified_date_time=None, carrier_organization_id=None, started_order_picking_at=None):  # noqa: E501
        """DeliveryOrder - a model defined in Swagger"""  # noqa: E501
        self._delivery_order_id = None
        self._creation_date_time = None
        self._fulfillment_requests = None
        self._delivery_date_time = None
        self._destination = None
        self._despatch_warehouse_id = None
        self._fulfilled = None
        self._sequence_number = None
        self._is_deleted = None
        self._last_modified_date_time = None
        self._carrier_organization_id = None
        self._started_order_picking_at = None
        self.discriminator = None
        self.delivery_order_id = delivery_order_id
        self.creation_date_time = creation_date_time
        self.fulfillment_requests = fulfillment_requests
        self.delivery_date_time = delivery_date_time
        self.destination = destination
        self.despatch_warehouse_id = despatch_warehouse_id
        self.fulfilled = fulfilled
        self.sequence_number = sequence_number
        if is_deleted is not None:
            self.is_deleted = is_deleted
        if last_modified_date_time is not None:
            self.last_modified_date_time = last_modified_date_time
        if carrier_organization_id is not None:
            self.carrier_organization_id = carrier_organization_id
        if started_order_picking_at is not None:
            self.started_order_picking_at = started_order_picking_at

    @property
    def delivery_order_id(self):
        """Gets the delivery_order_id of this DeliveryOrder.  # noqa: E501


        :return: The delivery_order_id of this DeliveryOrder.  # noqa: E501
        :rtype: str
        """
        return self._delivery_order_id

    @delivery_order_id.setter
    def delivery_order_id(self, delivery_order_id):
        """Sets the delivery_order_id of this DeliveryOrder.


        :param delivery_order_id: The delivery_order_id of this DeliveryOrder.  # noqa: E501
        :type: str
        """
        if delivery_order_id is None:
            raise ValueError("Invalid value for `delivery_order_id`, must not be `None`")  # noqa: E501

        self._delivery_order_id = delivery_order_id

    @property
    def creation_date_time(self):
        """Gets the creation_date_time of this DeliveryOrder.  # noqa: E501


        :return: The creation_date_time of this DeliveryOrder.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date_time

    @creation_date_time.setter
    def creation_date_time(self, creation_date_time):
        """Sets the creation_date_time of this DeliveryOrder.


        :param creation_date_time: The creation_date_time of this DeliveryOrder.  # noqa: E501
        :type: datetime
        """
        if creation_date_time is None:
            raise ValueError("Invalid value for `creation_date_time`, must not be `None`")  # noqa: E501

        self._creation_date_time = creation_date_time

    @property
    def fulfillment_requests(self):
        """Gets the fulfillment_requests of this DeliveryOrder.  # noqa: E501


        :return: The fulfillment_requests of this DeliveryOrder.  # noqa: E501
        :rtype: list[FulfillmentRequest]
        """
        return self._fulfillment_requests

    @fulfillment_requests.setter
    def fulfillment_requests(self, fulfillment_requests):
        """Sets the fulfillment_requests of this DeliveryOrder.


        :param fulfillment_requests: The fulfillment_requests of this DeliveryOrder.  # noqa: E501
        :type: list[FulfillmentRequest]
        """
        if fulfillment_requests is None:
            raise ValueError("Invalid value for `fulfillment_requests`, must not be `None`")  # noqa: E501

        self._fulfillment_requests = fulfillment_requests

    @property
    def delivery_date_time(self):
        """Gets the delivery_date_time of this DeliveryOrder.  # noqa: E501


        :return: The delivery_date_time of this DeliveryOrder.  # noqa: E501
        :rtype: datetime
        """
        return self._delivery_date_time

    @delivery_date_time.setter
    def delivery_date_time(self, delivery_date_time):
        """Sets the delivery_date_time of this DeliveryOrder.


        :param delivery_date_time: The delivery_date_time of this DeliveryOrder.  # noqa: E501
        :type: datetime
        """
        if delivery_date_time is None:
            raise ValueError("Invalid value for `delivery_date_time`, must not be `None`")  # noqa: E501

        self._delivery_date_time = delivery_date_time

    @property
    def destination(self):
        """Gets the destination of this DeliveryOrder.  # noqa: E501


        :return: The destination of this DeliveryOrder.  # noqa: E501
        :rtype: Destination
        """
        return self._destination

    @destination.setter
    def destination(self, destination):
        """Sets the destination of this DeliveryOrder.


        :param destination: The destination of this DeliveryOrder.  # noqa: E501
        :type: Destination
        """
        if destination is None:
            raise ValueError("Invalid value for `destination`, must not be `None`")  # noqa: E501

        self._destination = destination

    @property
    def despatch_warehouse_id(self):
        """Gets the despatch_warehouse_id of this DeliveryOrder.  # noqa: E501


        :return: The despatch_warehouse_id of this DeliveryOrder.  # noqa: E501
        :rtype: str
        """
        return self._despatch_warehouse_id

    @despatch_warehouse_id.setter
    def despatch_warehouse_id(self, despatch_warehouse_id):
        """Sets the despatch_warehouse_id of this DeliveryOrder.


        :param despatch_warehouse_id: The despatch_warehouse_id of this DeliveryOrder.  # noqa: E501
        :type: str
        """
        if despatch_warehouse_id is None:
            raise ValueError("Invalid value for `despatch_warehouse_id`, must not be `None`")  # noqa: E501

        self._despatch_warehouse_id = despatch_warehouse_id

    @property
    def fulfilled(self):
        """Gets the fulfilled of this DeliveryOrder.  # noqa: E501


        :return: The fulfilled of this DeliveryOrder.  # noqa: E501
        :rtype: bool
        """
        return self._fulfilled

    @fulfilled.setter
    def fulfilled(self, fulfilled):
        """Sets the fulfilled of this DeliveryOrder.


        :param fulfilled: The fulfilled of this DeliveryOrder.  # noqa: E501
        :type: bool
        """
        if fulfilled is None:
            raise ValueError("Invalid value for `fulfilled`, must not be `None`")  # noqa: E501

        self._fulfilled = fulfilled

    @property
    def sequence_number(self):
        """Gets the sequence_number of this DeliveryOrder.  # noqa: E501


        :return: The sequence_number of this DeliveryOrder.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this DeliveryOrder.


        :param sequence_number: The sequence_number of this DeliveryOrder.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    @property
    def is_deleted(self):
        """Gets the is_deleted of this DeliveryOrder.  # noqa: E501


        :return: The is_deleted of this DeliveryOrder.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this DeliveryOrder.


        :param is_deleted: The is_deleted of this DeliveryOrder.  # noqa: E501
        :type: bool
        """

        self._is_deleted = is_deleted

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this DeliveryOrder.  # noqa: E501


        :return: The last_modified_date_time of this DeliveryOrder.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this DeliveryOrder.


        :param last_modified_date_time: The last_modified_date_time of this DeliveryOrder.  # noqa: E501
        :type: datetime
        """

        self._last_modified_date_time = last_modified_date_time

    @property
    def carrier_organization_id(self):
        """Gets the carrier_organization_id of this DeliveryOrder.  # noqa: E501


        :return: The carrier_organization_id of this DeliveryOrder.  # noqa: E501
        :rtype: str
        """
        return self._carrier_organization_id

    @carrier_organization_id.setter
    def carrier_organization_id(self, carrier_organization_id):
        """Sets the carrier_organization_id of this DeliveryOrder.


        :param carrier_organization_id: The carrier_organization_id of this DeliveryOrder.  # noqa: E501
        :type: str
        """

        self._carrier_organization_id = carrier_organization_id

    @property
    def started_order_picking_at(self):
        """Gets the started_order_picking_at of this DeliveryOrder.  # noqa: E501


        :return: The started_order_picking_at of this DeliveryOrder.  # noqa: E501
        :rtype: datetime
        """
        return self._started_order_picking_at

    @started_order_picking_at.setter
    def started_order_picking_at(self, started_order_picking_at):
        """Sets the started_order_picking_at of this DeliveryOrder.


        :param started_order_picking_at: The started_order_picking_at of this DeliveryOrder.  # noqa: E501
        :type: datetime
        """

        self._started_order_picking_at = started_order_picking_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeliveryOrder, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeliveryOrder):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
