# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class DeliveryOrderAuction(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'auction_date': 'date',
        'auction_group_code': 'int',
        'batch_fulfillment_requests': 'list[FulfillmentRequestCreateAuction]',
        'trade_item_fulfillment_requests': 'list[FulfillmentRequestCreateAuctionTradeItem]',
        'delivery_date_time': 'datetime',
        'destination_warehouse_id': 'str',
        'despatch_warehouse_id': 'str',
        'carrier_organization_id': 'str'
    }

    attribute_map = {
        'auction_date': 'auctionDate',
        'auction_group_code': 'auctionGroupCode',
        'batch_fulfillment_requests': 'batchFulfillmentRequests',
        'trade_item_fulfillment_requests': 'tradeItemFulfillmentRequests',
        'delivery_date_time': 'deliveryDateTime',
        'destination_warehouse_id': 'destinationWarehouseId',
        'despatch_warehouse_id': 'despatchWarehouseId',
        'carrier_organization_id': 'carrierOrganizationId'
    }

    def __init__(self, auction_date=None, auction_group_code=None, batch_fulfillment_requests=None, trade_item_fulfillment_requests=None, delivery_date_time=None, destination_warehouse_id=None, despatch_warehouse_id=None, carrier_organization_id=None):  # noqa: E501
        """DeliveryOrderAuction - a model defined in Swagger"""  # noqa: E501
        self._auction_date = None
        self._auction_group_code = None
        self._batch_fulfillment_requests = None
        self._trade_item_fulfillment_requests = None
        self._delivery_date_time = None
        self._destination_warehouse_id = None
        self._despatch_warehouse_id = None
        self._carrier_organization_id = None
        self.discriminator = None
        self.auction_date = auction_date
        self.auction_group_code = auction_group_code
        if batch_fulfillment_requests is not None:
            self.batch_fulfillment_requests = batch_fulfillment_requests
        if trade_item_fulfillment_requests is not None:
            self.trade_item_fulfillment_requests = trade_item_fulfillment_requests
        self.delivery_date_time = delivery_date_time
        self.destination_warehouse_id = destination_warehouse_id
        self.despatch_warehouse_id = despatch_warehouse_id
        if carrier_organization_id is not None:
            self.carrier_organization_id = carrier_organization_id

    @property
    def auction_date(self):
        """Gets the auction_date of this DeliveryOrderAuction.  # noqa: E501


        :return: The auction_date of this DeliveryOrderAuction.  # noqa: E501
        :rtype: date
        """
        return self._auction_date

    @auction_date.setter
    def auction_date(self, auction_date):
        """Sets the auction_date of this DeliveryOrderAuction.


        :param auction_date: The auction_date of this DeliveryOrderAuction.  # noqa: E501
        :type: date
        """
        if auction_date is None:
            raise ValueError("Invalid value for `auction_date`, must not be `None`")  # noqa: E501

        self._auction_date = auction_date

    @property
    def auction_group_code(self):
        """Gets the auction_group_code of this DeliveryOrderAuction.  # noqa: E501


        :return: The auction_group_code of this DeliveryOrderAuction.  # noqa: E501
        :rtype: int
        """
        return self._auction_group_code

    @auction_group_code.setter
    def auction_group_code(self, auction_group_code):
        """Sets the auction_group_code of this DeliveryOrderAuction.


        :param auction_group_code: The auction_group_code of this DeliveryOrderAuction.  # noqa: E501
        :type: int
        """
        if auction_group_code is None:
            raise ValueError("Invalid value for `auction_group_code`, must not be `None`")  # noqa: E501

        self._auction_group_code = auction_group_code

    @property
    def batch_fulfillment_requests(self):
        """Gets the batch_fulfillment_requests of this DeliveryOrderAuction.  # noqa: E501

        AddClockDeliveryOrder only supports batch or trade item fulfillment requests, not a combination.  # noqa: E501

        :return: The batch_fulfillment_requests of this DeliveryOrderAuction.  # noqa: E501
        :rtype: list[FulfillmentRequestCreateAuction]
        """
        return self._batch_fulfillment_requests

    @batch_fulfillment_requests.setter
    def batch_fulfillment_requests(self, batch_fulfillment_requests):
        """Sets the batch_fulfillment_requests of this DeliveryOrderAuction.

        AddClockDeliveryOrder only supports batch or trade item fulfillment requests, not a combination.  # noqa: E501

        :param batch_fulfillment_requests: The batch_fulfillment_requests of this DeliveryOrderAuction.  # noqa: E501
        :type: list[FulfillmentRequestCreateAuction]
        """

        self._batch_fulfillment_requests = batch_fulfillment_requests

    @property
    def trade_item_fulfillment_requests(self):
        """Gets the trade_item_fulfillment_requests of this DeliveryOrderAuction.  # noqa: E501

        AddClockDeliveryOrder only supports batch or trade item fulfillment requests, not a combination.  # noqa: E501

        :return: The trade_item_fulfillment_requests of this DeliveryOrderAuction.  # noqa: E501
        :rtype: list[FulfillmentRequestCreateAuctionTradeItem]
        """
        return self._trade_item_fulfillment_requests

    @trade_item_fulfillment_requests.setter
    def trade_item_fulfillment_requests(self, trade_item_fulfillment_requests):
        """Sets the trade_item_fulfillment_requests of this DeliveryOrderAuction.

        AddClockDeliveryOrder only supports batch or trade item fulfillment requests, not a combination.  # noqa: E501

        :param trade_item_fulfillment_requests: The trade_item_fulfillment_requests of this DeliveryOrderAuction.  # noqa: E501
        :type: list[FulfillmentRequestCreateAuctionTradeItem]
        """

        self._trade_item_fulfillment_requests = trade_item_fulfillment_requests

    @property
    def delivery_date_time(self):
        """Gets the delivery_date_time of this DeliveryOrderAuction.  # noqa: E501


        :return: The delivery_date_time of this DeliveryOrderAuction.  # noqa: E501
        :rtype: datetime
        """
        return self._delivery_date_time

    @delivery_date_time.setter
    def delivery_date_time(self, delivery_date_time):
        """Sets the delivery_date_time of this DeliveryOrderAuction.


        :param delivery_date_time: The delivery_date_time of this DeliveryOrderAuction.  # noqa: E501
        :type: datetime
        """
        if delivery_date_time is None:
            raise ValueError("Invalid value for `delivery_date_time`, must not be `None`")  # noqa: E501

        self._delivery_date_time = delivery_date_time

    @property
    def destination_warehouse_id(self):
        """Gets the destination_warehouse_id of this DeliveryOrderAuction.  # noqa: E501


        :return: The destination_warehouse_id of this DeliveryOrderAuction.  # noqa: E501
        :rtype: str
        """
        return self._destination_warehouse_id

    @destination_warehouse_id.setter
    def destination_warehouse_id(self, destination_warehouse_id):
        """Sets the destination_warehouse_id of this DeliveryOrderAuction.


        :param destination_warehouse_id: The destination_warehouse_id of this DeliveryOrderAuction.  # noqa: E501
        :type: str
        """
        if destination_warehouse_id is None:
            raise ValueError("Invalid value for `destination_warehouse_id`, must not be `None`")  # noqa: E501

        self._destination_warehouse_id = destination_warehouse_id

    @property
    def despatch_warehouse_id(self):
        """Gets the despatch_warehouse_id of this DeliveryOrderAuction.  # noqa: E501


        :return: The despatch_warehouse_id of this DeliveryOrderAuction.  # noqa: E501
        :rtype: str
        """
        return self._despatch_warehouse_id

    @despatch_warehouse_id.setter
    def despatch_warehouse_id(self, despatch_warehouse_id):
        """Sets the despatch_warehouse_id of this DeliveryOrderAuction.


        :param despatch_warehouse_id: The despatch_warehouse_id of this DeliveryOrderAuction.  # noqa: E501
        :type: str
        """
        if despatch_warehouse_id is None:
            raise ValueError("Invalid value for `despatch_warehouse_id`, must not be `None`")  # noqa: E501

        self._despatch_warehouse_id = despatch_warehouse_id

    @property
    def carrier_organization_id(self):
        """Gets the carrier_organization_id of this DeliveryOrderAuction.  # noqa: E501


        :return: The carrier_organization_id of this DeliveryOrderAuction.  # noqa: E501
        :rtype: str
        """
        return self._carrier_organization_id

    @carrier_organization_id.setter
    def carrier_organization_id(self, carrier_organization_id):
        """Sets the carrier_organization_id of this DeliveryOrderAuction.


        :param carrier_organization_id: The carrier_organization_id of this DeliveryOrderAuction.  # noqa: E501
        :type: str
        """

        self._carrier_organization_id = carrier_organization_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DeliveryOrderAuction, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeliveryOrderAuction):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
