# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EditContractLine(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contract_line_id': 'str',
        'trade_item': 'AllOfEditContractLineTradeItem',
        'trade_item_group': 'AllOfEditContractLineTradeItemGroup',
        'periods': 'list[EditContractLinePeriod]',
        'additional_services': 'list[EditContractLineAdditionalService]'
    }

    attribute_map = {
        'contract_line_id': 'contractLineId',
        'trade_item': 'tradeItem',
        'trade_item_group': 'tradeItemGroup',
        'periods': 'periods',
        'additional_services': 'additionalServices'
    }

    def __init__(self, contract_line_id=None, trade_item=None, trade_item_group=None, periods=None, additional_services=None):  # noqa: E501
        """EditContractLine - a model defined in Swagger"""  # noqa: E501
        self._contract_line_id = None
        self._trade_item = None
        self._trade_item_group = None
        self._periods = None
        self._additional_services = None
        self.discriminator = None
        self.contract_line_id = contract_line_id
        if trade_item is not None:
            self.trade_item = trade_item
        if trade_item_group is not None:
            self.trade_item_group = trade_item_group
        if periods is not None:
            self.periods = periods
        if additional_services is not None:
            self.additional_services = additional_services

    @property
    def contract_line_id(self):
        """Gets the contract_line_id of this EditContractLine.  # noqa: E501


        :return: The contract_line_id of this EditContractLine.  # noqa: E501
        :rtype: str
        """
        return self._contract_line_id

    @contract_line_id.setter
    def contract_line_id(self, contract_line_id):
        """Sets the contract_line_id of this EditContractLine.


        :param contract_line_id: The contract_line_id of this EditContractLine.  # noqa: E501
        :type: str
        """
        if contract_line_id is None:
            raise ValueError("Invalid value for `contract_line_id`, must not be `None`")  # noqa: E501

        self._contract_line_id = contract_line_id

    @property
    def trade_item(self):
        """Gets the trade_item of this EditContractLine.  # noqa: E501

        Set either the 'tradeItem' or the 'tradeItemGroup'.  # noqa: E501

        :return: The trade_item of this EditContractLine.  # noqa: E501
        :rtype: AllOfEditContractLineTradeItem
        """
        return self._trade_item

    @trade_item.setter
    def trade_item(self, trade_item):
        """Sets the trade_item of this EditContractLine.

        Set either the 'tradeItem' or the 'tradeItemGroup'.  # noqa: E501

        :param trade_item: The trade_item of this EditContractLine.  # noqa: E501
        :type: AllOfEditContractLineTradeItem
        """

        self._trade_item = trade_item

    @property
    def trade_item_group(self):
        """Gets the trade_item_group of this EditContractLine.  # noqa: E501

        Set either the 'tradeItem' or the 'tradeItemGroup'.  # noqa: E501

        :return: The trade_item_group of this EditContractLine.  # noqa: E501
        :rtype: AllOfEditContractLineTradeItemGroup
        """
        return self._trade_item_group

    @trade_item_group.setter
    def trade_item_group(self, trade_item_group):
        """Sets the trade_item_group of this EditContractLine.

        Set either the 'tradeItem' or the 'tradeItemGroup'.  # noqa: E501

        :param trade_item_group: The trade_item_group of this EditContractLine.  # noqa: E501
        :type: AllOfEditContractLineTradeItemGroup
        """

        self._trade_item_group = trade_item_group

    @property
    def periods(self):
        """Gets the periods of this EditContractLine.  # noqa: E501


        :return: The periods of this EditContractLine.  # noqa: E501
        :rtype: list[EditContractLinePeriod]
        """
        return self._periods

    @periods.setter
    def periods(self, periods):
        """Sets the periods of this EditContractLine.


        :param periods: The periods of this EditContractLine.  # noqa: E501
        :type: list[EditContractLinePeriod]
        """

        self._periods = periods

    @property
    def additional_services(self):
        """Gets the additional_services of this EditContractLine.  # noqa: E501


        :return: The additional_services of this EditContractLine.  # noqa: E501
        :rtype: list[EditContractLineAdditionalService]
        """
        return self._additional_services

    @additional_services.setter
    def additional_services(self, additional_services):
        """Sets the additional_services of this EditContractLine.


        :param additional_services: The additional_services of this EditContractLine.  # noqa: E501
        :type: list[EditContractLineAdditionalService]
        """

        self._additional_services = additional_services

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EditContractLine, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EditContractLine):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
