# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class EditCustomerOffer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'number_of_pieces': 'int',
        'price_per_piece': 'Price',
        'warehouse_id': 'str',
        'packing_configurations': 'list[PackingConfigurationBase]',
        'sales_unit': 'SalesUnit',
        'agreement_reference': 'AgreementReference',
        'allowed_customers': 'list[str]',
        'volume_prices': 'list[AddVolumePrice]'
    }

    attribute_map = {
        'number_of_pieces': 'numberOfPieces',
        'price_per_piece': 'pricePerPiece',
        'warehouse_id': 'warehouseId',
        'packing_configurations': 'packingConfigurations',
        'sales_unit': 'salesUnit',
        'agreement_reference': 'agreementReference',
        'allowed_customers': 'allowedCustomers',
        'volume_prices': 'volumePrices'
    }

    def __init__(self, number_of_pieces=None, price_per_piece=None, warehouse_id=None, packing_configurations=None, sales_unit=None, agreement_reference=None, allowed_customers=None, volume_prices=None):  # noqa: E501
        """EditCustomerOffer - a model defined in Swagger"""  # noqa: E501
        self._number_of_pieces = None
        self._price_per_piece = None
        self._warehouse_id = None
        self._packing_configurations = None
        self._sales_unit = None
        self._agreement_reference = None
        self._allowed_customers = None
        self._volume_prices = None
        self.discriminator = None
        self.number_of_pieces = number_of_pieces
        self.price_per_piece = price_per_piece
        self.warehouse_id = warehouse_id
        if packing_configurations is not None:
            self.packing_configurations = packing_configurations
        if sales_unit is not None:
            self.sales_unit = sales_unit
        if agreement_reference is not None:
            self.agreement_reference = agreement_reference
        self.allowed_customers = allowed_customers
        if volume_prices is not None:
            self.volume_prices = volume_prices

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this EditCustomerOffer.  # noqa: E501


        :return: The number_of_pieces of this EditCustomerOffer.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this EditCustomerOffer.


        :param number_of_pieces: The number_of_pieces of this EditCustomerOffer.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def price_per_piece(self):
        """Gets the price_per_piece of this EditCustomerOffer.  # noqa: E501


        :return: The price_per_piece of this EditCustomerOffer.  # noqa: E501
        :rtype: Price
        """
        return self._price_per_piece

    @price_per_piece.setter
    def price_per_piece(self, price_per_piece):
        """Sets the price_per_piece of this EditCustomerOffer.


        :param price_per_piece: The price_per_piece of this EditCustomerOffer.  # noqa: E501
        :type: Price
        """
        if price_per_piece is None:
            raise ValueError("Invalid value for `price_per_piece`, must not be `None`")  # noqa: E501

        self._price_per_piece = price_per_piece

    @property
    def warehouse_id(self):
        """Gets the warehouse_id of this EditCustomerOffer.  # noqa: E501


        :return: The warehouse_id of this EditCustomerOffer.  # noqa: E501
        :rtype: str
        """
        return self._warehouse_id

    @warehouse_id.setter
    def warehouse_id(self, warehouse_id):
        """Sets the warehouse_id of this EditCustomerOffer.


        :param warehouse_id: The warehouse_id of this EditCustomerOffer.  # noqa: E501
        :type: str
        """
        if warehouse_id is None:
            raise ValueError("Invalid value for `warehouse_id`, must not be `None`")  # noqa: E501

        self._warehouse_id = warehouse_id

    @property
    def packing_configurations(self):
        """Gets the packing_configurations of this EditCustomerOffer.  # noqa: E501


        :return: The packing_configurations of this EditCustomerOffer.  # noqa: E501
        :rtype: list[PackingConfigurationBase]
        """
        return self._packing_configurations

    @packing_configurations.setter
    def packing_configurations(self, packing_configurations):
        """Sets the packing_configurations of this EditCustomerOffer.


        :param packing_configurations: The packing_configurations of this EditCustomerOffer.  # noqa: E501
        :type: list[PackingConfigurationBase]
        """

        self._packing_configurations = packing_configurations

    @property
    def sales_unit(self):
        """Gets the sales_unit of this EditCustomerOffer.  # noqa: E501


        :return: The sales_unit of this EditCustomerOffer.  # noqa: E501
        :rtype: SalesUnit
        """
        return self._sales_unit

    @sales_unit.setter
    def sales_unit(self, sales_unit):
        """Sets the sales_unit of this EditCustomerOffer.


        :param sales_unit: The sales_unit of this EditCustomerOffer.  # noqa: E501
        :type: SalesUnit
        """

        self._sales_unit = sales_unit

    @property
    def agreement_reference(self):
        """Gets the agreement_reference of this EditCustomerOffer.  # noqa: E501


        :return: The agreement_reference of this EditCustomerOffer.  # noqa: E501
        :rtype: AgreementReference
        """
        return self._agreement_reference

    @agreement_reference.setter
    def agreement_reference(self, agreement_reference):
        """Sets the agreement_reference of this EditCustomerOffer.


        :param agreement_reference: The agreement_reference of this EditCustomerOffer.  # noqa: E501
        :type: AgreementReference
        """

        self._agreement_reference = agreement_reference

    @property
    def allowed_customers(self):
        """Gets the allowed_customers of this EditCustomerOffer.  # noqa: E501


        :return: The allowed_customers of this EditCustomerOffer.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_customers

    @allowed_customers.setter
    def allowed_customers(self, allowed_customers):
        """Sets the allowed_customers of this EditCustomerOffer.


        :param allowed_customers: The allowed_customers of this EditCustomerOffer.  # noqa: E501
        :type: list[str]
        """
        if allowed_customers is None:
            raise ValueError("Invalid value for `allowed_customers`, must not be `None`")  # noqa: E501

        self._allowed_customers = allowed_customers

    @property
    def volume_prices(self):
        """Gets the volume_prices of this EditCustomerOffer.  # noqa: E501


        :return: The volume_prices of this EditCustomerOffer.  # noqa: E501
        :rtype: list[AddVolumePrice]
        """
        return self._volume_prices

    @volume_prices.setter
    def volume_prices(self, volume_prices):
        """Sets the volume_prices of this EditCustomerOffer.


        :param volume_prices: The volume_prices of this EditCustomerOffer.  # noqa: E501
        :type: list[AddVolumePrice]
        """

        self._volume_prices = volume_prices

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EditCustomerOffer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EditCustomerOffer):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
