# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FulfillmentOrderCorrection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'correction_id': 'str',
        'delivery_location_gln': 'str',
        'load_carrier_corrections': 'list[LoadCarrierCorrection]',
        'status': 'CorrectionStatus',
        'creation_date_time': 'datetime',
        'last_modified_date_time': 'datetime'
    }

    attribute_map = {
        'correction_id': 'correctionId',
        'delivery_location_gln': 'deliveryLocationGln',
        'load_carrier_corrections': 'loadCarrierCorrections',
        'status': 'status',
        'creation_date_time': 'creationDateTime',
        'last_modified_date_time': 'lastModifiedDateTime'
    }

    def __init__(self, correction_id=None, delivery_location_gln=None, load_carrier_corrections=None, status=None, creation_date_time=None, last_modified_date_time=None):  # noqa: E501
        """FulfillmentOrderCorrection - a model defined in Swagger"""  # noqa: E501
        self._correction_id = None
        self._delivery_location_gln = None
        self._load_carrier_corrections = None
        self._status = None
        self._creation_date_time = None
        self._last_modified_date_time = None
        self.discriminator = None
        self.correction_id = correction_id
        if delivery_location_gln is not None:
            self.delivery_location_gln = delivery_location_gln
        self.load_carrier_corrections = load_carrier_corrections
        if status is not None:
            self.status = status
        self.creation_date_time = creation_date_time
        self.last_modified_date_time = last_modified_date_time

    @property
    def correction_id(self):
        """Gets the correction_id of this FulfillmentOrderCorrection.  # noqa: E501


        :return: The correction_id of this FulfillmentOrderCorrection.  # noqa: E501
        :rtype: str
        """
        return self._correction_id

    @correction_id.setter
    def correction_id(self, correction_id):
        """Sets the correction_id of this FulfillmentOrderCorrection.


        :param correction_id: The correction_id of this FulfillmentOrderCorrection.  # noqa: E501
        :type: str
        """
        if correction_id is None:
            raise ValueError("Invalid value for `correction_id`, must not be `None`")  # noqa: E501

        self._correction_id = correction_id

    @property
    def delivery_location_gln(self):
        """Gets the delivery_location_gln of this FulfillmentOrderCorrection.  # noqa: E501


        :return: The delivery_location_gln of this FulfillmentOrderCorrection.  # noqa: E501
        :rtype: str
        """
        return self._delivery_location_gln

    @delivery_location_gln.setter
    def delivery_location_gln(self, delivery_location_gln):
        """Sets the delivery_location_gln of this FulfillmentOrderCorrection.


        :param delivery_location_gln: The delivery_location_gln of this FulfillmentOrderCorrection.  # noqa: E501
        :type: str
        """

        self._delivery_location_gln = delivery_location_gln

    @property
    def load_carrier_corrections(self):
        """Gets the load_carrier_corrections of this FulfillmentOrderCorrection.  # noqa: E501


        :return: The load_carrier_corrections of this FulfillmentOrderCorrection.  # noqa: E501
        :rtype: list[LoadCarrierCorrection]
        """
        return self._load_carrier_corrections

    @load_carrier_corrections.setter
    def load_carrier_corrections(self, load_carrier_corrections):
        """Sets the load_carrier_corrections of this FulfillmentOrderCorrection.


        :param load_carrier_corrections: The load_carrier_corrections of this FulfillmentOrderCorrection.  # noqa: E501
        :type: list[LoadCarrierCorrection]
        """
        if load_carrier_corrections is None:
            raise ValueError("Invalid value for `load_carrier_corrections`, must not be `None`")  # noqa: E501

        self._load_carrier_corrections = load_carrier_corrections

    @property
    def status(self):
        """Gets the status of this FulfillmentOrderCorrection.  # noqa: E501


        :return: The status of this FulfillmentOrderCorrection.  # noqa: E501
        :rtype: CorrectionStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this FulfillmentOrderCorrection.


        :param status: The status of this FulfillmentOrderCorrection.  # noqa: E501
        :type: CorrectionStatus
        """

        self._status = status

    @property
    def creation_date_time(self):
        """Gets the creation_date_time of this FulfillmentOrderCorrection.  # noqa: E501


        :return: The creation_date_time of this FulfillmentOrderCorrection.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date_time

    @creation_date_time.setter
    def creation_date_time(self, creation_date_time):
        """Sets the creation_date_time of this FulfillmentOrderCorrection.


        :param creation_date_time: The creation_date_time of this FulfillmentOrderCorrection.  # noqa: E501
        :type: datetime
        """
        if creation_date_time is None:
            raise ValueError("Invalid value for `creation_date_time`, must not be `None`")  # noqa: E501

        self._creation_date_time = creation_date_time

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this FulfillmentOrderCorrection.  # noqa: E501


        :return: The last_modified_date_time of this FulfillmentOrderCorrection.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this FulfillmentOrderCorrection.


        :param last_modified_date_time: The last_modified_date_time of this FulfillmentOrderCorrection.  # noqa: E501
        :type: datetime
        """
        if last_modified_date_time is None:
            raise ValueError("Invalid value for `last_modified_date_time`, must not be `None`")  # noqa: E501

        self._last_modified_date_time = last_modified_date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FulfillmentOrderCorrection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FulfillmentOrderCorrection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
