# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FulfillmentOrderCreate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fulfillment_order_id': 'str',
        'carrier_organization_id': 'str',
        'logistic_hub': 'LogisticHub',
        'one_label_only': 'bool',
        'load_carriers': 'list[AddLoadCarrierConfiguration]',
        'delivery_location_gln': 'str'
    }

    attribute_map = {
        'fulfillment_order_id': 'fulfillmentOrderId',
        'carrier_organization_id': 'carrierOrganizationId',
        'logistic_hub': 'logisticHub',
        'one_label_only': 'oneLabelOnly',
        'load_carriers': 'loadCarriers',
        'delivery_location_gln': 'deliveryLocationGln'
    }

    def __init__(self, fulfillment_order_id=None, carrier_organization_id=None, logistic_hub=None, one_label_only=None, load_carriers=None, delivery_location_gln=None):  # noqa: E501
        """FulfillmentOrderCreate - a model defined in Swagger"""  # noqa: E501
        self._fulfillment_order_id = None
        self._carrier_organization_id = None
        self._logistic_hub = None
        self._one_label_only = None
        self._load_carriers = None
        self._delivery_location_gln = None
        self.discriminator = None
        self.fulfillment_order_id = fulfillment_order_id
        if carrier_organization_id is not None:
            self.carrier_organization_id = carrier_organization_id
        if logistic_hub is not None:
            self.logistic_hub = logistic_hub
        self.one_label_only = one_label_only
        self.load_carriers = load_carriers
        if delivery_location_gln is not None:
            self.delivery_location_gln = delivery_location_gln

    @property
    def fulfillment_order_id(self):
        """Gets the fulfillment_order_id of this FulfillmentOrderCreate.  # noqa: E501


        :return: The fulfillment_order_id of this FulfillmentOrderCreate.  # noqa: E501
        :rtype: str
        """
        return self._fulfillment_order_id

    @fulfillment_order_id.setter
    def fulfillment_order_id(self, fulfillment_order_id):
        """Sets the fulfillment_order_id of this FulfillmentOrderCreate.


        :param fulfillment_order_id: The fulfillment_order_id of this FulfillmentOrderCreate.  # noqa: E501
        :type: str
        """
        if fulfillment_order_id is None:
            raise ValueError("Invalid value for `fulfillment_order_id`, must not be `None`")  # noqa: E501

        self._fulfillment_order_id = fulfillment_order_id

    @property
    def carrier_organization_id(self):
        """Gets the carrier_organization_id of this FulfillmentOrderCreate.  # noqa: E501


        :return: The carrier_organization_id of this FulfillmentOrderCreate.  # noqa: E501
        :rtype: str
        """
        return self._carrier_organization_id

    @carrier_organization_id.setter
    def carrier_organization_id(self, carrier_organization_id):
        """Sets the carrier_organization_id of this FulfillmentOrderCreate.


        :param carrier_organization_id: The carrier_organization_id of this FulfillmentOrderCreate.  # noqa: E501
        :type: str
        """

        self._carrier_organization_id = carrier_organization_id

    @property
    def logistic_hub(self):
        """Gets the logistic_hub of this FulfillmentOrderCreate.  # noqa: E501


        :return: The logistic_hub of this FulfillmentOrderCreate.  # noqa: E501
        :rtype: LogisticHub
        """
        return self._logistic_hub

    @logistic_hub.setter
    def logistic_hub(self, logistic_hub):
        """Sets the logistic_hub of this FulfillmentOrderCreate.


        :param logistic_hub: The logistic_hub of this FulfillmentOrderCreate.  # noqa: E501
        :type: LogisticHub
        """

        self._logistic_hub = logistic_hub

    @property
    def one_label_only(self):
        """Gets the one_label_only of this FulfillmentOrderCreate.  # noqa: E501

        If true, only one logistic label pdf will be provided  # noqa: E501

        :return: The one_label_only of this FulfillmentOrderCreate.  # noqa: E501
        :rtype: bool
        """
        return self._one_label_only

    @one_label_only.setter
    def one_label_only(self, one_label_only):
        """Sets the one_label_only of this FulfillmentOrderCreate.

        If true, only one logistic label pdf will be provided  # noqa: E501

        :param one_label_only: The one_label_only of this FulfillmentOrderCreate.  # noqa: E501
        :type: bool
        """
        if one_label_only is None:
            raise ValueError("Invalid value for `one_label_only`, must not be `None`")  # noqa: E501

        self._one_label_only = one_label_only

    @property
    def load_carriers(self):
        """Gets the load_carriers of this FulfillmentOrderCreate.  # noqa: E501


        :return: The load_carriers of this FulfillmentOrderCreate.  # noqa: E501
        :rtype: list[AddLoadCarrierConfiguration]
        """
        return self._load_carriers

    @load_carriers.setter
    def load_carriers(self, load_carriers):
        """Sets the load_carriers of this FulfillmentOrderCreate.


        :param load_carriers: The load_carriers of this FulfillmentOrderCreate.  # noqa: E501
        :type: list[AddLoadCarrierConfiguration]
        """
        if load_carriers is None:
            raise ValueError("Invalid value for `load_carriers`, must not be `None`")  # noqa: E501

        self._load_carriers = load_carriers

    @property
    def delivery_location_gln(self):
        """Gets the delivery_location_gln of this FulfillmentOrderCreate.  # noqa: E501

        Optional property to set a different delivery location from the delivery location known in the fulfillment requests. The location must be in the same country as the original delivery location.  # noqa: E501

        :return: The delivery_location_gln of this FulfillmentOrderCreate.  # noqa: E501
        :rtype: str
        """
        return self._delivery_location_gln

    @delivery_location_gln.setter
    def delivery_location_gln(self, delivery_location_gln):
        """Sets the delivery_location_gln of this FulfillmentOrderCreate.

        Optional property to set a different delivery location from the delivery location known in the fulfillment requests. The location must be in the same country as the original delivery location.  # noqa: E501

        :param delivery_location_gln: The delivery_location_gln of this FulfillmentOrderCreate.  # noqa: E501
        :type: str
        """

        self._delivery_location_gln = delivery_location_gln

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FulfillmentOrderCreate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FulfillmentOrderCreate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
