# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class FulfillmentOrderInbound(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fulfillment_order_id': 'str',
        'carrier_organization_id': 'str',
        'latest_delivery_date_time': 'datetime',
        'destination': 'Destination',
        'despatch_warehouse_id': 'str',
        'load_carriers': 'list[LoadCarrierConfigurationInbound]',
        'delivery_note_codes': 'list[str]',
        'supplier_organization_id': 'str',
        'status': 'FulfillmentStatus',
        'sequence_number': 'int',
        'creation_date_time': 'datetime',
        'last_modified_date_time': 'datetime'
    }

    attribute_map = {
        'fulfillment_order_id': 'fulfillmentOrderId',
        'carrier_organization_id': 'carrierOrganizationId',
        'latest_delivery_date_time': 'latestDeliveryDateTime',
        'destination': 'destination',
        'despatch_warehouse_id': 'despatchWarehouseId',
        'load_carriers': 'loadCarriers',
        'delivery_note_codes': 'deliveryNoteCodes',
        'supplier_organization_id': 'supplierOrganizationId',
        'status': 'status',
        'sequence_number': 'sequenceNumber',
        'creation_date_time': 'creationDateTime',
        'last_modified_date_time': 'lastModifiedDateTime'
    }

    def __init__(self, fulfillment_order_id=None, carrier_organization_id=None, latest_delivery_date_time=None, destination=None, despatch_warehouse_id=None, load_carriers=None, delivery_note_codes=None, supplier_organization_id=None, status=None, sequence_number=None, creation_date_time=None, last_modified_date_time=None):  # noqa: E501
        """FulfillmentOrderInbound - a model defined in Swagger"""  # noqa: E501
        self._fulfillment_order_id = None
        self._carrier_organization_id = None
        self._latest_delivery_date_time = None
        self._destination = None
        self._despatch_warehouse_id = None
        self._load_carriers = None
        self._delivery_note_codes = None
        self._supplier_organization_id = None
        self._status = None
        self._sequence_number = None
        self._creation_date_time = None
        self._last_modified_date_time = None
        self.discriminator = None
        self.fulfillment_order_id = fulfillment_order_id
        if carrier_organization_id is not None:
            self.carrier_organization_id = carrier_organization_id
        self.latest_delivery_date_time = latest_delivery_date_time
        self.destination = destination
        self.despatch_warehouse_id = despatch_warehouse_id
        self.load_carriers = load_carriers
        self.delivery_note_codes = delivery_note_codes
        self.supplier_organization_id = supplier_organization_id
        self.status = status
        self.sequence_number = sequence_number
        self.creation_date_time = creation_date_time
        self.last_modified_date_time = last_modified_date_time

    @property
    def fulfillment_order_id(self):
        """Gets the fulfillment_order_id of this FulfillmentOrderInbound.  # noqa: E501


        :return: The fulfillment_order_id of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: str
        """
        return self._fulfillment_order_id

    @fulfillment_order_id.setter
    def fulfillment_order_id(self, fulfillment_order_id):
        """Sets the fulfillment_order_id of this FulfillmentOrderInbound.


        :param fulfillment_order_id: The fulfillment_order_id of this FulfillmentOrderInbound.  # noqa: E501
        :type: str
        """
        if fulfillment_order_id is None:
            raise ValueError("Invalid value for `fulfillment_order_id`, must not be `None`")  # noqa: E501

        self._fulfillment_order_id = fulfillment_order_id

    @property
    def carrier_organization_id(self):
        """Gets the carrier_organization_id of this FulfillmentOrderInbound.  # noqa: E501


        :return: The carrier_organization_id of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: str
        """
        return self._carrier_organization_id

    @carrier_organization_id.setter
    def carrier_organization_id(self, carrier_organization_id):
        """Sets the carrier_organization_id of this FulfillmentOrderInbound.


        :param carrier_organization_id: The carrier_organization_id of this FulfillmentOrderInbound.  # noqa: E501
        :type: str
        """

        self._carrier_organization_id = carrier_organization_id

    @property
    def latest_delivery_date_time(self):
        """Gets the latest_delivery_date_time of this FulfillmentOrderInbound.  # noqa: E501


        :return: The latest_delivery_date_time of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: datetime
        """
        return self._latest_delivery_date_time

    @latest_delivery_date_time.setter
    def latest_delivery_date_time(self, latest_delivery_date_time):
        """Sets the latest_delivery_date_time of this FulfillmentOrderInbound.


        :param latest_delivery_date_time: The latest_delivery_date_time of this FulfillmentOrderInbound.  # noqa: E501
        :type: datetime
        """
        if latest_delivery_date_time is None:
            raise ValueError("Invalid value for `latest_delivery_date_time`, must not be `None`")  # noqa: E501

        self._latest_delivery_date_time = latest_delivery_date_time

    @property
    def destination(self):
        """Gets the destination of this FulfillmentOrderInbound.  # noqa: E501


        :return: The destination of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: Destination
        """
        return self._destination

    @destination.setter
    def destination(self, destination):
        """Sets the destination of this FulfillmentOrderInbound.


        :param destination: The destination of this FulfillmentOrderInbound.  # noqa: E501
        :type: Destination
        """
        if destination is None:
            raise ValueError("Invalid value for `destination`, must not be `None`")  # noqa: E501

        self._destination = destination

    @property
    def despatch_warehouse_id(self):
        """Gets the despatch_warehouse_id of this FulfillmentOrderInbound.  # noqa: E501


        :return: The despatch_warehouse_id of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: str
        """
        return self._despatch_warehouse_id

    @despatch_warehouse_id.setter
    def despatch_warehouse_id(self, despatch_warehouse_id):
        """Sets the despatch_warehouse_id of this FulfillmentOrderInbound.


        :param despatch_warehouse_id: The despatch_warehouse_id of this FulfillmentOrderInbound.  # noqa: E501
        :type: str
        """
        if despatch_warehouse_id is None:
            raise ValueError("Invalid value for `despatch_warehouse_id`, must not be `None`")  # noqa: E501

        self._despatch_warehouse_id = despatch_warehouse_id

    @property
    def load_carriers(self):
        """Gets the load_carriers of this FulfillmentOrderInbound.  # noqa: E501


        :return: The load_carriers of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: list[LoadCarrierConfigurationInbound]
        """
        return self._load_carriers

    @load_carriers.setter
    def load_carriers(self, load_carriers):
        """Sets the load_carriers of this FulfillmentOrderInbound.


        :param load_carriers: The load_carriers of this FulfillmentOrderInbound.  # noqa: E501
        :type: list[LoadCarrierConfigurationInbound]
        """
        if load_carriers is None:
            raise ValueError("Invalid value for `load_carriers`, must not be `None`")  # noqa: E501

        self._load_carriers = load_carriers

    @property
    def delivery_note_codes(self):
        """Gets the delivery_note_codes of this FulfillmentOrderInbound.  # noqa: E501


        :return: The delivery_note_codes of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: list[str]
        """
        return self._delivery_note_codes

    @delivery_note_codes.setter
    def delivery_note_codes(self, delivery_note_codes):
        """Sets the delivery_note_codes of this FulfillmentOrderInbound.


        :param delivery_note_codes: The delivery_note_codes of this FulfillmentOrderInbound.  # noqa: E501
        :type: list[str]
        """
        if delivery_note_codes is None:
            raise ValueError("Invalid value for `delivery_note_codes`, must not be `None`")  # noqa: E501

        self._delivery_note_codes = delivery_note_codes

    @property
    def supplier_organization_id(self):
        """Gets the supplier_organization_id of this FulfillmentOrderInbound.  # noqa: E501


        :return: The supplier_organization_id of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: str
        """
        return self._supplier_organization_id

    @supplier_organization_id.setter
    def supplier_organization_id(self, supplier_organization_id):
        """Sets the supplier_organization_id of this FulfillmentOrderInbound.


        :param supplier_organization_id: The supplier_organization_id of this FulfillmentOrderInbound.  # noqa: E501
        :type: str
        """
        if supplier_organization_id is None:
            raise ValueError("Invalid value for `supplier_organization_id`, must not be `None`")  # noqa: E501

        self._supplier_organization_id = supplier_organization_id

    @property
    def status(self):
        """Gets the status of this FulfillmentOrderInbound.  # noqa: E501


        :return: The status of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: FulfillmentStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this FulfillmentOrderInbound.


        :param status: The status of this FulfillmentOrderInbound.  # noqa: E501
        :type: FulfillmentStatus
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def sequence_number(self):
        """Gets the sequence_number of this FulfillmentOrderInbound.  # noqa: E501


        :return: The sequence_number of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this FulfillmentOrderInbound.


        :param sequence_number: The sequence_number of this FulfillmentOrderInbound.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    @property
    def creation_date_time(self):
        """Gets the creation_date_time of this FulfillmentOrderInbound.  # noqa: E501


        :return: The creation_date_time of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date_time

    @creation_date_time.setter
    def creation_date_time(self, creation_date_time):
        """Sets the creation_date_time of this FulfillmentOrderInbound.


        :param creation_date_time: The creation_date_time of this FulfillmentOrderInbound.  # noqa: E501
        :type: datetime
        """
        if creation_date_time is None:
            raise ValueError("Invalid value for `creation_date_time`, must not be `None`")  # noqa: E501

        self._creation_date_time = creation_date_time

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this FulfillmentOrderInbound.  # noqa: E501


        :return: The last_modified_date_time of this FulfillmentOrderInbound.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this FulfillmentOrderInbound.


        :param last_modified_date_time: The last_modified_date_time of this FulfillmentOrderInbound.  # noqa: E501
        :type: datetime
        """
        if last_modified_date_time is None:
            raise ValueError("Invalid value for `last_modified_date_time`, must not be `None`")  # noqa: E501

        self._last_modified_date_time = last_modified_date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FulfillmentOrderInbound, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FulfillmentOrderInbound):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
