# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class LoadCarrierItemInbound(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'batch_id': 'str',
        'number_of_packages': 'int',
        'service_code': 'int',
        'trade_item_id': 'str',
        'batch_reference': 'str',
        'delivery_note_code': 'str',
        'delivery_note_letter': 'str',
        'sort_index': 'int',
        'delivery_remarks': 'str'
    }

    attribute_map = {
        'batch_id': 'batchId',
        'number_of_packages': 'numberOfPackages',
        'service_code': 'serviceCode',
        'trade_item_id': 'tradeItemId',
        'batch_reference': 'batchReference',
        'delivery_note_code': 'deliveryNoteCode',
        'delivery_note_letter': 'deliveryNoteLetter',
        'sort_index': 'sortIndex',
        'delivery_remarks': 'deliveryRemarks'
    }

    def __init__(self, batch_id=None, number_of_packages=None, service_code=None, trade_item_id=None, batch_reference=None, delivery_note_code=None, delivery_note_letter=None, sort_index=None, delivery_remarks=None):  # noqa: E501
        """LoadCarrierItemInbound - a model defined in Swagger"""  # noqa: E501
        self._batch_id = None
        self._number_of_packages = None
        self._service_code = None
        self._trade_item_id = None
        self._batch_reference = None
        self._delivery_note_code = None
        self._delivery_note_letter = None
        self._sort_index = None
        self._delivery_remarks = None
        self.discriminator = None
        self.batch_id = batch_id
        self.number_of_packages = number_of_packages
        if service_code is not None:
            self.service_code = service_code
        self.trade_item_id = trade_item_id
        if batch_reference is not None:
            self.batch_reference = batch_reference
        if delivery_note_code is not None:
            self.delivery_note_code = delivery_note_code
        if delivery_note_letter is not None:
            self.delivery_note_letter = delivery_note_letter
        if sort_index is not None:
            self.sort_index = sort_index
        if delivery_remarks is not None:
            self.delivery_remarks = delivery_remarks

    @property
    def batch_id(self):
        """Gets the batch_id of this LoadCarrierItemInbound.  # noqa: E501


        :return: The batch_id of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """Sets the batch_id of this LoadCarrierItemInbound.


        :param batch_id: The batch_id of this LoadCarrierItemInbound.  # noqa: E501
        :type: str
        """
        if batch_id is None:
            raise ValueError("Invalid value for `batch_id`, must not be `None`")  # noqa: E501

        self._batch_id = batch_id

    @property
    def number_of_packages(self):
        """Gets the number_of_packages of this LoadCarrierItemInbound.  # noqa: E501


        :return: The number_of_packages of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: int
        """
        return self._number_of_packages

    @number_of_packages.setter
    def number_of_packages(self, number_of_packages):
        """Sets the number_of_packages of this LoadCarrierItemInbound.


        :param number_of_packages: The number_of_packages of this LoadCarrierItemInbound.  # noqa: E501
        :type: int
        """
        if number_of_packages is None:
            raise ValueError("Invalid value for `number_of_packages`, must not be `None`")  # noqa: E501

        self._number_of_packages = number_of_packages

    @property
    def service_code(self):
        """Gets the service_code of this LoadCarrierItemInbound.  # noqa: E501


        :return: The service_code of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: int
        """
        return self._service_code

    @service_code.setter
    def service_code(self, service_code):
        """Sets the service_code of this LoadCarrierItemInbound.


        :param service_code: The service_code of this LoadCarrierItemInbound.  # noqa: E501
        :type: int
        """

        self._service_code = service_code

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this LoadCarrierItemInbound.  # noqa: E501


        :return: The trade_item_id of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this LoadCarrierItemInbound.


        :param trade_item_id: The trade_item_id of this LoadCarrierItemInbound.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def batch_reference(self):
        """Gets the batch_reference of this LoadCarrierItemInbound.  # noqa: E501


        :return: The batch_reference of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: str
        """
        return self._batch_reference

    @batch_reference.setter
    def batch_reference(self, batch_reference):
        """Sets the batch_reference of this LoadCarrierItemInbound.


        :param batch_reference: The batch_reference of this LoadCarrierItemInbound.  # noqa: E501
        :type: str
        """

        self._batch_reference = batch_reference

    @property
    def delivery_note_code(self):
        """Gets the delivery_note_code of this LoadCarrierItemInbound.  # noqa: E501


        :return: The delivery_note_code of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: str
        """
        return self._delivery_note_code

    @delivery_note_code.setter
    def delivery_note_code(self, delivery_note_code):
        """Sets the delivery_note_code of this LoadCarrierItemInbound.


        :param delivery_note_code: The delivery_note_code of this LoadCarrierItemInbound.  # noqa: E501
        :type: str
        """

        self._delivery_note_code = delivery_note_code

    @property
    def delivery_note_letter(self):
        """Gets the delivery_note_letter of this LoadCarrierItemInbound.  # noqa: E501


        :return: The delivery_note_letter of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: str
        """
        return self._delivery_note_letter

    @delivery_note_letter.setter
    def delivery_note_letter(self, delivery_note_letter):
        """Sets the delivery_note_letter of this LoadCarrierItemInbound.


        :param delivery_note_letter: The delivery_note_letter of this LoadCarrierItemInbound.  # noqa: E501
        :type: str
        """

        self._delivery_note_letter = delivery_note_letter

    @property
    def sort_index(self):
        """Gets the sort_index of this LoadCarrierItemInbound.  # noqa: E501

        The index related to the item's position on the loadcarrier  # noqa: E501

        :return: The sort_index of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: int
        """
        return self._sort_index

    @sort_index.setter
    def sort_index(self, sort_index):
        """Sets the sort_index of this LoadCarrierItemInbound.

        The index related to the item's position on the loadcarrier  # noqa: E501

        :param sort_index: The sort_index of this LoadCarrierItemInbound.  # noqa: E501
        :type: int
        """

        self._sort_index = sort_index

    @property
    def delivery_remarks(self):
        """Gets the delivery_remarks of this LoadCarrierItemInbound.  # noqa: E501


        :return: The delivery_remarks of this LoadCarrierItemInbound.  # noqa: E501
        :rtype: str
        """
        return self._delivery_remarks

    @delivery_remarks.setter
    def delivery_remarks(self, delivery_remarks):
        """Sets the delivery_remarks of this LoadCarrierItemInbound.


        :param delivery_remarks: The delivery_remarks of this LoadCarrierItemInbound.  # noqa: E501
        :type: str
        """

        self._delivery_remarks = delivery_remarks

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LoadCarrierItemInbound, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LoadCarrierItemInbound):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
