# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NonWorkingDayDeliveryCondition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'non_working_day_public_holidays': 'list[PublicHoliday]',
        'deviating_time_frame': 'TimeFrame'
    }

    attribute_map = {
        'non_working_day_public_holidays': 'nonWorkingDayPublicHolidays',
        'deviating_time_frame': 'deviatingTimeFrame'
    }

    def __init__(self, non_working_day_public_holidays=None, deviating_time_frame=None):  # noqa: E501
        """NonWorkingDayDeliveryCondition - a model defined in Swagger"""  # noqa: E501
        self._non_working_day_public_holidays = None
        self._deviating_time_frame = None
        self.discriminator = None
        self.non_working_day_public_holidays = non_working_day_public_holidays
        if deviating_time_frame is not None:
            self.deviating_time_frame = deviating_time_frame

    @property
    def non_working_day_public_holidays(self):
        """Gets the non_working_day_public_holidays of this NonWorkingDayDeliveryCondition.  # noqa: E501


        :return: The non_working_day_public_holidays of this NonWorkingDayDeliveryCondition.  # noqa: E501
        :rtype: list[PublicHoliday]
        """
        return self._non_working_day_public_holidays

    @non_working_day_public_holidays.setter
    def non_working_day_public_holidays(self, non_working_day_public_holidays):
        """Sets the non_working_day_public_holidays of this NonWorkingDayDeliveryCondition.


        :param non_working_day_public_holidays: The non_working_day_public_holidays of this NonWorkingDayDeliveryCondition.  # noqa: E501
        :type: list[PublicHoliday]
        """
        if non_working_day_public_holidays is None:
            raise ValueError("Invalid value for `non_working_day_public_holidays`, must not be `None`")  # noqa: E501

        self._non_working_day_public_holidays = non_working_day_public_holidays

    @property
    def deviating_time_frame(self):
        """Gets the deviating_time_frame of this NonWorkingDayDeliveryCondition.  # noqa: E501


        :return: The deviating_time_frame of this NonWorkingDayDeliveryCondition.  # noqa: E501
        :rtype: TimeFrame
        """
        return self._deviating_time_frame

    @deviating_time_frame.setter
    def deviating_time_frame(self, deviating_time_frame):
        """Sets the deviating_time_frame of this NonWorkingDayDeliveryCondition.


        :param deviating_time_frame: The deviating_time_frame of this NonWorkingDayDeliveryCondition.  # noqa: E501
        :type: TimeFrame
        """

        self._deviating_time_frame = deviating_time_frame

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NonWorkingDayDeliveryCondition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NonWorkingDayDeliveryCondition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
