# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class OrderRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'order_request_id': 'str',
        'customer_organization_id': 'str',
        'supply_line_id': 'str',
        'trade_item_id': 'str',
        'number_of_pieces': 'int',
        'price_per_piece': 'Price',
        'packing_configuration': 'PackingConfigurationBase',
        'delivery': 'OrderRequestDelivery',
        'delivery_remarks': 'str',
        'reference': 'str',
        'additional_service_ids': 'list[str]',
        'added': 'datetime',
        'status': 'OrderRequestStatus',
        'declined_reason': 'str',
        'payment_provider': 'PaymentProvider',
        'sequence_number': 'int',
        'is_deleted': 'bool'
    }

    attribute_map = {
        'order_request_id': 'orderRequestId',
        'customer_organization_id': 'customerOrganizationId',
        'supply_line_id': 'supplyLineId',
        'trade_item_id': 'tradeItemId',
        'number_of_pieces': 'numberOfPieces',
        'price_per_piece': 'pricePerPiece',
        'packing_configuration': 'packingConfiguration',
        'delivery': 'delivery',
        'delivery_remarks': 'deliveryRemarks',
        'reference': 'reference',
        'additional_service_ids': 'additionalServiceIds',
        'added': 'added',
        'status': 'status',
        'declined_reason': 'declinedReason',
        'payment_provider': 'paymentProvider',
        'sequence_number': 'sequenceNumber',
        'is_deleted': 'isDeleted'
    }

    def __init__(self, order_request_id=None, customer_organization_id=None, supply_line_id=None, trade_item_id=None, number_of_pieces=None, price_per_piece=None, packing_configuration=None, delivery=None, delivery_remarks=None, reference=None, additional_service_ids=None, added=None, status=None, declined_reason=None, payment_provider=None, sequence_number=None, is_deleted=None):  # noqa: E501
        """OrderRequest - a model defined in Swagger"""  # noqa: E501
        self._order_request_id = None
        self._customer_organization_id = None
        self._supply_line_id = None
        self._trade_item_id = None
        self._number_of_pieces = None
        self._price_per_piece = None
        self._packing_configuration = None
        self._delivery = None
        self._delivery_remarks = None
        self._reference = None
        self._additional_service_ids = None
        self._added = None
        self._status = None
        self._declined_reason = None
        self._payment_provider = None
        self._sequence_number = None
        self._is_deleted = None
        self.discriminator = None
        self.order_request_id = order_request_id
        self.customer_organization_id = customer_organization_id
        if supply_line_id is not None:
            self.supply_line_id = supply_line_id
        self.trade_item_id = trade_item_id
        self.number_of_pieces = number_of_pieces
        self.price_per_piece = price_per_piece
        self.packing_configuration = packing_configuration
        self.delivery = delivery
        if delivery_remarks is not None:
            self.delivery_remarks = delivery_remarks
        if reference is not None:
            self.reference = reference
        self.additional_service_ids = additional_service_ids
        self.added = added
        self.status = status
        if declined_reason is not None:
            self.declined_reason = declined_reason
        if payment_provider is not None:
            self.payment_provider = payment_provider
        self.sequence_number = sequence_number
        self.is_deleted = is_deleted

    @property
    def order_request_id(self):
        """Gets the order_request_id of this OrderRequest.  # noqa: E501


        :return: The order_request_id of this OrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._order_request_id

    @order_request_id.setter
    def order_request_id(self, order_request_id):
        """Sets the order_request_id of this OrderRequest.


        :param order_request_id: The order_request_id of this OrderRequest.  # noqa: E501
        :type: str
        """
        if order_request_id is None:
            raise ValueError("Invalid value for `order_request_id`, must not be `None`")  # noqa: E501

        self._order_request_id = order_request_id

    @property
    def customer_organization_id(self):
        """Gets the customer_organization_id of this OrderRequest.  # noqa: E501


        :return: The customer_organization_id of this OrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._customer_organization_id

    @customer_organization_id.setter
    def customer_organization_id(self, customer_organization_id):
        """Sets the customer_organization_id of this OrderRequest.


        :param customer_organization_id: The customer_organization_id of this OrderRequest.  # noqa: E501
        :type: str
        """
        if customer_organization_id is None:
            raise ValueError("Invalid value for `customer_organization_id`, must not be `None`")  # noqa: E501

        self._customer_organization_id = customer_organization_id

    @property
    def supply_line_id(self):
        """Gets the supply_line_id of this OrderRequest.  # noqa: E501


        :return: The supply_line_id of this OrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._supply_line_id

    @supply_line_id.setter
    def supply_line_id(self, supply_line_id):
        """Sets the supply_line_id of this OrderRequest.


        :param supply_line_id: The supply_line_id of this OrderRequest.  # noqa: E501
        :type: str
        """

        self._supply_line_id = supply_line_id

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this OrderRequest.  # noqa: E501


        :return: The trade_item_id of this OrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this OrderRequest.


        :param trade_item_id: The trade_item_id of this OrderRequest.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this OrderRequest.  # noqa: E501


        :return: The number_of_pieces of this OrderRequest.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this OrderRequest.


        :param number_of_pieces: The number_of_pieces of this OrderRequest.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def price_per_piece(self):
        """Gets the price_per_piece of this OrderRequest.  # noqa: E501


        :return: The price_per_piece of this OrderRequest.  # noqa: E501
        :rtype: Price
        """
        return self._price_per_piece

    @price_per_piece.setter
    def price_per_piece(self, price_per_piece):
        """Sets the price_per_piece of this OrderRequest.


        :param price_per_piece: The price_per_piece of this OrderRequest.  # noqa: E501
        :type: Price
        """
        if price_per_piece is None:
            raise ValueError("Invalid value for `price_per_piece`, must not be `None`")  # noqa: E501

        self._price_per_piece = price_per_piece

    @property
    def packing_configuration(self):
        """Gets the packing_configuration of this OrderRequest.  # noqa: E501


        :return: The packing_configuration of this OrderRequest.  # noqa: E501
        :rtype: PackingConfigurationBase
        """
        return self._packing_configuration

    @packing_configuration.setter
    def packing_configuration(self, packing_configuration):
        """Sets the packing_configuration of this OrderRequest.


        :param packing_configuration: The packing_configuration of this OrderRequest.  # noqa: E501
        :type: PackingConfigurationBase
        """
        if packing_configuration is None:
            raise ValueError("Invalid value for `packing_configuration`, must not be `None`")  # noqa: E501

        self._packing_configuration = packing_configuration

    @property
    def delivery(self):
        """Gets the delivery of this OrderRequest.  # noqa: E501


        :return: The delivery of this OrderRequest.  # noqa: E501
        :rtype: OrderRequestDelivery
        """
        return self._delivery

    @delivery.setter
    def delivery(self, delivery):
        """Sets the delivery of this OrderRequest.


        :param delivery: The delivery of this OrderRequest.  # noqa: E501
        :type: OrderRequestDelivery
        """
        if delivery is None:
            raise ValueError("Invalid value for `delivery`, must not be `None`")  # noqa: E501

        self._delivery = delivery

    @property
    def delivery_remarks(self):
        """Gets the delivery_remarks of this OrderRequest.  # noqa: E501


        :return: The delivery_remarks of this OrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._delivery_remarks

    @delivery_remarks.setter
    def delivery_remarks(self, delivery_remarks):
        """Sets the delivery_remarks of this OrderRequest.


        :param delivery_remarks: The delivery_remarks of this OrderRequest.  # noqa: E501
        :type: str
        """

        self._delivery_remarks = delivery_remarks

    @property
    def reference(self):
        """Gets the reference of this OrderRequest.  # noqa: E501


        :return: The reference of this OrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._reference

    @reference.setter
    def reference(self, reference):
        """Sets the reference of this OrderRequest.


        :param reference: The reference of this OrderRequest.  # noqa: E501
        :type: str
        """

        self._reference = reference

    @property
    def additional_service_ids(self):
        """Gets the additional_service_ids of this OrderRequest.  # noqa: E501


        :return: The additional_service_ids of this OrderRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._additional_service_ids

    @additional_service_ids.setter
    def additional_service_ids(self, additional_service_ids):
        """Sets the additional_service_ids of this OrderRequest.


        :param additional_service_ids: The additional_service_ids of this OrderRequest.  # noqa: E501
        :type: list[str]
        """
        if additional_service_ids is None:
            raise ValueError("Invalid value for `additional_service_ids`, must not be `None`")  # noqa: E501

        self._additional_service_ids = additional_service_ids

    @property
    def added(self):
        """Gets the added of this OrderRequest.  # noqa: E501


        :return: The added of this OrderRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._added

    @added.setter
    def added(self, added):
        """Sets the added of this OrderRequest.


        :param added: The added of this OrderRequest.  # noqa: E501
        :type: datetime
        """
        if added is None:
            raise ValueError("Invalid value for `added`, must not be `None`")  # noqa: E501

        self._added = added

    @property
    def status(self):
        """Gets the status of this OrderRequest.  # noqa: E501


        :return: The status of this OrderRequest.  # noqa: E501
        :rtype: OrderRequestStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this OrderRequest.


        :param status: The status of this OrderRequest.  # noqa: E501
        :type: OrderRequestStatus
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def declined_reason(self):
        """Gets the declined_reason of this OrderRequest.  # noqa: E501


        :return: The declined_reason of this OrderRequest.  # noqa: E501
        :rtype: str
        """
        return self._declined_reason

    @declined_reason.setter
    def declined_reason(self, declined_reason):
        """Sets the declined_reason of this OrderRequest.


        :param declined_reason: The declined_reason of this OrderRequest.  # noqa: E501
        :type: str
        """

        self._declined_reason = declined_reason

    @property
    def payment_provider(self):
        """Gets the payment_provider of this OrderRequest.  # noqa: E501


        :return: The payment_provider of this OrderRequest.  # noqa: E501
        :rtype: PaymentProvider
        """
        return self._payment_provider

    @payment_provider.setter
    def payment_provider(self, payment_provider):
        """Sets the payment_provider of this OrderRequest.


        :param payment_provider: The payment_provider of this OrderRequest.  # noqa: E501
        :type: PaymentProvider
        """

        self._payment_provider = payment_provider

    @property
    def sequence_number(self):
        """Gets the sequence_number of this OrderRequest.  # noqa: E501


        :return: The sequence_number of this OrderRequest.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this OrderRequest.


        :param sequence_number: The sequence_number of this OrderRequest.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    @property
    def is_deleted(self):
        """Gets the is_deleted of this OrderRequest.  # noqa: E501


        :return: The is_deleted of this OrderRequest.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this OrderRequest.


        :param is_deleted: The is_deleted of this OrderRequest.  # noqa: E501
        :type: bool
        """
        if is_deleted is None:
            raise ValueError("Invalid value for `is_deleted`, must not be `None`")  # noqa: E501

        self._is_deleted = is_deleted

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
