# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PackingConfigurationBase(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pieces_per_package': 'int',
        'vbn_package_code': 'int',
        'custom_package_id': 'str',
        'packages_per_layer': 'int',
        'layers_per_load_carrier': 'int',
        'load_carrier': 'LoadCarrierType',
        'photo_url': 'str'
    }

    attribute_map = {
        'pieces_per_package': 'piecesPerPackage',
        'vbn_package_code': 'vbnPackageCode',
        'custom_package_id': 'customPackageId',
        'packages_per_layer': 'packagesPerLayer',
        'layers_per_load_carrier': 'layersPerLoadCarrier',
        'load_carrier': 'loadCarrier',
        'photo_url': 'photoUrl'
    }

    def __init__(self, pieces_per_package=None, vbn_package_code=None, custom_package_id=None, packages_per_layer=None, layers_per_load_carrier=None, load_carrier=None, photo_url=None):  # noqa: E501
        """PackingConfigurationBase - a model defined in Swagger"""  # noqa: E501
        self._pieces_per_package = None
        self._vbn_package_code = None
        self._custom_package_id = None
        self._packages_per_layer = None
        self._layers_per_load_carrier = None
        self._load_carrier = None
        self._photo_url = None
        self.discriminator = None
        self.pieces_per_package = pieces_per_package
        self.vbn_package_code = vbn_package_code
        if custom_package_id is not None:
            self.custom_package_id = custom_package_id
        self.packages_per_layer = packages_per_layer
        self.layers_per_load_carrier = layers_per_load_carrier
        self.load_carrier = load_carrier
        if photo_url is not None:
            self.photo_url = photo_url

    @property
    def pieces_per_package(self):
        """Gets the pieces_per_package of this PackingConfigurationBase.  # noqa: E501


        :return: The pieces_per_package of this PackingConfigurationBase.  # noqa: E501
        :rtype: int
        """
        return self._pieces_per_package

    @pieces_per_package.setter
    def pieces_per_package(self, pieces_per_package):
        """Sets the pieces_per_package of this PackingConfigurationBase.


        :param pieces_per_package: The pieces_per_package of this PackingConfigurationBase.  # noqa: E501
        :type: int
        """
        if pieces_per_package is None:
            raise ValueError("Invalid value for `pieces_per_package`, must not be `None`")  # noqa: E501

        self._pieces_per_package = pieces_per_package

    @property
    def vbn_package_code(self):
        """Gets the vbn_package_code of this PackingConfigurationBase.  # noqa: E501


        :return: The vbn_package_code of this PackingConfigurationBase.  # noqa: E501
        :rtype: int
        """
        return self._vbn_package_code

    @vbn_package_code.setter
    def vbn_package_code(self, vbn_package_code):
        """Sets the vbn_package_code of this PackingConfigurationBase.


        :param vbn_package_code: The vbn_package_code of this PackingConfigurationBase.  # noqa: E501
        :type: int
        """
        if vbn_package_code is None:
            raise ValueError("Invalid value for `vbn_package_code`, must not be `None`")  # noqa: E501

        self._vbn_package_code = vbn_package_code

    @property
    def custom_package_id(self):
        """Gets the custom_package_id of this PackingConfigurationBase.  # noqa: E501


        :return: The custom_package_id of this PackingConfigurationBase.  # noqa: E501
        :rtype: str
        """
        return self._custom_package_id

    @custom_package_id.setter
    def custom_package_id(self, custom_package_id):
        """Sets the custom_package_id of this PackingConfigurationBase.


        :param custom_package_id: The custom_package_id of this PackingConfigurationBase.  # noqa: E501
        :type: str
        """

        self._custom_package_id = custom_package_id

    @property
    def packages_per_layer(self):
        """Gets the packages_per_layer of this PackingConfigurationBase.  # noqa: E501


        :return: The packages_per_layer of this PackingConfigurationBase.  # noqa: E501
        :rtype: int
        """
        return self._packages_per_layer

    @packages_per_layer.setter
    def packages_per_layer(self, packages_per_layer):
        """Sets the packages_per_layer of this PackingConfigurationBase.


        :param packages_per_layer: The packages_per_layer of this PackingConfigurationBase.  # noqa: E501
        :type: int
        """
        if packages_per_layer is None:
            raise ValueError("Invalid value for `packages_per_layer`, must not be `None`")  # noqa: E501

        self._packages_per_layer = packages_per_layer

    @property
    def layers_per_load_carrier(self):
        """Gets the layers_per_load_carrier of this PackingConfigurationBase.  # noqa: E501


        :return: The layers_per_load_carrier of this PackingConfigurationBase.  # noqa: E501
        :rtype: int
        """
        return self._layers_per_load_carrier

    @layers_per_load_carrier.setter
    def layers_per_load_carrier(self, layers_per_load_carrier):
        """Sets the layers_per_load_carrier of this PackingConfigurationBase.


        :param layers_per_load_carrier: The layers_per_load_carrier of this PackingConfigurationBase.  # noqa: E501
        :type: int
        """
        if layers_per_load_carrier is None:
            raise ValueError("Invalid value for `layers_per_load_carrier`, must not be `None`")  # noqa: E501

        self._layers_per_load_carrier = layers_per_load_carrier

    @property
    def load_carrier(self):
        """Gets the load_carrier of this PackingConfigurationBase.  # noqa: E501


        :return: The load_carrier of this PackingConfigurationBase.  # noqa: E501
        :rtype: LoadCarrierType
        """
        return self._load_carrier

    @load_carrier.setter
    def load_carrier(self, load_carrier):
        """Sets the load_carrier of this PackingConfigurationBase.


        :param load_carrier: The load_carrier of this PackingConfigurationBase.  # noqa: E501
        :type: LoadCarrierType
        """
        if load_carrier is None:
            raise ValueError("Invalid value for `load_carrier`, must not be `None`")  # noqa: E501

        self._load_carrier = load_carrier

    @property
    def photo_url(self):
        """Gets the photo_url of this PackingConfigurationBase.  # noqa: E501

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :return: The photo_url of this PackingConfigurationBase.  # noqa: E501
        :rtype: str
        """
        return self._photo_url

    @photo_url.setter
    def photo_url(self, photo_url):
        """Sets the photo_url of this PackingConfigurationBase.

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :param photo_url: The photo_url of this PackingConfigurationBase.  # noqa: E501
        :type: str
        """

        self._photo_url = photo_url

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PackingConfigurationBase, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PackingConfigurationBase):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
