# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class QuantityCorrection(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'correction_id': 'str',
        'delta_in_pieces': 'int',
        'new_number_of_pieces': 'int',
        'reason': 'str'
    }

    attribute_map = {
        'correction_id': 'correctionId',
        'delta_in_pieces': 'deltaInPieces',
        'new_number_of_pieces': 'newNumberOfPieces',
        'reason': 'reason'
    }

    def __init__(self, correction_id=None, delta_in_pieces=None, new_number_of_pieces=None, reason=None):  # noqa: E501
        """QuantityCorrection - a model defined in Swagger"""  # noqa: E501
        self._correction_id = None
        self._delta_in_pieces = None
        self._new_number_of_pieces = None
        self._reason = None
        self.discriminator = None
        self.correction_id = correction_id
        if delta_in_pieces is not None:
            self.delta_in_pieces = delta_in_pieces
        if new_number_of_pieces is not None:
            self.new_number_of_pieces = new_number_of_pieces
        if reason is not None:
            self.reason = reason

    @property
    def correction_id(self):
        """Gets the correction_id of this QuantityCorrection.  # noqa: E501


        :return: The correction_id of this QuantityCorrection.  # noqa: E501
        :rtype: str
        """
        return self._correction_id

    @correction_id.setter
    def correction_id(self, correction_id):
        """Sets the correction_id of this QuantityCorrection.


        :param correction_id: The correction_id of this QuantityCorrection.  # noqa: E501
        :type: str
        """
        if correction_id is None:
            raise ValueError("Invalid value for `correction_id`, must not be `None`")  # noqa: E501

        self._correction_id = correction_id

    @property
    def delta_in_pieces(self):
        """Gets the delta_in_pieces of this QuantityCorrection.  # noqa: E501


        :return: The delta_in_pieces of this QuantityCorrection.  # noqa: E501
        :rtype: int
        """
        return self._delta_in_pieces

    @delta_in_pieces.setter
    def delta_in_pieces(self, delta_in_pieces):
        """Sets the delta_in_pieces of this QuantityCorrection.


        :param delta_in_pieces: The delta_in_pieces of this QuantityCorrection.  # noqa: E501
        :type: int
        """

        self._delta_in_pieces = delta_in_pieces

    @property
    def new_number_of_pieces(self):
        """Gets the new_number_of_pieces of this QuantityCorrection.  # noqa: E501


        :return: The new_number_of_pieces of this QuantityCorrection.  # noqa: E501
        :rtype: int
        """
        return self._new_number_of_pieces

    @new_number_of_pieces.setter
    def new_number_of_pieces(self, new_number_of_pieces):
        """Sets the new_number_of_pieces of this QuantityCorrection.


        :param new_number_of_pieces: The new_number_of_pieces of this QuantityCorrection.  # noqa: E501
        :type: int
        """

        self._new_number_of_pieces = new_number_of_pieces

    @property
    def reason(self):
        """Gets the reason of this QuantityCorrection.  # noqa: E501


        :return: The reason of this QuantityCorrection.  # noqa: E501
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this QuantityCorrection.


        :param reason: The reason of this QuantityCorrection.  # noqa: E501
        :type: str
        """

        self._reason = reason

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(QuantityCorrection, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QuantityCorrection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
