# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SupplyLine(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'supply_line_id': 'str',
        'status': 'SupplyStatus',
        'trade_item_id': 'str',
        'batch_id': 'str',
        'price_per_piece': 'Price',
        'price_per_piece_last_modified': 'datetime',
        'volume_prices': 'list[VolumePrice]',
        'number_of_pieces': 'int',
        'packing_configurations': 'list[SupplyLinePackingConfiguration]',
        'order_period': 'TradePeriod',
        'delivery_period': 'TradePeriod',
        'included_services': 'list[CommercialService]',
        'allowed_customer_organization_ids': 'list[str]',
        'sequence_number': 'int',
        'supply_type': 'SupplyType',
        'agreement_reference': 'AgreementReference',
        'sales_unit': 'SalesUnit',
        'is_promo': 'bool',
        'is_deleted': 'bool',
        'price_group_name': 'str'
    }

    attribute_map = {
        'supply_line_id': 'supplyLineId',
        'status': 'status',
        'trade_item_id': 'tradeItemId',
        'batch_id': 'batchId',
        'price_per_piece': 'pricePerPiece',
        'price_per_piece_last_modified': 'pricePerPieceLastModified',
        'volume_prices': 'volumePrices',
        'number_of_pieces': 'numberOfPieces',
        'packing_configurations': 'packingConfigurations',
        'order_period': 'orderPeriod',
        'delivery_period': 'deliveryPeriod',
        'included_services': 'includedServices',
        'allowed_customer_organization_ids': 'allowedCustomerOrganizationIds',
        'sequence_number': 'sequenceNumber',
        'supply_type': 'supplyType',
        'agreement_reference': 'agreementReference',
        'sales_unit': 'salesUnit',
        'is_promo': 'isPromo',
        'is_deleted': 'isDeleted',
        'price_group_name': 'priceGroupName'
    }

    def __init__(self, supply_line_id=None, status=None, trade_item_id=None, batch_id=None, price_per_piece=None, price_per_piece_last_modified=None, volume_prices=None, number_of_pieces=None, packing_configurations=None, order_period=None, delivery_period=None, included_services=None, allowed_customer_organization_ids=None, sequence_number=None, supply_type=None, agreement_reference=None, sales_unit=None, is_promo=None, is_deleted=None, price_group_name=None):  # noqa: E501
        """SupplyLine - a model defined in Swagger"""  # noqa: E501
        self._supply_line_id = None
        self._status = None
        self._trade_item_id = None
        self._batch_id = None
        self._price_per_piece = None
        self._price_per_piece_last_modified = None
        self._volume_prices = None
        self._number_of_pieces = None
        self._packing_configurations = None
        self._order_period = None
        self._delivery_period = None
        self._included_services = None
        self._allowed_customer_organization_ids = None
        self._sequence_number = None
        self._supply_type = None
        self._agreement_reference = None
        self._sales_unit = None
        self._is_promo = None
        self._is_deleted = None
        self._price_group_name = None
        self.discriminator = None
        self.supply_line_id = supply_line_id
        self.status = status
        self.trade_item_id = trade_item_id
        if batch_id is not None:
            self.batch_id = batch_id
        self.price_per_piece = price_per_piece
        if price_per_piece_last_modified is not None:
            self.price_per_piece_last_modified = price_per_piece_last_modified
        self.volume_prices = volume_prices
        self.number_of_pieces = number_of_pieces
        if packing_configurations is not None:
            self.packing_configurations = packing_configurations
        self.order_period = order_period
        if delivery_period is not None:
            self.delivery_period = delivery_period
        if included_services is not None:
            self.included_services = included_services
        if allowed_customer_organization_ids is not None:
            self.allowed_customer_organization_ids = allowed_customer_organization_ids
        self.sequence_number = sequence_number
        if supply_type is not None:
            self.supply_type = supply_type
        if agreement_reference is not None:
            self.agreement_reference = agreement_reference
        if sales_unit is not None:
            self.sales_unit = sales_unit
        if is_promo is not None:
            self.is_promo = is_promo
        if is_deleted is not None:
            self.is_deleted = is_deleted
        if price_group_name is not None:
            self.price_group_name = price_group_name

    @property
    def supply_line_id(self):
        """Gets the supply_line_id of this SupplyLine.  # noqa: E501


        :return: The supply_line_id of this SupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._supply_line_id

    @supply_line_id.setter
    def supply_line_id(self, supply_line_id):
        """Sets the supply_line_id of this SupplyLine.


        :param supply_line_id: The supply_line_id of this SupplyLine.  # noqa: E501
        :type: str
        """
        if supply_line_id is None:
            raise ValueError("Invalid value for `supply_line_id`, must not be `None`")  # noqa: E501

        self._supply_line_id = supply_line_id

    @property
    def status(self):
        """Gets the status of this SupplyLine.  # noqa: E501


        :return: The status of this SupplyLine.  # noqa: E501
        :rtype: SupplyStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this SupplyLine.


        :param status: The status of this SupplyLine.  # noqa: E501
        :type: SupplyStatus
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this SupplyLine.  # noqa: E501


        :return: The trade_item_id of this SupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this SupplyLine.


        :param trade_item_id: The trade_item_id of this SupplyLine.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def batch_id(self):
        """Gets the batch_id of this SupplyLine.  # noqa: E501


        :return: The batch_id of this SupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """Sets the batch_id of this SupplyLine.


        :param batch_id: The batch_id of this SupplyLine.  # noqa: E501
        :type: str
        """

        self._batch_id = batch_id

    @property
    def price_per_piece(self):
        """Gets the price_per_piece of this SupplyLine.  # noqa: E501


        :return: The price_per_piece of this SupplyLine.  # noqa: E501
        :rtype: Price
        """
        return self._price_per_piece

    @price_per_piece.setter
    def price_per_piece(self, price_per_piece):
        """Sets the price_per_piece of this SupplyLine.


        :param price_per_piece: The price_per_piece of this SupplyLine.  # noqa: E501
        :type: Price
        """
        if price_per_piece is None:
            raise ValueError("Invalid value for `price_per_piece`, must not be `None`")  # noqa: E501

        self._price_per_piece = price_per_piece

    @property
    def price_per_piece_last_modified(self):
        """Gets the price_per_piece_last_modified of this SupplyLine.  # noqa: E501

        This field is set when the price has been changed by the supplier. Catalog prices in a closed week can only be changed once per 24 hours.  # noqa: E501

        :return: The price_per_piece_last_modified of this SupplyLine.  # noqa: E501
        :rtype: datetime
        """
        return self._price_per_piece_last_modified

    @price_per_piece_last_modified.setter
    def price_per_piece_last_modified(self, price_per_piece_last_modified):
        """Sets the price_per_piece_last_modified of this SupplyLine.

        This field is set when the price has been changed by the supplier. Catalog prices in a closed week can only be changed once per 24 hours.  # noqa: E501

        :param price_per_piece_last_modified: The price_per_piece_last_modified of this SupplyLine.  # noqa: E501
        :type: datetime
        """

        self._price_per_piece_last_modified = price_per_piece_last_modified

    @property
    def volume_prices(self):
        """Gets the volume_prices of this SupplyLine.  # noqa: E501


        :return: The volume_prices of this SupplyLine.  # noqa: E501
        :rtype: list[VolumePrice]
        """
        return self._volume_prices

    @volume_prices.setter
    def volume_prices(self, volume_prices):
        """Sets the volume_prices of this SupplyLine.


        :param volume_prices: The volume_prices of this SupplyLine.  # noqa: E501
        :type: list[VolumePrice]
        """
        if volume_prices is None:
            raise ValueError("Invalid value for `volume_prices`, must not be `None`")  # noqa: E501

        self._volume_prices = volume_prices

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this SupplyLine.  # noqa: E501


        :return: The number_of_pieces of this SupplyLine.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this SupplyLine.


        :param number_of_pieces: The number_of_pieces of this SupplyLine.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def packing_configurations(self):
        """Gets the packing_configurations of this SupplyLine.  # noqa: E501


        :return: The packing_configurations of this SupplyLine.  # noqa: E501
        :rtype: list[SupplyLinePackingConfiguration]
        """
        return self._packing_configurations

    @packing_configurations.setter
    def packing_configurations(self, packing_configurations):
        """Sets the packing_configurations of this SupplyLine.


        :param packing_configurations: The packing_configurations of this SupplyLine.  # noqa: E501
        :type: list[SupplyLinePackingConfiguration]
        """

        self._packing_configurations = packing_configurations

    @property
    def order_period(self):
        """Gets the order_period of this SupplyLine.  # noqa: E501


        :return: The order_period of this SupplyLine.  # noqa: E501
        :rtype: TradePeriod
        """
        return self._order_period

    @order_period.setter
    def order_period(self, order_period):
        """Sets the order_period of this SupplyLine.


        :param order_period: The order_period of this SupplyLine.  # noqa: E501
        :type: TradePeriod
        """
        if order_period is None:
            raise ValueError("Invalid value for `order_period`, must not be `None`")  # noqa: E501

        self._order_period = order_period

    @property
    def delivery_period(self):
        """Gets the delivery_period of this SupplyLine.  # noqa: E501


        :return: The delivery_period of this SupplyLine.  # noqa: E501
        :rtype: TradePeriod
        """
        return self._delivery_period

    @delivery_period.setter
    def delivery_period(self, delivery_period):
        """Sets the delivery_period of this SupplyLine.


        :param delivery_period: The delivery_period of this SupplyLine.  # noqa: E501
        :type: TradePeriod
        """

        self._delivery_period = delivery_period

    @property
    def included_services(self):
        """Gets the included_services of this SupplyLine.  # noqa: E501


        :return: The included_services of this SupplyLine.  # noqa: E501
        :rtype: list[CommercialService]
        """
        return self._included_services

    @included_services.setter
    def included_services(self, included_services):
        """Sets the included_services of this SupplyLine.


        :param included_services: The included_services of this SupplyLine.  # noqa: E501
        :type: list[CommercialService]
        """

        self._included_services = included_services

    @property
    def allowed_customer_organization_ids(self):
        """Gets the allowed_customer_organization_ids of this SupplyLine.  # noqa: E501


        :return: The allowed_customer_organization_ids of this SupplyLine.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_customer_organization_ids

    @allowed_customer_organization_ids.setter
    def allowed_customer_organization_ids(self, allowed_customer_organization_ids):
        """Sets the allowed_customer_organization_ids of this SupplyLine.


        :param allowed_customer_organization_ids: The allowed_customer_organization_ids of this SupplyLine.  # noqa: E501
        :type: list[str]
        """

        self._allowed_customer_organization_ids = allowed_customer_organization_ids

    @property
    def sequence_number(self):
        """Gets the sequence_number of this SupplyLine.  # noqa: E501


        :return: The sequence_number of this SupplyLine.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this SupplyLine.


        :param sequence_number: The sequence_number of this SupplyLine.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    @property
    def supply_type(self):
        """Gets the supply_type of this SupplyLine.  # noqa: E501


        :return: The supply_type of this SupplyLine.  # noqa: E501
        :rtype: SupplyType
        """
        return self._supply_type

    @supply_type.setter
    def supply_type(self, supply_type):
        """Sets the supply_type of this SupplyLine.


        :param supply_type: The supply_type of this SupplyLine.  # noqa: E501
        :type: SupplyType
        """

        self._supply_type = supply_type

    @property
    def agreement_reference(self):
        """Gets the agreement_reference of this SupplyLine.  # noqa: E501


        :return: The agreement_reference of this SupplyLine.  # noqa: E501
        :rtype: AgreementReference
        """
        return self._agreement_reference

    @agreement_reference.setter
    def agreement_reference(self, agreement_reference):
        """Sets the agreement_reference of this SupplyLine.


        :param agreement_reference: The agreement_reference of this SupplyLine.  # noqa: E501
        :type: AgreementReference
        """

        self._agreement_reference = agreement_reference

    @property
    def sales_unit(self):
        """Gets the sales_unit of this SupplyLine.  # noqa: E501


        :return: The sales_unit of this SupplyLine.  # noqa: E501
        :rtype: SalesUnit
        """
        return self._sales_unit

    @sales_unit.setter
    def sales_unit(self, sales_unit):
        """Sets the sales_unit of this SupplyLine.


        :param sales_unit: The sales_unit of this SupplyLine.  # noqa: E501
        :type: SalesUnit
        """

        self._sales_unit = sales_unit

    @property
    def is_promo(self):
        """Gets the is_promo of this SupplyLine.  # noqa: E501


        :return: The is_promo of this SupplyLine.  # noqa: E501
        :rtype: bool
        """
        return self._is_promo

    @is_promo.setter
    def is_promo(self, is_promo):
        """Sets the is_promo of this SupplyLine.


        :param is_promo: The is_promo of this SupplyLine.  # noqa: E501
        :type: bool
        """

        self._is_promo = is_promo

    @property
    def is_deleted(self):
        """Gets the is_deleted of this SupplyLine.  # noqa: E501


        :return: The is_deleted of this SupplyLine.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this SupplyLine.


        :param is_deleted: The is_deleted of this SupplyLine.  # noqa: E501
        :type: bool
        """

        self._is_deleted = is_deleted

    @property
    def price_group_name(self):
        """Gets the price_group_name of this SupplyLine.  # noqa: E501


        :return: The price_group_name of this SupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._price_group_name

    @price_group_name.setter
    def price_group_name(self, price_group_name):
        """Sets the price_group_name of this SupplyLine.


        :param price_group_name: The price_group_name of this SupplyLine.  # noqa: E501
        :type: str
        """

        self._price_group_name = price_group_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SupplyLine, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupplyLine):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
