# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class SupplyLinePackingConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pieces_per_package': 'int',
        'package': 'Package',
        'packages_per_layer': 'int',
        'layers_per_load_carrier': 'int',
        'transport_height_in_cm': 'int',
        'load_carrier': 'SupplyLoadCarrierType',
        'additional_price_per_piece': 'Price',
        'photo_url': 'str',
        'allowed_customer_organization_ids': 'list[str]'
    }

    attribute_map = {
        'pieces_per_package': 'piecesPerPackage',
        'package': 'package',
        'packages_per_layer': 'packagesPerLayer',
        'layers_per_load_carrier': 'layersPerLoadCarrier',
        'transport_height_in_cm': 'transportHeightInCm',
        'load_carrier': 'loadCarrier',
        'additional_price_per_piece': 'additionalPricePerPiece',
        'photo_url': 'photoUrl',
        'allowed_customer_organization_ids': 'allowedCustomerOrganizationIds'
    }

    def __init__(self, pieces_per_package=None, package=None, packages_per_layer=None, layers_per_load_carrier=None, transport_height_in_cm=None, load_carrier=None, additional_price_per_piece=None, photo_url=None, allowed_customer_organization_ids=None):  # noqa: E501
        """SupplyLinePackingConfiguration - a model defined in Swagger"""  # noqa: E501
        self._pieces_per_package = None
        self._package = None
        self._packages_per_layer = None
        self._layers_per_load_carrier = None
        self._transport_height_in_cm = None
        self._load_carrier = None
        self._additional_price_per_piece = None
        self._photo_url = None
        self._allowed_customer_organization_ids = None
        self.discriminator = None
        self.pieces_per_package = pieces_per_package
        self.package = package
        self.packages_per_layer = packages_per_layer
        self.layers_per_load_carrier = layers_per_load_carrier
        if transport_height_in_cm is not None:
            self.transport_height_in_cm = transport_height_in_cm
        self.load_carrier = load_carrier
        if additional_price_per_piece is not None:
            self.additional_price_per_piece = additional_price_per_piece
        if photo_url is not None:
            self.photo_url = photo_url
        if allowed_customer_organization_ids is not None:
            self.allowed_customer_organization_ids = allowed_customer_organization_ids

    @property
    def pieces_per_package(self):
        """Gets the pieces_per_package of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The pieces_per_package of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._pieces_per_package

    @pieces_per_package.setter
    def pieces_per_package(self, pieces_per_package):
        """Sets the pieces_per_package of this SupplyLinePackingConfiguration.


        :param pieces_per_package: The pieces_per_package of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: int
        """
        if pieces_per_package is None:
            raise ValueError("Invalid value for `pieces_per_package`, must not be `None`")  # noqa: E501

        self._pieces_per_package = pieces_per_package

    @property
    def package(self):
        """Gets the package of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The package of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: Package
        """
        return self._package

    @package.setter
    def package(self, package):
        """Sets the package of this SupplyLinePackingConfiguration.


        :param package: The package of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: Package
        """
        if package is None:
            raise ValueError("Invalid value for `package`, must not be `None`")  # noqa: E501

        self._package = package

    @property
    def packages_per_layer(self):
        """Gets the packages_per_layer of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The packages_per_layer of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._packages_per_layer

    @packages_per_layer.setter
    def packages_per_layer(self, packages_per_layer):
        """Sets the packages_per_layer of this SupplyLinePackingConfiguration.


        :param packages_per_layer: The packages_per_layer of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: int
        """
        if packages_per_layer is None:
            raise ValueError("Invalid value for `packages_per_layer`, must not be `None`")  # noqa: E501

        self._packages_per_layer = packages_per_layer

    @property
    def layers_per_load_carrier(self):
        """Gets the layers_per_load_carrier of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The layers_per_load_carrier of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._layers_per_load_carrier

    @layers_per_load_carrier.setter
    def layers_per_load_carrier(self, layers_per_load_carrier):
        """Sets the layers_per_load_carrier of this SupplyLinePackingConfiguration.


        :param layers_per_load_carrier: The layers_per_load_carrier of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: int
        """
        if layers_per_load_carrier is None:
            raise ValueError("Invalid value for `layers_per_load_carrier`, must not be `None`")  # noqa: E501

        self._layers_per_load_carrier = layers_per_load_carrier

    @property
    def transport_height_in_cm(self):
        """Gets the transport_height_in_cm of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The transport_height_in_cm of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._transport_height_in_cm

    @transport_height_in_cm.setter
    def transport_height_in_cm(self, transport_height_in_cm):
        """Sets the transport_height_in_cm of this SupplyLinePackingConfiguration.


        :param transport_height_in_cm: The transport_height_in_cm of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: int
        """

        self._transport_height_in_cm = transport_height_in_cm

    @property
    def load_carrier(self):
        """Gets the load_carrier of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The load_carrier of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: SupplyLoadCarrierType
        """
        return self._load_carrier

    @load_carrier.setter
    def load_carrier(self, load_carrier):
        """Sets the load_carrier of this SupplyLinePackingConfiguration.


        :param load_carrier: The load_carrier of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: SupplyLoadCarrierType
        """
        if load_carrier is None:
            raise ValueError("Invalid value for `load_carrier`, must not be `None`")  # noqa: E501

        self._load_carrier = load_carrier

    @property
    def additional_price_per_piece(self):
        """Gets the additional_price_per_piece of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The additional_price_per_piece of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: Price
        """
        return self._additional_price_per_piece

    @additional_price_per_piece.setter
    def additional_price_per_piece(self, additional_price_per_piece):
        """Sets the additional_price_per_piece of this SupplyLinePackingConfiguration.


        :param additional_price_per_piece: The additional_price_per_piece of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: Price
        """

        self._additional_price_per_piece = additional_price_per_piece

    @property
    def photo_url(self):
        """Gets the photo_url of this SupplyLinePackingConfiguration.  # noqa: E501

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :return: The photo_url of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._photo_url

    @photo_url.setter
    def photo_url(self, photo_url):
        """Sets the photo_url of this SupplyLinePackingConfiguration.

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :param photo_url: The photo_url of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: str
        """

        self._photo_url = photo_url

    @property
    def allowed_customer_organization_ids(self):
        """Gets the allowed_customer_organization_ids of this SupplyLinePackingConfiguration.  # noqa: E501


        :return: The allowed_customer_organization_ids of this SupplyLinePackingConfiguration.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_customer_organization_ids

    @allowed_customer_organization_ids.setter
    def allowed_customer_organization_ids(self, allowed_customer_organization_ids):
        """Sets the allowed_customer_organization_ids of this SupplyLinePackingConfiguration.


        :param allowed_customer_organization_ids: The allowed_customer_organization_ids of this SupplyLinePackingConfiguration.  # noqa: E501
        :type: list[str]
        """

        self._allowed_customer_organization_ids = allowed_customer_organization_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SupplyLinePackingConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SupplyLinePackingConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
