# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TimeFrame(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'latest_order_time': 'str',
        'delivery_days_offset': 'int',
        'latest_delivery_time': 'str',
        'additional_delivery_cost': 'DeliveryCost'
    }

    attribute_map = {
        'latest_order_time': 'latestOrderTime',
        'delivery_days_offset': 'deliveryDaysOffset',
        'latest_delivery_time': 'latestDeliveryTime',
        'additional_delivery_cost': 'additionalDeliveryCost'
    }

    def __init__(self, latest_order_time=None, delivery_days_offset=None, latest_delivery_time=None, additional_delivery_cost=None):  # noqa: E501
        """TimeFrame - a model defined in Swagger"""  # noqa: E501
        self._latest_order_time = None
        self._delivery_days_offset = None
        self._latest_delivery_time = None
        self._additional_delivery_cost = None
        self.discriminator = None
        self.latest_order_time = latest_order_time
        if delivery_days_offset is not None:
            self.delivery_days_offset = delivery_days_offset
        self.latest_delivery_time = latest_delivery_time
        if additional_delivery_cost is not None:
            self.additional_delivery_cost = additional_delivery_cost

    @property
    def latest_order_time(self):
        """Gets the latest_order_time of this TimeFrame.  # noqa: E501


        :return: The latest_order_time of this TimeFrame.  # noqa: E501
        :rtype: str
        """
        return self._latest_order_time

    @latest_order_time.setter
    def latest_order_time(self, latest_order_time):
        """Sets the latest_order_time of this TimeFrame.


        :param latest_order_time: The latest_order_time of this TimeFrame.  # noqa: E501
        :type: str
        """
        if latest_order_time is None:
            raise ValueError("Invalid value for `latest_order_time`, must not be `None`")  # noqa: E501

        self._latest_order_time = latest_order_time

    @property
    def delivery_days_offset(self):
        """Gets the delivery_days_offset of this TimeFrame.  # noqa: E501


        :return: The delivery_days_offset of this TimeFrame.  # noqa: E501
        :rtype: int
        """
        return self._delivery_days_offset

    @delivery_days_offset.setter
    def delivery_days_offset(self, delivery_days_offset):
        """Sets the delivery_days_offset of this TimeFrame.


        :param delivery_days_offset: The delivery_days_offset of this TimeFrame.  # noqa: E501
        :type: int
        """

        self._delivery_days_offset = delivery_days_offset

    @property
    def latest_delivery_time(self):
        """Gets the latest_delivery_time of this TimeFrame.  # noqa: E501


        :return: The latest_delivery_time of this TimeFrame.  # noqa: E501
        :rtype: str
        """
        return self._latest_delivery_time

    @latest_delivery_time.setter
    def latest_delivery_time(self, latest_delivery_time):
        """Sets the latest_delivery_time of this TimeFrame.


        :param latest_delivery_time: The latest_delivery_time of this TimeFrame.  # noqa: E501
        :type: str
        """
        if latest_delivery_time is None:
            raise ValueError("Invalid value for `latest_delivery_time`, must not be `None`")  # noqa: E501

        self._latest_delivery_time = latest_delivery_time

    @property
    def additional_delivery_cost(self):
        """Gets the additional_delivery_cost of this TimeFrame.  # noqa: E501


        :return: The additional_delivery_cost of this TimeFrame.  # noqa: E501
        :rtype: DeliveryCost
        """
        return self._additional_delivery_cost

    @additional_delivery_cost.setter
    def additional_delivery_cost(self, additional_delivery_cost):
        """Sets the additional_delivery_cost of this TimeFrame.


        :param additional_delivery_cost: The additional_delivery_cost of this TimeFrame.  # noqa: E501
        :type: DeliveryCost
        """

        self._additional_delivery_cost = additional_delivery_cost

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TimeFrame, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TimeFrame):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
