# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TradeItemUpdate(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'article_gtin': 'str',
        'vbn_product_code': 'int',
        'trade_item_name': 'TradeItemName',
        'characteristics': 'list[Characteristic]',
        'customer_organization_ids': 'list[str]',
        'seasonal_periods': 'list[SeasonalPeriod]',
        'photos': 'list[Photo]',
        'packing_configurations': 'list[PackingConfiguration]',
        'botanical_names': 'list[str]',
        'country_of_origin_iso_codes': 'list[str]',
        'is_hidden_in_catalog': 'bool',
        'trade_item_components': 'list[TradeItemComponent]'
    }

    attribute_map = {
        'article_gtin': 'articleGtin',
        'vbn_product_code': 'vbnProductCode',
        'trade_item_name': 'tradeItemName',
        'characteristics': 'characteristics',
        'customer_organization_ids': 'customerOrganizationIds',
        'seasonal_periods': 'seasonalPeriods',
        'photos': 'photos',
        'packing_configurations': 'packingConfigurations',
        'botanical_names': 'botanicalNames',
        'country_of_origin_iso_codes': 'countryOfOriginIsoCodes',
        'is_hidden_in_catalog': 'isHiddenInCatalog',
        'trade_item_components': 'tradeItemComponents'
    }

    def __init__(self, article_gtin=None, vbn_product_code=None, trade_item_name=None, characteristics=None, customer_organization_ids=None, seasonal_periods=None, photos=None, packing_configurations=None, botanical_names=None, country_of_origin_iso_codes=None, is_hidden_in_catalog=None, trade_item_components=None):  # noqa: E501
        """TradeItemUpdate - a model defined in Swagger"""  # noqa: E501
        self._article_gtin = None
        self._vbn_product_code = None
        self._trade_item_name = None
        self._characteristics = None
        self._customer_organization_ids = None
        self._seasonal_periods = None
        self._photos = None
        self._packing_configurations = None
        self._botanical_names = None
        self._country_of_origin_iso_codes = None
        self._is_hidden_in_catalog = None
        self._trade_item_components = None
        self.discriminator = None
        if article_gtin is not None:
            self.article_gtin = article_gtin
        if vbn_product_code is not None:
            self.vbn_product_code = vbn_product_code
        self.trade_item_name = trade_item_name
        self.characteristics = characteristics
        if customer_organization_ids is not None:
            self.customer_organization_ids = customer_organization_ids
        if seasonal_periods is not None:
            self.seasonal_periods = seasonal_periods
        self.photos = photos
        self.packing_configurations = packing_configurations
        if botanical_names is not None:
            self.botanical_names = botanical_names
        if country_of_origin_iso_codes is not None:
            self.country_of_origin_iso_codes = country_of_origin_iso_codes
        self.is_hidden_in_catalog = is_hidden_in_catalog
        if trade_item_components is not None:
            self.trade_item_components = trade_item_components

    @property
    def article_gtin(self):
        """Gets the article_gtin of this TradeItemUpdate.  # noqa: E501


        :return: The article_gtin of this TradeItemUpdate.  # noqa: E501
        :rtype: str
        """
        return self._article_gtin

    @article_gtin.setter
    def article_gtin(self, article_gtin):
        """Sets the article_gtin of this TradeItemUpdate.


        :param article_gtin: The article_gtin of this TradeItemUpdate.  # noqa: E501
        :type: str
        """

        self._article_gtin = article_gtin

    @property
    def vbn_product_code(self):
        """Gets the vbn_product_code of this TradeItemUpdate.  # noqa: E501


        :return: The vbn_product_code of this TradeItemUpdate.  # noqa: E501
        :rtype: int
        """
        return self._vbn_product_code

    @vbn_product_code.setter
    def vbn_product_code(self, vbn_product_code):
        """Sets the vbn_product_code of this TradeItemUpdate.


        :param vbn_product_code: The vbn_product_code of this TradeItemUpdate.  # noqa: E501
        :type: int
        """

        self._vbn_product_code = vbn_product_code

    @property
    def trade_item_name(self):
        """Gets the trade_item_name of this TradeItemUpdate.  # noqa: E501


        :return: The trade_item_name of this TradeItemUpdate.  # noqa: E501
        :rtype: TradeItemName
        """
        return self._trade_item_name

    @trade_item_name.setter
    def trade_item_name(self, trade_item_name):
        """Sets the trade_item_name of this TradeItemUpdate.


        :param trade_item_name: The trade_item_name of this TradeItemUpdate.  # noqa: E501
        :type: TradeItemName
        """
        if trade_item_name is None:
            raise ValueError("Invalid value for `trade_item_name`, must not be `None`")  # noqa: E501

        self._trade_item_name = trade_item_name

    @property
    def characteristics(self):
        """Gets the characteristics of this TradeItemUpdate.  # noqa: E501


        :return: The characteristics of this TradeItemUpdate.  # noqa: E501
        :rtype: list[Characteristic]
        """
        return self._characteristics

    @characteristics.setter
    def characteristics(self, characteristics):
        """Sets the characteristics of this TradeItemUpdate.


        :param characteristics: The characteristics of this TradeItemUpdate.  # noqa: E501
        :type: list[Characteristic]
        """
        if characteristics is None:
            raise ValueError("Invalid value for `characteristics`, must not be `None`")  # noqa: E501

        self._characteristics = characteristics

    @property
    def customer_organization_ids(self):
        """Gets the customer_organization_ids of this TradeItemUpdate.  # noqa: E501


        :return: The customer_organization_ids of this TradeItemUpdate.  # noqa: E501
        :rtype: list[str]
        """
        return self._customer_organization_ids

    @customer_organization_ids.setter
    def customer_organization_ids(self, customer_organization_ids):
        """Sets the customer_organization_ids of this TradeItemUpdate.


        :param customer_organization_ids: The customer_organization_ids of this TradeItemUpdate.  # noqa: E501
        :type: list[str]
        """

        self._customer_organization_ids = customer_organization_ids

    @property
    def seasonal_periods(self):
        """Gets the seasonal_periods of this TradeItemUpdate.  # noqa: E501


        :return: The seasonal_periods of this TradeItemUpdate.  # noqa: E501
        :rtype: list[SeasonalPeriod]
        """
        return self._seasonal_periods

    @seasonal_periods.setter
    def seasonal_periods(self, seasonal_periods):
        """Sets the seasonal_periods of this TradeItemUpdate.


        :param seasonal_periods: The seasonal_periods of this TradeItemUpdate.  # noqa: E501
        :type: list[SeasonalPeriod]
        """

        self._seasonal_periods = seasonal_periods

    @property
    def photos(self):
        """Gets the photos of this TradeItemUpdate.  # noqa: E501


        :return: The photos of this TradeItemUpdate.  # noqa: E501
        :rtype: list[Photo]
        """
        return self._photos

    @photos.setter
    def photos(self, photos):
        """Sets the photos of this TradeItemUpdate.


        :param photos: The photos of this TradeItemUpdate.  # noqa: E501
        :type: list[Photo]
        """
        if photos is None:
            raise ValueError("Invalid value for `photos`, must not be `None`")  # noqa: E501

        self._photos = photos

    @property
    def packing_configurations(self):
        """Gets the packing_configurations of this TradeItemUpdate.  # noqa: E501


        :return: The packing_configurations of this TradeItemUpdate.  # noqa: E501
        :rtype: list[PackingConfiguration]
        """
        return self._packing_configurations

    @packing_configurations.setter
    def packing_configurations(self, packing_configurations):
        """Sets the packing_configurations of this TradeItemUpdate.


        :param packing_configurations: The packing_configurations of this TradeItemUpdate.  # noqa: E501
        :type: list[PackingConfiguration]
        """
        if packing_configurations is None:
            raise ValueError("Invalid value for `packing_configurations`, must not be `None`")  # noqa: E501

        self._packing_configurations = packing_configurations

    @property
    def botanical_names(self):
        """Gets the botanical_names of this TradeItemUpdate.  # noqa: E501


        :return: The botanical_names of this TradeItemUpdate.  # noqa: E501
        :rtype: list[str]
        """
        return self._botanical_names

    @botanical_names.setter
    def botanical_names(self, botanical_names):
        """Sets the botanical_names of this TradeItemUpdate.


        :param botanical_names: The botanical_names of this TradeItemUpdate.  # noqa: E501
        :type: list[str]
        """

        self._botanical_names = botanical_names

    @property
    def country_of_origin_iso_codes(self):
        """Gets the country_of_origin_iso_codes of this TradeItemUpdate.  # noqa: E501


        :return: The country_of_origin_iso_codes of this TradeItemUpdate.  # noqa: E501
        :rtype: list[str]
        """
        return self._country_of_origin_iso_codes

    @country_of_origin_iso_codes.setter
    def country_of_origin_iso_codes(self, country_of_origin_iso_codes):
        """Sets the country_of_origin_iso_codes of this TradeItemUpdate.


        :param country_of_origin_iso_codes: The country_of_origin_iso_codes of this TradeItemUpdate.  # noqa: E501
        :type: list[str]
        """

        self._country_of_origin_iso_codes = country_of_origin_iso_codes

    @property
    def is_hidden_in_catalog(self):
        """Gets the is_hidden_in_catalog of this TradeItemUpdate.  # noqa: E501


        :return: The is_hidden_in_catalog of this TradeItemUpdate.  # noqa: E501
        :rtype: bool
        """
        return self._is_hidden_in_catalog

    @is_hidden_in_catalog.setter
    def is_hidden_in_catalog(self, is_hidden_in_catalog):
        """Sets the is_hidden_in_catalog of this TradeItemUpdate.


        :param is_hidden_in_catalog: The is_hidden_in_catalog of this TradeItemUpdate.  # noqa: E501
        :type: bool
        """
        if is_hidden_in_catalog is None:
            raise ValueError("Invalid value for `is_hidden_in_catalog`, must not be `None`")  # noqa: E501

        self._is_hidden_in_catalog = is_hidden_in_catalog

    @property
    def trade_item_components(self):
        """Gets the trade_item_components of this TradeItemUpdate.  # noqa: E501


        :return: The trade_item_components of this TradeItemUpdate.  # noqa: E501
        :rtype: list[TradeItemComponent]
        """
        return self._trade_item_components

    @trade_item_components.setter
    def trade_item_components(self, trade_item_components):
        """Sets the trade_item_components of this TradeItemUpdate.


        :param trade_item_components: The trade_item_components of this TradeItemUpdate.  # noqa: E501
        :type: list[TradeItemComponent]
        """

        self._trade_item_components = trade_item_components

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TradeItemUpdate, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TradeItemUpdate):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
