# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TradeItemVariant(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'trade_item_id': 'str',
        'characteristics': 'list[Characteristic]',
        'country_of_origin_iso_codes': 'list[str]',
        'parent_id': 'str'
    }

    attribute_map = {
        'trade_item_id': 'tradeItemId',
        'characteristics': 'characteristics',
        'country_of_origin_iso_codes': 'countryOfOriginIsoCodes',
        'parent_id': 'parentId'
    }

    def __init__(self, trade_item_id=None, characteristics=None, country_of_origin_iso_codes=None, parent_id=None):  # noqa: E501
        """TradeItemVariant - a model defined in Swagger"""  # noqa: E501
        self._trade_item_id = None
        self._characteristics = None
        self._country_of_origin_iso_codes = None
        self._parent_id = None
        self.discriminator = None
        self.trade_item_id = trade_item_id
        self.characteristics = characteristics
        if country_of_origin_iso_codes is not None:
            self.country_of_origin_iso_codes = country_of_origin_iso_codes
        self.parent_id = parent_id

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this TradeItemVariant.  # noqa: E501


        :return: The trade_item_id of this TradeItemVariant.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this TradeItemVariant.


        :param trade_item_id: The trade_item_id of this TradeItemVariant.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def characteristics(self):
        """Gets the characteristics of this TradeItemVariant.  # noqa: E501


        :return: The characteristics of this TradeItemVariant.  # noqa: E501
        :rtype: list[Characteristic]
        """
        return self._characteristics

    @characteristics.setter
    def characteristics(self, characteristics):
        """Sets the characteristics of this TradeItemVariant.


        :param characteristics: The characteristics of this TradeItemVariant.  # noqa: E501
        :type: list[Characteristic]
        """
        if characteristics is None:
            raise ValueError("Invalid value for `characteristics`, must not be `None`")  # noqa: E501

        self._characteristics = characteristics

    @property
    def country_of_origin_iso_codes(self):
        """Gets the country_of_origin_iso_codes of this TradeItemVariant.  # noqa: E501


        :return: The country_of_origin_iso_codes of this TradeItemVariant.  # noqa: E501
        :rtype: list[str]
        """
        return self._country_of_origin_iso_codes

    @country_of_origin_iso_codes.setter
    def country_of_origin_iso_codes(self, country_of_origin_iso_codes):
        """Sets the country_of_origin_iso_codes of this TradeItemVariant.


        :param country_of_origin_iso_codes: The country_of_origin_iso_codes of this TradeItemVariant.  # noqa: E501
        :type: list[str]
        """

        self._country_of_origin_iso_codes = country_of_origin_iso_codes

    @property
    def parent_id(self):
        """Gets the parent_id of this TradeItemVariant.  # noqa: E501


        :return: The parent_id of this TradeItemVariant.  # noqa: E501
        :rtype: str
        """
        return self._parent_id

    @parent_id.setter
    def parent_id(self, parent_id):
        """Sets the parent_id of this TradeItemVariant.


        :param parent_id: The parent_id of this TradeItemVariant.  # noqa: E501
        :type: str
        """
        if parent_id is None:
            raise ValueError("Invalid value for `parent_id`, must not be `None`")  # noqa: E501

        self._parent_id = parent_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TradeItemVariant, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TradeItemVariant):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
