# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TransformBatchRequestPackingConfiguration(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'pieces_per_package': 'int',
        'layers_per_load_carrier': 'int',
        'packages_per_layer': 'int',
        'package': 'Package',
        'load_carrier_type': 'LoadCarrierType',
        'package_length': 'int',
        'package_width': 'int',
        'photo_url': 'str',
        'transport_height_in_cm': 'int'
    }

    attribute_map = {
        'pieces_per_package': 'piecesPerPackage',
        'layers_per_load_carrier': 'layersPerLoadCarrier',
        'packages_per_layer': 'packagesPerLayer',
        'package': 'package',
        'load_carrier_type': 'loadCarrierType',
        'package_length': 'packageLength',
        'package_width': 'packageWidth',
        'photo_url': 'photoUrl',
        'transport_height_in_cm': 'transportHeightInCm'
    }

    def __init__(self, pieces_per_package=None, layers_per_load_carrier=None, packages_per_layer=None, package=None, load_carrier_type=None, package_length=None, package_width=None, photo_url=None, transport_height_in_cm=None):  # noqa: E501
        """TransformBatchRequestPackingConfiguration - a model defined in Swagger"""  # noqa: E501
        self._pieces_per_package = None
        self._layers_per_load_carrier = None
        self._packages_per_layer = None
        self._package = None
        self._load_carrier_type = None
        self._package_length = None
        self._package_width = None
        self._photo_url = None
        self._transport_height_in_cm = None
        self.discriminator = None
        self.pieces_per_package = pieces_per_package
        self.layers_per_load_carrier = layers_per_load_carrier
        self.packages_per_layer = packages_per_layer
        self.package = package
        self.load_carrier_type = load_carrier_type
        if package_length is not None:
            self.package_length = package_length
        if package_width is not None:
            self.package_width = package_width
        if photo_url is not None:
            self.photo_url = photo_url
        if transport_height_in_cm is not None:
            self.transport_height_in_cm = transport_height_in_cm

    @property
    def pieces_per_package(self):
        """Gets the pieces_per_package of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The pieces_per_package of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._pieces_per_package

    @pieces_per_package.setter
    def pieces_per_package(self, pieces_per_package):
        """Sets the pieces_per_package of this TransformBatchRequestPackingConfiguration.


        :param pieces_per_package: The pieces_per_package of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: int
        """
        if pieces_per_package is None:
            raise ValueError("Invalid value for `pieces_per_package`, must not be `None`")  # noqa: E501

        self._pieces_per_package = pieces_per_package

    @property
    def layers_per_load_carrier(self):
        """Gets the layers_per_load_carrier of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The layers_per_load_carrier of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._layers_per_load_carrier

    @layers_per_load_carrier.setter
    def layers_per_load_carrier(self, layers_per_load_carrier):
        """Sets the layers_per_load_carrier of this TransformBatchRequestPackingConfiguration.


        :param layers_per_load_carrier: The layers_per_load_carrier of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: int
        """
        if layers_per_load_carrier is None:
            raise ValueError("Invalid value for `layers_per_load_carrier`, must not be `None`")  # noqa: E501

        self._layers_per_load_carrier = layers_per_load_carrier

    @property
    def packages_per_layer(self):
        """Gets the packages_per_layer of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The packages_per_layer of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._packages_per_layer

    @packages_per_layer.setter
    def packages_per_layer(self, packages_per_layer):
        """Sets the packages_per_layer of this TransformBatchRequestPackingConfiguration.


        :param packages_per_layer: The packages_per_layer of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: int
        """
        if packages_per_layer is None:
            raise ValueError("Invalid value for `packages_per_layer`, must not be `None`")  # noqa: E501

        self._packages_per_layer = packages_per_layer

    @property
    def package(self):
        """Gets the package of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The package of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: Package
        """
        return self._package

    @package.setter
    def package(self, package):
        """Sets the package of this TransformBatchRequestPackingConfiguration.


        :param package: The package of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: Package
        """
        if package is None:
            raise ValueError("Invalid value for `package`, must not be `None`")  # noqa: E501

        self._package = package

    @property
    def load_carrier_type(self):
        """Gets the load_carrier_type of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The load_carrier_type of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: LoadCarrierType
        """
        return self._load_carrier_type

    @load_carrier_type.setter
    def load_carrier_type(self, load_carrier_type):
        """Sets the load_carrier_type of this TransformBatchRequestPackingConfiguration.


        :param load_carrier_type: The load_carrier_type of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: LoadCarrierType
        """
        if load_carrier_type is None:
            raise ValueError("Invalid value for `load_carrier_type`, must not be `None`")  # noqa: E501

        self._load_carrier_type = load_carrier_type

    @property
    def package_length(self):
        """Gets the package_length of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The package_length of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._package_length

    @package_length.setter
    def package_length(self, package_length):
        """Sets the package_length of this TransformBatchRequestPackingConfiguration.


        :param package_length: The package_length of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: int
        """

        self._package_length = package_length

    @property
    def package_width(self):
        """Gets the package_width of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The package_width of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._package_width

    @package_width.setter
    def package_width(self, package_width):
        """Sets the package_width of this TransformBatchRequestPackingConfiguration.


        :param package_width: The package_width of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: int
        """

        self._package_width = package_width

    @property
    def photo_url(self):
        """Gets the photo_url of this TransformBatchRequestPackingConfiguration.  # noqa: E501

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :return: The photo_url of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: str
        """
        return self._photo_url

    @photo_url.setter
    def photo_url(self, photo_url):
        """Sets the photo_url of this TransformBatchRequestPackingConfiguration.

        Image URLs posted as Floriday media must conform with the following format https://image.floriday.io/.  # noqa: E501

        :param photo_url: The photo_url of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: str
        """

        self._photo_url = photo_url

    @property
    def transport_height_in_cm(self):
        """Gets the transport_height_in_cm of this TransformBatchRequestPackingConfiguration.  # noqa: E501


        :return: The transport_height_in_cm of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._transport_height_in_cm

    @transport_height_in_cm.setter
    def transport_height_in_cm(self, transport_height_in_cm):
        """Sets the transport_height_in_cm of this TransformBatchRequestPackingConfiguration.


        :param transport_height_in_cm: The transport_height_in_cm of this TransformBatchRequestPackingConfiguration.  # noqa: E501
        :type: int
        """

        self._transport_height_in_cm = transport_height_in_cm

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TransformBatchRequestPackingConfiguration, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TransformBatchRequestPackingConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
