# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Warehouse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'warehouse_id': 'str',
        'organization_id': 'str',
        'name': 'str',
        'services': 'list[WareHouseServiceType]',
        'location': 'Location',
        'sequence_number': 'int',
        'creation_date_time': 'datetime',
        'last_modified_date_time': 'datetime',
        'is_deleted': 'bool'
    }

    attribute_map = {
        'warehouse_id': 'warehouseId',
        'organization_id': 'organizationId',
        'name': 'name',
        'services': 'services',
        'location': 'location',
        'sequence_number': 'sequenceNumber',
        'creation_date_time': 'creationDateTime',
        'last_modified_date_time': 'lastModifiedDateTime',
        'is_deleted': 'isDeleted'
    }

    def __init__(self, warehouse_id=None, organization_id=None, name=None, services=None, location=None, sequence_number=None, creation_date_time=None, last_modified_date_time=None, is_deleted=None):  # noqa: E501
        """Warehouse - a model defined in Swagger"""  # noqa: E501
        self._warehouse_id = None
        self._organization_id = None
        self._name = None
        self._services = None
        self._location = None
        self._sequence_number = None
        self._creation_date_time = None
        self._last_modified_date_time = None
        self._is_deleted = None
        self.discriminator = None
        self.warehouse_id = warehouse_id
        self.organization_id = organization_id
        self.name = name
        if services is not None:
            self.services = services
        self.location = location
        self.sequence_number = sequence_number
        if creation_date_time is not None:
            self.creation_date_time = creation_date_time
        if last_modified_date_time is not None:
            self.last_modified_date_time = last_modified_date_time
        if is_deleted is not None:
            self.is_deleted = is_deleted

    @property
    def warehouse_id(self):
        """Gets the warehouse_id of this Warehouse.  # noqa: E501


        :return: The warehouse_id of this Warehouse.  # noqa: E501
        :rtype: str
        """
        return self._warehouse_id

    @warehouse_id.setter
    def warehouse_id(self, warehouse_id):
        """Sets the warehouse_id of this Warehouse.


        :param warehouse_id: The warehouse_id of this Warehouse.  # noqa: E501
        :type: str
        """
        if warehouse_id is None:
            raise ValueError("Invalid value for `warehouse_id`, must not be `None`")  # noqa: E501

        self._warehouse_id = warehouse_id

    @property
    def organization_id(self):
        """Gets the organization_id of this Warehouse.  # noqa: E501


        :return: The organization_id of this Warehouse.  # noqa: E501
        :rtype: str
        """
        return self._organization_id

    @organization_id.setter
    def organization_id(self, organization_id):
        """Sets the organization_id of this Warehouse.


        :param organization_id: The organization_id of this Warehouse.  # noqa: E501
        :type: str
        """
        if organization_id is None:
            raise ValueError("Invalid value for `organization_id`, must not be `None`")  # noqa: E501

        self._organization_id = organization_id

    @property
    def name(self):
        """Gets the name of this Warehouse.  # noqa: E501


        :return: The name of this Warehouse.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Warehouse.


        :param name: The name of this Warehouse.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def services(self):
        """Gets the services of this Warehouse.  # noqa: E501


        :return: The services of this Warehouse.  # noqa: E501
        :rtype: list[WareHouseServiceType]
        """
        return self._services

    @services.setter
    def services(self, services):
        """Sets the services of this Warehouse.


        :param services: The services of this Warehouse.  # noqa: E501
        :type: list[WareHouseServiceType]
        """

        self._services = services

    @property
    def location(self):
        """Gets the location of this Warehouse.  # noqa: E501


        :return: The location of this Warehouse.  # noqa: E501
        :rtype: Location
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this Warehouse.


        :param location: The location of this Warehouse.  # noqa: E501
        :type: Location
        """
        if location is None:
            raise ValueError("Invalid value for `location`, must not be `None`")  # noqa: E501

        self._location = location

    @property
    def sequence_number(self):
        """Gets the sequence_number of this Warehouse.  # noqa: E501


        :return: The sequence_number of this Warehouse.  # noqa: E501
        :rtype: int
        """
        return self._sequence_number

    @sequence_number.setter
    def sequence_number(self, sequence_number):
        """Sets the sequence_number of this Warehouse.


        :param sequence_number: The sequence_number of this Warehouse.  # noqa: E501
        :type: int
        """
        if sequence_number is None:
            raise ValueError("Invalid value for `sequence_number`, must not be `None`")  # noqa: E501

        self._sequence_number = sequence_number

    @property
    def creation_date_time(self):
        """Gets the creation_date_time of this Warehouse.  # noqa: E501


        :return: The creation_date_time of this Warehouse.  # noqa: E501
        :rtype: datetime
        """
        return self._creation_date_time

    @creation_date_time.setter
    def creation_date_time(self, creation_date_time):
        """Sets the creation_date_time of this Warehouse.


        :param creation_date_time: The creation_date_time of this Warehouse.  # noqa: E501
        :type: datetime
        """

        self._creation_date_time = creation_date_time

    @property
    def last_modified_date_time(self):
        """Gets the last_modified_date_time of this Warehouse.  # noqa: E501


        :return: The last_modified_date_time of this Warehouse.  # noqa: E501
        :rtype: datetime
        """
        return self._last_modified_date_time

    @last_modified_date_time.setter
    def last_modified_date_time(self, last_modified_date_time):
        """Sets the last_modified_date_time of this Warehouse.


        :param last_modified_date_time: The last_modified_date_time of this Warehouse.  # noqa: E501
        :type: datetime
        """

        self._last_modified_date_time = last_modified_date_time

    @property
    def is_deleted(self):
        """Gets the is_deleted of this Warehouse.  # noqa: E501


        :return: The is_deleted of this Warehouse.  # noqa: E501
        :rtype: bool
        """
        return self._is_deleted

    @is_deleted.setter
    def is_deleted(self, is_deleted):
        """Sets the is_deleted of this Warehouse.


        :param is_deleted: The is_deleted of this Warehouse.  # noqa: E501
        :type: bool
        """

        self._is_deleted = is_deleted

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Warehouse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Warehouse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
