# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class WeeklyBaseSupplyPriceGroupPrice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'price_group_id': 'str',
        'price_perpiece': 'float',
        'price_group_type': 'PriceGroupType',
        'price_per_piece_last_modified': 'datetime'
    }

    attribute_map = {
        'price_group_id': 'priceGroupId',
        'price_perpiece': 'pricePerpiece',
        'price_group_type': 'priceGroupType',
        'price_per_piece_last_modified': 'pricePerPieceLastModified'
    }

    def __init__(self, price_group_id=None, price_perpiece=None, price_group_type=None, price_per_piece_last_modified=None):  # noqa: E501
        """WeeklyBaseSupplyPriceGroupPrice - a model defined in Swagger"""  # noqa: E501
        self._price_group_id = None
        self._price_perpiece = None
        self._price_group_type = None
        self._price_per_piece_last_modified = None
        self.discriminator = None
        self.price_group_id = price_group_id
        self.price_perpiece = price_perpiece
        self.price_group_type = price_group_type
        if price_per_piece_last_modified is not None:
            self.price_per_piece_last_modified = price_per_piece_last_modified

    @property
    def price_group_id(self):
        """Gets the price_group_id of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501


        :return: The price_group_id of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :rtype: str
        """
        return self._price_group_id

    @price_group_id.setter
    def price_group_id(self, price_group_id):
        """Sets the price_group_id of this WeeklyBaseSupplyPriceGroupPrice.


        :param price_group_id: The price_group_id of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :type: str
        """
        if price_group_id is None:
            raise ValueError("Invalid value for `price_group_id`, must not be `None`")  # noqa: E501

        self._price_group_id = price_group_id

    @property
    def price_perpiece(self):
        """Gets the price_perpiece of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501


        :return: The price_perpiece of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :rtype: float
        """
        return self._price_perpiece

    @price_perpiece.setter
    def price_perpiece(self, price_perpiece):
        """Sets the price_perpiece of this WeeklyBaseSupplyPriceGroupPrice.


        :param price_perpiece: The price_perpiece of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :type: float
        """
        if price_perpiece is None:
            raise ValueError("Invalid value for `price_perpiece`, must not be `None`")  # noqa: E501

        self._price_perpiece = price_perpiece

    @property
    def price_group_type(self):
        """Gets the price_group_type of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501


        :return: The price_group_type of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :rtype: PriceGroupType
        """
        return self._price_group_type

    @price_group_type.setter
    def price_group_type(self, price_group_type):
        """Sets the price_group_type of this WeeklyBaseSupplyPriceGroupPrice.


        :param price_group_type: The price_group_type of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :type: PriceGroupType
        """
        if price_group_type is None:
            raise ValueError("Invalid value for `price_group_type`, must not be `None`")  # noqa: E501

        self._price_group_type = price_group_type

    @property
    def price_per_piece_last_modified(self):
        """Gets the price_per_piece_last_modified of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501

        This field is set when the price has been changed by the supplier. Catalog prices in a closed week can only be changed once per 24 hours.  # noqa: E501

        :return: The price_per_piece_last_modified of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :rtype: datetime
        """
        return self._price_per_piece_last_modified

    @price_per_piece_last_modified.setter
    def price_per_piece_last_modified(self, price_per_piece_last_modified):
        """Sets the price_per_piece_last_modified of this WeeklyBaseSupplyPriceGroupPrice.

        This field is set when the price has been changed by the supplier. Catalog prices in a closed week can only be changed once per 24 hours.  # noqa: E501

        :param price_per_piece_last_modified: The price_per_piece_last_modified of this WeeklyBaseSupplyPriceGroupPrice.  # noqa: E501
        :type: datetime
        """

        self._price_per_piece_last_modified = price_per_piece_last_modified

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WeeklyBaseSupplyPriceGroupPrice, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WeeklyBaseSupplyPriceGroupPrice):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
