# coding: utf-8

"""
    Main - Floriday Suppliers API

    ﻿Every endpoint requires at least the `role:app` scope and the header `X-Api-Key` populated with your given API-key. Most endpoints also require an additional scope which is listed in their descriptions.  - 🗝 [Authorization server (staging)](https://idm.staging.floriday.io/oauth2/ausmw6b47z1BnlHkw0h7/.well-known/oauth-authorization-server) - 🗝 [Authorization server (live)](https://idm.floriday.io/oauth2/aus3testdcf2vyfs70i7/.well-known/oauth-authorization-server) - 📚 [Documentation](https://developer.floriday.io/docs/welcome) - ▶ [Coding screencast: getting started (NL)](https://www.youtube.com/watch?v=fdqzP7_Y_s8)  ---  _The current state of this version 2024v1 is **Main**._ * This version will be deprecated after October 2024. * This version will be removed after April 2025.  ---  🔗 2023v2: [Customers API](https://api.staging.floriday.io/customers-api-2023v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2023v2/swagger/index.html) 🔗 2024v1: [Customers API](https://api.staging.floriday.io/customers-api-2024v1/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v1/swagger/index.html) 🔗 2024v2: [Customers API](https://api.staging.floriday.io/customers-api-2024v2/swagger/index.html) | [Suppliers API](https://api.staging.floriday.io/suppliers-api-2024v2/swagger/index.html)   # noqa: E501

    OpenAPI spec version: 2024v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class WeeklySupplyLine(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'supply_line_id': 'str',
        'trade_item_id': 'str',
        'price_per_piece': 'Price',
        'number_of_pieces': 'int',
        'trade_period': 'WeeklyTradePeriod',
        'allowed_customer_organization_ids': 'list[str]',
        'included_services': 'list[CommercialService]',
        'sales_unit': 'SalesUnit',
        'is_promo': 'bool'
    }

    attribute_map = {
        'supply_line_id': 'supplyLineId',
        'trade_item_id': 'tradeItemId',
        'price_per_piece': 'pricePerPiece',
        'number_of_pieces': 'numberOfPieces',
        'trade_period': 'tradePeriod',
        'allowed_customer_organization_ids': 'allowedCustomerOrganizationIds',
        'included_services': 'includedServices',
        'sales_unit': 'salesUnit',
        'is_promo': 'isPromo'
    }

    def __init__(self, supply_line_id=None, trade_item_id=None, price_per_piece=None, number_of_pieces=None, trade_period=None, allowed_customer_organization_ids=None, included_services=None, sales_unit=None, is_promo=None):  # noqa: E501
        """WeeklySupplyLine - a model defined in Swagger"""  # noqa: E501
        self._supply_line_id = None
        self._trade_item_id = None
        self._price_per_piece = None
        self._number_of_pieces = None
        self._trade_period = None
        self._allowed_customer_organization_ids = None
        self._included_services = None
        self._sales_unit = None
        self._is_promo = None
        self.discriminator = None
        self.supply_line_id = supply_line_id
        self.trade_item_id = trade_item_id
        self.price_per_piece = price_per_piece
        self.number_of_pieces = number_of_pieces
        self.trade_period = trade_period
        self.allowed_customer_organization_ids = allowed_customer_organization_ids
        if included_services is not None:
            self.included_services = included_services
        if sales_unit is not None:
            self.sales_unit = sales_unit
        if is_promo is not None:
            self.is_promo = is_promo

    @property
    def supply_line_id(self):
        """Gets the supply_line_id of this WeeklySupplyLine.  # noqa: E501


        :return: The supply_line_id of this WeeklySupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._supply_line_id

    @supply_line_id.setter
    def supply_line_id(self, supply_line_id):
        """Sets the supply_line_id of this WeeklySupplyLine.


        :param supply_line_id: The supply_line_id of this WeeklySupplyLine.  # noqa: E501
        :type: str
        """
        if supply_line_id is None:
            raise ValueError("Invalid value for `supply_line_id`, must not be `None`")  # noqa: E501

        self._supply_line_id = supply_line_id

    @property
    def trade_item_id(self):
        """Gets the trade_item_id of this WeeklySupplyLine.  # noqa: E501


        :return: The trade_item_id of this WeeklySupplyLine.  # noqa: E501
        :rtype: str
        """
        return self._trade_item_id

    @trade_item_id.setter
    def trade_item_id(self, trade_item_id):
        """Sets the trade_item_id of this WeeklySupplyLine.


        :param trade_item_id: The trade_item_id of this WeeklySupplyLine.  # noqa: E501
        :type: str
        """
        if trade_item_id is None:
            raise ValueError("Invalid value for `trade_item_id`, must not be `None`")  # noqa: E501

        self._trade_item_id = trade_item_id

    @property
    def price_per_piece(self):
        """Gets the price_per_piece of this WeeklySupplyLine.  # noqa: E501


        :return: The price_per_piece of this WeeklySupplyLine.  # noqa: E501
        :rtype: Price
        """
        return self._price_per_piece

    @price_per_piece.setter
    def price_per_piece(self, price_per_piece):
        """Sets the price_per_piece of this WeeklySupplyLine.


        :param price_per_piece: The price_per_piece of this WeeklySupplyLine.  # noqa: E501
        :type: Price
        """
        if price_per_piece is None:
            raise ValueError("Invalid value for `price_per_piece`, must not be `None`")  # noqa: E501

        self._price_per_piece = price_per_piece

    @property
    def number_of_pieces(self):
        """Gets the number_of_pieces of this WeeklySupplyLine.  # noqa: E501


        :return: The number_of_pieces of this WeeklySupplyLine.  # noqa: E501
        :rtype: int
        """
        return self._number_of_pieces

    @number_of_pieces.setter
    def number_of_pieces(self, number_of_pieces):
        """Sets the number_of_pieces of this WeeklySupplyLine.


        :param number_of_pieces: The number_of_pieces of this WeeklySupplyLine.  # noqa: E501
        :type: int
        """
        if number_of_pieces is None:
            raise ValueError("Invalid value for `number_of_pieces`, must not be `None`")  # noqa: E501

        self._number_of_pieces = number_of_pieces

    @property
    def trade_period(self):
        """Gets the trade_period of this WeeklySupplyLine.  # noqa: E501


        :return: The trade_period of this WeeklySupplyLine.  # noqa: E501
        :rtype: WeeklyTradePeriod
        """
        return self._trade_period

    @trade_period.setter
    def trade_period(self, trade_period):
        """Sets the trade_period of this WeeklySupplyLine.


        :param trade_period: The trade_period of this WeeklySupplyLine.  # noqa: E501
        :type: WeeklyTradePeriod
        """
        if trade_period is None:
            raise ValueError("Invalid value for `trade_period`, must not be `None`")  # noqa: E501

        self._trade_period = trade_period

    @property
    def allowed_customer_organization_ids(self):
        """Gets the allowed_customer_organization_ids of this WeeklySupplyLine.  # noqa: E501


        :return: The allowed_customer_organization_ids of this WeeklySupplyLine.  # noqa: E501
        :rtype: list[str]
        """
        return self._allowed_customer_organization_ids

    @allowed_customer_organization_ids.setter
    def allowed_customer_organization_ids(self, allowed_customer_organization_ids):
        """Sets the allowed_customer_organization_ids of this WeeklySupplyLine.


        :param allowed_customer_organization_ids: The allowed_customer_organization_ids of this WeeklySupplyLine.  # noqa: E501
        :type: list[str]
        """
        if allowed_customer_organization_ids is None:
            raise ValueError("Invalid value for `allowed_customer_organization_ids`, must not be `None`")  # noqa: E501

        self._allowed_customer_organization_ids = allowed_customer_organization_ids

    @property
    def included_services(self):
        """Gets the included_services of this WeeklySupplyLine.  # noqa: E501


        :return: The included_services of this WeeklySupplyLine.  # noqa: E501
        :rtype: list[CommercialService]
        """
        return self._included_services

    @included_services.setter
    def included_services(self, included_services):
        """Sets the included_services of this WeeklySupplyLine.


        :param included_services: The included_services of this WeeklySupplyLine.  # noqa: E501
        :type: list[CommercialService]
        """

        self._included_services = included_services

    @property
    def sales_unit(self):
        """Gets the sales_unit of this WeeklySupplyLine.  # noqa: E501


        :return: The sales_unit of this WeeklySupplyLine.  # noqa: E501
        :rtype: SalesUnit
        """
        return self._sales_unit

    @sales_unit.setter
    def sales_unit(self, sales_unit):
        """Sets the sales_unit of this WeeklySupplyLine.


        :param sales_unit: The sales_unit of this WeeklySupplyLine.  # noqa: E501
        :type: SalesUnit
        """

        self._sales_unit = sales_unit

    @property
    def is_promo(self):
        """Gets the is_promo of this WeeklySupplyLine.  # noqa: E501


        :return: The is_promo of this WeeklySupplyLine.  # noqa: E501
        :rtype: bool
        """
        return self._is_promo

    @is_promo.setter
    def is_promo(self, is_promo):
        """Sets the is_promo of this WeeklySupplyLine.


        :param is_promo: The is_promo of this WeeklySupplyLine.  # noqa: E501
        :type: bool
        """

        self._is_promo = is_promo

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WeeklySupplyLine, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WeeklySupplyLine):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
